What is Alphatk?

Alphatk is a text editor.  It's most useful for programmers, those
writing a lot of TeX or LaTeX documents, and for editing of HTML source
files.  It has very rich features to aid in writing and editing files of
those document types.  The programming languages most strongly supported
are C, C++, Java, Tcl, Perl, Matlab, in addition to LaTeX and CSS/HTML.
Most other common languages (around 50!)  are also supported, although
perhaps not with quite such a rich feature set.  As well as being useful
for creating and editing such documents, Alphatk provides a host of
facilities for communicating with compilers, diff, patch, version control
systems, ftp sites, web sites, etc.

Alphatk is a little like emacs, in that it is a very powerful text editor.
However it was designed with a graphical interface in mind, which can make
it rather more mouse-friendly, and less reliant on cryptic keystrokes
(although any action can be bound to any key combination so those who don't
use a mouse much will still be happy!).  Alphatk has a very rich feature
set.

Alphatk runs on Windows, Unix and MacOS X, so you can use the same editor on
all your platforms.

Alphatk comes as a 45 day unlimited, fully-functional demo.  After that
you must purchase a license key.  You can do so at
<http://order.kagi.com/?1GU>.

New releases will be made as frequently as is necessary to keep up with
bug reports and feature requests.  Bug fixes and code contributions are
much appreciated.

Alphatk would never have existed had it not been for Pete Keleher, the
creator of 'Alpha', a MacOS only editor, and for the community of Alpha
users who have contributed vast amounts of Tcl code which help make
Alphatk the powerful editor it now is.

The web site for Alphatk is <http://www.purl.org/net/alphatk>
The ftp site for Alphatk is <ftp://ftp.ucsd.edu/pub/alpha/tcl/alphatk/>

(If you were reading this in Alphatk, you could 'alt-double-click' or use 'F6'
on these links to go to them).

Alphatk is supported on any platform on which Tk 8.4 or newer runs.  This
means it should run smoothly on any Windows, Unix or MacOS X system!
Beyond the pre-packaged executables, the alphatk.tar.gz/alphatk.zip
non-executable distributions are known to run on:

    Windows NT 4.0sp3,sp5,sp6, with any 8.4.x
    Windows 2000sp1/2 with any Tcl 8.4.x
    Windows XP with Tcl 8.4.x
    Solaris running X-windows, with Tcl/Tk 8.4
    RedHat Linux with Tcl/Tk 8.4.x
    MacOS X with Tk on Aqua 8.4.x
    MacOS X with Tcl/Tk 8.4.x and DarwinX

Tcl/Tk 8.5a3 also works very well.

Any standard Tcl extensions can be placed here.  Tcl will search all
subdirectories for packages.  If you have extensions installed in
your system-wide Tcl installation (probably a better idea), then they
will of course be seen as well.  

Tcl (and therefore AlphaTcl) will usually use the newest version of a 
package it has available.

Most binaries here are for Windows.  If someone wishes to send me binaries
for MacOS X, Linux (or other standard *nix) I'd be happy to distribute
them.

The Alpha family of editors, using AlphaTcl library version 8.1a5


                                     Readme version: 8.1a5
                                            created: 03/18/1991 {10:22:14 AM}
                                        last update: 05/17/2006 {02:16:25 PM}


	  	Table Of Contents

"# Introduction"
"# General Help files"
"# Mode specific help"
"# Package specific help"
"# Keyboard shortcuts (key bindings)"
"# Internet resources"
"# Bug reporting"
"# Registration"

<<floatNamedMarks>>

NOTE: Colored, underlined text is hyperlinked.  Most links lead to other
places in Alpha's documentation, from where you can return by selecting the
menu item "Search > Return To Bookmark".  Other links will open the relevant
Preference Pane or Tutorial.


	  	Introduction

Alpha is a powerful, multi-modal, highly configurable, and programmable text
editor.  For basic editing you can probably rely on your experience from
other text editors or word processors, but in order to take advantage of the
power-user features you will sooner or later want to dive into Alpha's vast
documentation.  This 'Readme' briefly surveys Alpha's documentation and help
system, and points to other resources.  Please see the "Release Notes" help
file for a list of the major recent changes and known limitations.

If you wish to uninstall Alpha, click here: <<uninstall>>


	  	General Help files

Most of Alpha's help files can be accessed from the Help Menu, right-most in
the menu bar.  To get an idea of some of Alpha's capabilities, peruse the
"Examples Help" file.  For general help, there is a detailed "Alpha Manual",
and a rather shorter "Quick Start" document.  The other help files are more
specialized.  Some help files are also available in html or pdf format.  Html
formatted help files can also be read with Alpha's html renderer.

Preferences: Help


	  	Mode specific help
	       
Alpha automatically enters a "mode" specific to the sort of document being
edited, and many features are mode dependent.  For example, in HTML mode there
are special menus with all sorts of fancy tools for editing html documents,
and the text is automatically colored according to the html syntax to make it
easier to read.  

Alpha determines the mode from the file name extension (e.g. .html); otherwise
you can change mode manually by selecting "Config > Mode Prefs > Change Mode".
For help on mode-specific issues, consult the mode help file --- pressing
Control-Help opens the help file for the active mode.  Selecting the menu item
"Config > Mode Prefs > Describe Mode" will provide more technical information
regarding the mode.

Many modes allow you to customize their behavior by setting "Mode Prefs",
which can be accessed through "Config > Mode Prefs > Preferences".  These
dialogs generally include a "Help" button that describes the individual
preferences.

Preferences: Mode


	  	Package specific help

Much of Alpha's functionality is implemented as 'packages', which can be
turned on and off in "Config > Global Setup > Features", where you can also
obtain short descriptions of the individual features.

Preferences: Features

See the "Installed Packages" file for a list of pre-installed packages in
Alpha, with hyperlinks to their documentation.  For other packages, check
this web page:

    <http://www.purl.org/net/alpha/wikipages/new-packages>

The "Config > Packages" menu contains items for "Describe a Package" and "Read
Help for a Package".  Selecting either of these will open a dialog allowing
you to select the package for which you want more information.


	  	Keyboard shortcuts (key bindings)

Alpha is very rich in keyboard shortcuts: some of them are displayed in the
menus, but there are many others.  It is also easy to define your own keyboard
shortcuts for any menu item, or for any action or script.  The help file
"Keyboard Shortcuts" describes Alpha's preset shortcuts, and contains more
information on how to define your own.  The preset key bindings adjust to
keyboard layout --- currently you have to tell Alpha about your keyboard
layout, in "Config > Preferences > System Preferences > International".

Preferences: International


	  	Internet resources
	      
For the most recent, up-to-date, information about Alpha, and further 
resources, see "The Alpha Wiki" at

    <http://www.purl.org/net/alpha/wiki> .

Alpha is privileged by an active and helpful user community whose main
communication channels are two mailing lists you are invited to subscribe 
to, for "users" and "developers".  Go to

    <http://www.purl.org/net/alpha/mail>

to search the archives or to sign up.

The developers' list is for discussing technical issues, while the users'
list is for all sorts of questions and hints --- it is read also by the
developers.  Questions are usually answered within a day, and often they lead
to improvements in subsequent versions of Alpha and its documentation.  You
can also use the "Help > Search E-mail Archives" menu item to see if a
particular issue has been discussed.


	  	Bug reporting 
	    
There are still a number of known bugs, and probably many which have not yet
been discovered.  Bug reports are very welcome.  PLEASE read the help file
"Known Bugs" for a list of known bugs, and for information regarding how to
make your bug report sufficiently informative to allow the developers to
identify and fix the bug.  Alpha has a sophisticated bug reporting and
tracking system at

    <http://www.purl.org/net/alpha/bugzilla/> .

It allows to keep track of all information related to a bug, workarounds,
dependence, and solutions.  The preferred method for submitting a new bug to
this system is through "Help > Report A Bug" menu item.


	  	Registration

You may freely copy and distribute Alpha, but please bear in mind that Alpha
is Shareware.  If you decide to keep it, please <<register>> your copy.

The Author(s) of this product are in no way liable for any direct or indirect
damage caused by the product.

See the file "license.terms" for information on usage and redistribution of
this software, and for a DISCLAIMER OF ALL WARRANTIES.

This document has been placed in the public domain.

$Id: README.txt,v 1.7 2004/10/18 01:52:32 jenglish Exp $

~ About:

The Tile Widget Set is an experimental reimplementation of
some of the core Tk widgets.  The primary purpose is
to generate ideas for how to build the next generation of Tk,
when the asteroid strikes and we prepare for the 9.0 release.

~ Features:

    + A revised and expanded version of the TIP #48 style engine

    + Native look and feel under Windows XP

    + Native L&F under other Windows versions

    + "Revitalized" look and feel under Unix

    + scrollbar, button, checkbutton, radiobutton, menubutton,
      label, frame, and labelframe widgets, plus a partial 
      implementation of the scale widget

    + new notebook and progressbar widgets


~ Compiling:

You have your choice of not one, not two, but three, count'em three!
separate build systems to try!  One of them is bound to work for you.

Jeff's TEA3-based build system: "./configure ; make ; make install" 
in the top-level directory.

Joe's build system: "./configure ; make ; make install"
in the "generic" subdirectory.  Also TEA-based, just done differently.  
MSVC users can also try 'makefile.vc' in that directory
(will need some hand-editing, 'make install' won't work).

Pat's build system (Windows): "cd win ; nmake -f makefile.vc",
or use the Developer Studio Project File "Tile.dsp".

You can also compile in a separate build directory with 
Joe's or Jeff's system, if that's what you're into.

*** NOTE *** 

The tile package requires access to a few Tk internal routines.
These have been added to the private stubs table for Tk 8.5,
but for 8.4 you will need to link against the Tk 8.4 shared
library directly (import library on Windows).


~ Available themes:

The tile package contains the following built-in themes:

    + "classic", the classic Motif-style appearance

    + "default", a simpler, streamlined look for X11

    + "alt", a "revitalized" look and feel similar
      to GTK+'s default theme and Windows NT appearance;

    + "winnative", which uses the native Win32 API to draw widgets

    + "xpnative", which uses the Windows XP "Visual Styles" API

    + "step", an experimental playground for testing
      out new ideas, such as NeXTStep-style scrollbars.

There are some other themes in the "demos" subdirectory:

    + "blue", another experimental playground used to test out
      the pixmap engine.

    + "kroc", a pixmap theme contributed by David Zolli.

    + "Aquativo", an adaptation of the GTK+ theme of the same name.
      (Images are not included in the tile distribution;
      see the instructions in demos/themes/Aquativo.tcl
      for how to download them from the Gnome site).
      Requires the Img package for PNG support.

    + "WinXPBlue", another imported GTK+ theme providing
       a look and feel similar to Windows XP.  (Again,
       images not include in the tile distribution.
       Also requires the Img package for PNG support.)

~ Availability

The tile widget set is currently hosted under the tktable project
at SourceForge:

    <URL: http://tktable.sourceforge.net/ >
    <URL: http://sourceforge.net/projects/tktable/ >

Sources are available under the 'tile' module in CVS.

! FORTRAN Example.f
! 
! Included in the Alpha distribution as an example of the Fort mode
! 
! source of original document:
! 
! http://www.polyhedron.co.uk/compare/

! EXAMPLE creating TEST_FPU.EXE using Compaq Visual Fortran -- CVF 6.6
! DF /c LAPACK.F
! DF TEST_FPU LAPACK.OBJ /LINK INTEL.LIB /STACK:8000000
! 128mb Memory is required to avoid paging

! --------------------------------------------------------------------
MODULE kinds
   INTEGER, PARAMETER :: RK8 = SELECTED_REAL_KIND(15, 300)
END MODULE kinds
! --------------------------------------------------------------------
PROGRAM TEST_FPU  ! A number-crunching benchmark using matrix inversion.
USE kinds         ! Implemented by:    David Frank  Dave_Frank@hotmail.com
IMPLICIT NONE     ! Gauss  routine by: Tim Prince   N8TM@aol.com
                  ! Crout  routine by: James Van Buskirk  torsop@ix.netcom.com
                  ! Lapack routine by: Jos Bergervoet bergervo@IAEhv.nl

! - - - local variables - - -
REAL(RK8) :: pool(101,101,1000), pool3(1001,1001) ! random numbers to invert
EQUIVALENCE (pool,pool3)               ! use same pool numbers for test 3,4
REAL(RK8) :: a(101,101), a3(1001,1001)     ! working matrices

REAL(RK8) :: avg_err, dt(4)
INTEGER :: i, n, t(8), clock1, clock2, rate

CHARACTER (LEN=36) :: invert_id(4) = &
                      (/ 'Test1 - Gauss 2000 (101x101) inverts', &
                         'Test2 - Crout 2000 (101x101) inverts', &
                         'Test3 - Crout  2 (1001x1001) inverts', &
                         'Test4 - Lapack 2 (1001x1001) inverts' /)
! - - - - - - - - - - - - - -

WRITE (*,*) ' Benchmark running, hopefully as only ACTIVE task'

CALL DATE_AND_TIME ( values = t )

CALL RANDOM_SEED()               ! set seed to random number based on time
CALL RANDOM_NUMBER(pool)         ! fill pool with random data ( 0. -> 1. )

! - - - begin benchmark - - -

DO n = 1,4

   CALL SYSTEM_CLOCK (clock1,rate)  ! get benchmark (n) start time

   SELECT CASE (n)
   CASE (1:2)
      DO i = 1,1000
         a = pool(:,:,i)         ! get next matrix to invert
         IF (n == 1) THEN
            CALL Gauss (a,101)  ! invert a
            CALL Gauss (a,101)  ! invert a
         ELSE
            CALL Crout (a,101)  ! invert a
            CALL Crout (a,101)  ! invert a
         END IF
      END DO
      avg_err = SUM(ABS(a-pool(:,:,1000)))/(101*101)   ! last matrix error

   CASE (3:4)
      a3 = pool3                 ! get 1001x1001 matrix
      IF (n == 3) THEN
         CALL Crout (a3,1001)     ! invert a3
         CALL Crout (a3,1001)     ! invert a3
      ELSE
         CALL Lapack (a3,1001)    ! invert a3
         CALL Lapack (a3,1001)    ! invert a3
      END IF
      avg_err = SUM(ABS(a3-pool3))/(1001*1001)    ! invert err.

   END SELECT

   CALL SYSTEM_CLOCK (clock2,rate)
   dt(n) = (clock2-clock1)/DBLE(rate)  ! get benchmark (n) elapsed sec.

   WRITE (*,92) invert_id(n), dt(n), ' sec  Err=', avg_err

END DO                         ! for test 1-4

WRITE (*,92) '                             total =',SUM(dt), ' sec'
WRITE (*,*)


91 FORMAT (A,I4,2('/',I2.2))
92 FORMAT (A,F5.1,A,F18.15)

END PROGRAM TEST_FPU

! --------------------------------------------------------------------
SUBROUTINE Gauss (a,n)       ! Invert matrix by Gauss method
! --------------------------------------------------------------------
USE kinds
IMPLICIT NONE

INTEGER :: n
REAL(RK8) :: a(n,n)

! - - - Local Variables - - -
REAL(RK8) :: b(n,n), c, d, temp(n)
INTEGER :: i, j, k, m, imax(1), ipvt(n)
! - - - - - - - - - - - - - -
b = a
ipvt = (/ (i, i = 1, n) /)
    
DO k = 1,n
   imax = MAXLOC(ABS(b(k:n,k)))
   m = k-1+imax(1)

   IF (m /= k) THEN
      ipvt( (/m,k/) ) = ipvt( (/k,m/) )
      b((/m,k/),:) = b((/k,m/),:)
   END IF
   d = 1/b(k,k)

   temp = b(:,k)
   DO j = 1, n
      c = b(k,j)*d
      b(:,j) = b(:,j)-temp*c
      b(k,j) = c
   END DO
   b(:,k) = temp*(-d)
   b(k,k) = d
END DO
a(:,ipvt) = b

END SUBROUTINE Gauss

! -------------------------------------------------------------------
SUBROUTINE Crout (a,n)      ! Invert matrix by Crout method
! -------------------------------------------------------------------
USE kinds
IMPLICIT NONE

INTEGER :: n                ! Order of the matrix
REAL(RK8) :: a(n,n)         ! Matrix to be inverted

INTEGER :: i, j, m, imax(1)      ! Current row & column, max pivot loc
INTEGER :: index(n)              ! Partial pivot record
REAL(RK8) :: b(n,n), temp(n)     ! working arrays, temp

index = (/(i,i=1,n)/)        ! initialize column index

DO j = 1, n        ! Shuffle matrix a -> b
   DO i = 1, j-1
      b(i, j) = a(i, j)
   END DO
   DO i = j, n
      b(i, j) = a(n+1-j, i+1-j)
   END DO
END DO

DO j = 1, n   ! LU decomposition; reciprocals of diagonal elements in L matrix

   DO i = j, n    ! Get current column of L matrix
      b(n-i+j,n+1-i) = b(n-i+j,n+1-i)-DOT_PRODUCT(b(n+1-i:n-i+j-1,n+1-i), b(1:j-1,j))
   END DO

   imax = MAXLOC(ABS( (/ (b(j+i-1,i),i=1,n-j+1) /) ))
   m = imax(1)
   b(j+m-1,m) = 1/b(j+m-1,m)

   IF (m /= n+1-j) THEN   ! Swap biggest element to current pivot position
      index((/j,n+1-m/))     = index((/n+1-m,j/))
      b((/j,n+1-m/),n+2-m:n) = b((/n+1-m,j/),n+2-m:n)
      temp(1:n+1-m)          = b(m:n, m)
      b(m:j-1+m, m)          = b(n+1-j:n, n+1-j)
      b(j+m:n, m)            = b(j, j+1:n+1-m)
      b(n+1-j:n, n+1-j)      = temp(1:j)
      b(j, j+1:n+1-m)        = temp(j+1:n+1-m)
   END IF

   DO i = j+1, n   ! Get current row of U matrix
      b(j,i) = b(n,n+1-j)*(b(j,i)-DOT_PRODUCT(b(n+1-j:n-1,n+1-j),b(1:j-1,i)))
   END DO
END DO

DO j = 1, n-1     ! Invert L matrix
   temp(1) = b(n, n+1-j)
   DO i = j+1, n
      b(n-i+j,n+1-i) = -DOT_PRODUCT(b(n-i+j:n-1,n+1-i),temp(1:i-j))*b(n,n+1-i)
      temp(i-j+1) = b(n-i+j,n+1-i)
   END DO
END DO

DO i = 1, (n+1)/3      ! Reshuffle matrix
   temp(1:n+2-3*i) = b(2*i:n+1-i,i)
   DO j = 2*i, n+1-i
      b(j, i) = b(n+i-j, n+1-j)
   END DO
   DO j = i, n+1-2*i
      b(i+j-1, j) = b(n+1-i, n+2-i-j)
   END DO
   b(n+1-i, i+1:n+2-2*i) = temp(1:n+2-3*i)
END DO

DO i = 1, n-1      ! Invert U matrix
   DO j = i+1, n
      b(i,j) = -b(i,j)-DOT_PRODUCT(temp(1:j-i-1), b(i+1:j-1,j))
      temp(j-i) = b(i,j)
   END DO
END DO

DO i = 1, n-1      ! Multiply inverses in reverse order
   temp(1:n-i) = b(i,i+1:n)
   DO j = 1,i
      b(i,j) = b(i,j)+DOT_PRODUCT(temp(1:n-i),b(i+1:n,j))
   END DO
   DO j = i+1, n
      b(i,j) = DOT_PRODUCT(temp(j-i:n-i),b(j:n,j))
   END DO
END DO

a(:,index) = b    ! output straightened columns of the inverse

END SUBROUTINE Crout

! --------------------------------------------------------------------
SUBROUTINE Lapack (a,n)     ! Invert matrix by Lapack method
! --------------------------------------------------------------------
USE kinds
IMPLICIT NONE

INTEGER   :: n
REAL(RK8) :: a(n,n)

INTEGER :: ipiv(n)
INTEGER :: info, lwork, ILAENV
REAL(RK8), ALLOCATABLE :: work(:)

lwork = n * ILAENV( 1, 'DGETRI', ' ', n, -1, -1, -1 )
ALLOCATE ( work(lwork) )

CALL DGETRF( n, n, a, n, ipiv, info )
CALL DGETRI( n, a, n, ipiv, work, lwork, info )

DEALLOCATE ( work )

END SUBROUTINE Lapack

!*==intfaces.f90  created by SPAG 6.55Dc at 12:01 on  5 Feb 2004
MODULE S_DGEMM
   INTERFACE
      SUBROUTINE DGEMM(Transa,Transb,M,N,K,Alpha,A,Lda,B,Ldb,Beta,C,Ldc)
      IMPLICIT NONE
!
! PARAMETER definitions
!
      DOUBLE PRECISION , PARAMETER :: ONE = 1.0D+0 , ZERO = 0.0D+0
      DOUBLE PRECISION :: Alpha , Beta
      INTEGER :: K , Lda , Ldb , Ldc , M , N
      CHARACTER(1) :: Transa , Transb
      DOUBLE PRECISION , DIMENSION(Lda,*) :: A
      DOUBLE PRECISION , DIMENSION(Ldb,*) :: B
      DOUBLE PRECISION , DIMENSION(Ldc,*) :: C
      INTENT (IN) A , Alpha , B , Beta , K , Lda , Ldb , Ldc , M , N
      INTENT (INOUT) C
      END SUBROUTINE DGEMM
   END INTERFACE
END MODULE S_DGEMM
!*==intfaces.f90  created by SPAG 6.55Dc at 12:01 on  5 Feb 2004
MODULE S_DGEMV
   INTERFACE
      SUBROUTINE DGEMV(Trans,M,N,Alpha,A,Lda,X,Incx,Beta,Y,Incy)
      IMPLICIT NONE
!
! PARAMETER definitions
!
      DOUBLE PRECISION , PARAMETER :: ONE = 1.0D+0 , ZERO = 0.0D+0
      DOUBLE PRECISION :: Alpha , Beta
      INTEGER :: Incx , Incy , Lda , M , N
      CHARACTER(1) :: Trans
      DOUBLE PRECISION , DIMENSION(Lda,*) :: A
      DOUBLE PRECISION , DIMENSION(*) :: X , Y
      INTENT (IN) A , Alpha , Beta , Incx , Incy , Lda , M , N , X
      INTENT (INOUT) Y
      END SUBROUTINE DGEMV
   END INTERFACE
END MODULE S_DGEMV
!*==intfaces.f90  created by SPAG 6.55Dc at 12:01 on  5 Feb 2004
MODULE S_DGER
   INTERFACE
      SUBROUTINE DGER(M,N,Alpha,X,Incx,Y,Incy,A,Lda)
      IMPLICIT NONE
!
! PARAMETER definitions
!
      DOUBLE PRECISION , PARAMETER :: ZERO = 0.0D+0
      DOUBLE PRECISION :: Alpha
      INTEGER :: Incx , Incy , Lda , M , N
      DOUBLE PRECISION , DIMENSION(Lda,*) :: A
      DOUBLE PRECISION , DIMENSION(*) :: X , Y
      INTENT (IN) Alpha , Incx , Incy , Lda , M , N , X , Y
      INTENT (INOUT) A
      END SUBROUTINE DGER
   END INTERFACE
END MODULE S_DGER
!*==intfaces.f90  created by SPAG 6.55Dc at 12:01 on  5 Feb 2004
MODULE S_DSCAL
   INTERFACE
      SUBROUTINE DSCAL(N,Da,Dx,Incx)
      IMPLICIT NONE
      DOUBLE PRECISION :: Da
      INTEGER :: Incx , N
      DOUBLE PRECISION , DIMENSION(*) :: Dx
      INTENT (IN) Da , Incx , N
      INTENT (INOUT) Dx
      END SUBROUTINE DSCAL
   END INTERFACE
END MODULE S_DSCAL
!*==intfaces.f90  created by SPAG 6.55Dc at 12:01 on  5 Feb 2004
MODULE S_DSWAP
   INTERFACE
      SUBROUTINE DSWAP(N,Dx,Incx,Dy,Incy)
      IMPLICIT NONE
      INTEGER :: Incx , Incy , N
      DOUBLE PRECISION , DIMENSION(*) :: Dx , Dy
      INTENT (IN) Incx , Incy , N
      INTENT (INOUT) Dx , Dy
      END SUBROUTINE DSWAP
   END INTERFACE
END MODULE S_DSWAP
!*==intfaces.f90  created by SPAG 6.55Dc at 12:01 on  5 Feb 2004
MODULE S_DTRMM
   INTERFACE
      SUBROUTINE DTRMM(Side,Uplo,Transa,Diag,M,N,Alpha,A,Lda,B,Ldb)
      IMPLICIT NONE
!
! PARAMETER definitions
!
      DOUBLE PRECISION , PARAMETER :: ONE = 1.0D+0 , ZERO = 0.0D+0
      DOUBLE PRECISION :: Alpha
      CHARACTER(1) :: Diag , Side , Transa , Uplo
      INTEGER :: Lda , Ldb , M , N
      DOUBLE PRECISION , DIMENSION(Lda,*) :: A
      DOUBLE PRECISION , DIMENSION(Ldb,*) :: B
      INTENT (IN) A , Alpha , Lda , Ldb , M , N
      INTENT (INOUT) B
      END SUBROUTINE DTRMM
   END INTERFACE
END MODULE S_DTRMM
!*==intfaces.f90  created by SPAG 6.55Dc at 12:01 on  5 Feb 2004
MODULE S_DTRMV
   INTERFACE
      SUBROUTINE DTRMV(Uplo,Trans,Diag,N,A,Lda,X,Incx)
      IMPLICIT NONE
!
! PARAMETER definitions
!
      DOUBLE PRECISION , PARAMETER :: ZERO = 0.0D+0
      CHARACTER(1) :: Diag , Trans , Uplo
      INTEGER :: Incx , Lda , N
      DOUBLE PRECISION , DIMENSION(Lda,*) :: A
      DOUBLE PRECISION , DIMENSION(*) :: X
      INTENT (IN) A , Incx , Lda , N
      INTENT (INOUT) X
      END SUBROUTINE DTRMV
   END INTERFACE
END MODULE S_DTRMV
!*==intfaces.f90  created by SPAG 6.55Dc at 12:01 on  5 Feb 2004
MODULE S_DTRSM
   INTERFACE
      SUBROUTINE DTRSM(Side,Uplo,Transa,Diag,M,N,Alpha,A,Lda,B,Ldb)
      IMPLICIT NONE
!
! PARAMETER definitions
!
      DOUBLE PRECISION , PARAMETER :: ONE = 1.0D+0 , ZERO = 0.0D+0
      DOUBLE PRECISION :: Alpha
      CHARACTER(1) :: Diag , Side , Transa , Uplo
      INTEGER :: Lda , Ldb , M , N
      DOUBLE PRECISION , DIMENSION(Lda,*) :: A
      DOUBLE PRECISION , DIMENSION(Ldb,*) :: B
      INTENT (IN) A , Alpha , Lda , Ldb , M , N
      INTENT (INOUT) B
      END SUBROUTINE DTRSM
   END INTERFACE
END MODULE S_DTRSM
!*==intfaces.f90  created by SPAG 6.55Dc at 12:01 on  5 Feb 2004
MODULE S_IDAMAX
   INTERFACE
      FUNCTION IDAMAX(N,Dx,Incx)
      IMPLICIT NONE
      INTEGER :: Incx , N
      DOUBLE PRECISION , DIMENSION(*) :: Dx
      INTEGER :: IDAMAX
      INTENT (IN) Dx , Incx , N
      END FUNCTION IDAMAX
   END INTERFACE
END MODULE S_IDAMAX
!*==intfaces.f90  created by SPAG 6.55Dc at 12:01 on  5 Feb 2004
MODULE S_XERBLA
   INTERFACE
      SUBROUTINE XERBLA(Srname,Info)
      IMPLICIT NONE
      INTEGER :: Info
      CHARACTER(6) :: Srname
      INTENT (IN) Info , Srname
      END SUBROUTINE XERBLA
   END INTERFACE
END MODULE S_XERBLA
!*==intfaces.f90  created by SPAG 6.55Dc at 12:01 on  5 Feb 2004
MODULE S_DGETF2
   INTERFACE
      SUBROUTINE DGETF2(M,N,A,Lda,Ipiv,Info)
      IMPLICIT NONE
!
! PARAMETER definitions
!
      DOUBLE PRECISION , PARAMETER :: ONE = 1.0D+0 , ZERO = 0.0D+0
      INTEGER :: Info , Lda , M , N
      DOUBLE PRECISION , DIMENSION(Lda,*) :: A
      INTEGER , DIMENSION(*) :: Ipiv
      INTENT (IN) M
      INTENT (OUT) Ipiv
      INTENT (INOUT) Info
      END SUBROUTINE DGETF2
   END INTERFACE
END MODULE S_DGETF2
!*==intfaces.f90  created by SPAG 6.55Dc at 12:01 on  5 Feb 2004
MODULE S_DGETRF
   INTERFACE
      SUBROUTINE DGETRF(M,N,A,Lda,Ipiv,Info)
      IMPLICIT NONE
!
! PARAMETER definitions
!
      DOUBLE PRECISION , PARAMETER :: ONE = 1.0D+0
      INTEGER :: Info , Lda , M , N
      DOUBLE PRECISION , DIMENSION(Lda,*) :: A
      INTEGER , DIMENSION(*) :: Ipiv
      INTENT (INOUT) Info , Ipiv
      END SUBROUTINE DGETRF
   END INTERFACE
END MODULE S_DGETRF
!*==intfaces.f90  created by SPAG 6.55Dc at 12:01 on  5 Feb 2004
MODULE S_DGETRI
   INTERFACE
      SUBROUTINE DGETRI(N,A,Lda,Ipiv,Work,Lwork,Info)
      IMPLICIT NONE
!
! PARAMETER definitions
!
      DOUBLE PRECISION , PARAMETER :: ZERO = 0.0D+0 , ONE = 1.0D+0
      INTEGER :: Info , Lda , Lwork , N
      DOUBLE PRECISION , DIMENSION(Lda,*) :: A
      INTEGER , DIMENSION(*) :: Ipiv
      DOUBLE PRECISION , DIMENSION(Lwork) :: Work
      INTENT (IN) Ipiv , Lwork
      INTENT (INOUT) A , Info
      END SUBROUTINE DGETRI
   END INTERFACE
END MODULE S_DGETRI
!*==intfaces.f90  created by SPAG 6.55Dc at 12:01 on  5 Feb 2004
MODULE S_DLASWP
   INTERFACE
      SUBROUTINE DLASWP(N,A,Lda,K1,K2,Ipiv,Incx)
      IMPLICIT NONE
      INTEGER :: Incx , K1 , K2 , Lda , N
      DOUBLE PRECISION , DIMENSION(Lda,*) :: A
      INTEGER , DIMENSION(*) :: Ipiv
      INTENT (IN) Incx , Ipiv , K1 , K2
      END SUBROUTINE DLASWP
   END INTERFACE
END MODULE S_DLASWP
!*==intfaces.f90  created by SPAG 6.55Dc at 12:01 on  5 Feb 2004
MODULE S_DTRTI2
   INTERFACE
      SUBROUTINE DTRTI2(Uplo,Diag,N,A,Lda,Info)
      IMPLICIT NONE
!
! PARAMETER definitions
!
      DOUBLE PRECISION , PARAMETER :: ONE = 1.0D+0
      CHARACTER :: Diag , Uplo
      INTEGER :: Info , Lda , N
      DOUBLE PRECISION , DIMENSION(Lda,*) :: A
      INTENT (IN) N
      INTENT (INOUT) A , Info
      END SUBROUTINE DTRTI2
   END INTERFACE
END MODULE S_DTRTI2
!*==intfaces.f90  created by SPAG 6.55Dc at 12:01 on  5 Feb 2004
MODULE S_DTRTRI
   INTERFACE
      SUBROUTINE DTRTRI(Uplo,Diag,N,A,Lda,Info)
      IMPLICIT NONE
!
! PARAMETER definitions
!
      DOUBLE PRECISION , PARAMETER :: ONE = 1.0D+0 , ZERO = 0.0D+0
      CHARACTER :: Diag , Uplo
      INTEGER :: Info , Lda , N
      DOUBLE PRECISION , DIMENSION(Lda,*) :: A
      INTENT (INOUT) Info
      END SUBROUTINE DTRTRI
   END INTERFACE
END MODULE S_DTRTRI
!*==intfaces.f90  created by SPAG 6.55Dc at 12:01 on  5 Feb 2004
MODULE S_ILAENV
   INTERFACE
      FUNCTION ILAENV(Ispec,Name,Opts,N1,N2,N3,N4)
      IMPLICIT NONE
      INTEGER :: Ispec , N1 , N2 , N3 , N4
      CHARACTER(*) :: Name , Opts
      INTEGER :: ILAENV
      INTENT (IN) Ispec , N1 , N2 , N4 , Name
      END FUNCTION ILAENV
   END INTERFACE
END MODULE S_ILAENV
!*==intfaces.f90  created by SPAG 6.55Dc at 12:01 on  5 Feb 2004
MODULE S_LSAME
   INTERFACE
      FUNCTION LSAME(Ca,Cb)
      IMPLICIT NONE
      CHARACTER :: Ca , Cb
      LOGICAL :: LSAME
      INTENT (IN) Ca , Cb
      END FUNCTION LSAME
   END INTERFACE
END MODULE S_LSAME
!*==DGETF2.spg  processed by SPAG 6.55Dc at 12:01 on  5 Feb 2004
!****************************************************************************
! LAPACK routines for inversion of a matrix are included below; they are:
!         dgetf2  dgetrf  dgetri  dlaswp  dtrti2  dtrtri  ilaenv  lsame
!
!       The BLAS routines that are called by LAPACK are not included.
!       You can either use standard BLAS (from netlib) or processor-
!       optimized (like INTEL mkl library). The necessary BLAS routines
!       are:
!         dgemm   dger    dswap   dtrmv   idamax
!         dgemv   dscal   dtrmm   dtrsm   xerbla
!
!       J. Bergervoet
!       May, 1998
!****************************************************************************
 
      SUBROUTINE DGETF2(M,N,A,Lda,Ipiv,Info)
      USE S_DGER
      USE S_DSCAL
      USE S_DSWAP
      USE S_IDAMAX
      USE S_XERBLA
      IMPLICIT NONE
!*--********************************************************************
!A INPUT  - M
!A INPUT  - N
!A INPUT  - A
!A INPUT  - LDA
!A OUTPUT - IPIV
!A OUTPUT - INFO
! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
! calls       DGER     DSCAL    DSWAP    IDAMAX   XERBLA
! called by   DGETRF
! modifies    ** NOTHING **
! uses value  ** NOTHING **
! local vars  J        JP
! uses PARAMs ONE      ZERO
!*++********************************************************************
!
!*** Start of declarations rewritten by SPAG
!
! PARAMETER definitions
!
      DOUBLE PRECISION , PARAMETER :: ONE = 1.0D+0 , ZERO = 0.0D+0
!
! Dummy arguments
!
      INTEGER :: Info , Lda , M , N
      DOUBLE PRECISION , DIMENSION(Lda,*) :: A
      INTEGER , DIMENSION(*) :: Ipiv
      INTENT (IN) M
      INTENT (OUT) Ipiv
      INTENT (INOUT) Info
!
! Local variables
!
      INTEGER :: j , jp
!
!*** End of declarations rewritten by SPAG
!
!
!  -- LAPACK routine (version 2.0) --
!     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
!     Courant Institute, Argonne National Lab, and Rice University
!     June 30, 1992
!
!     .. Scalar Arguments ..
!     ..
!     .. Array Arguments ..
!     ..
!
!  Purpose
!  =======
!
!  DGETF2 computes an LU factorization of a general m-by-n matrix A
!  using partial pivoting with row interchanges.
!
!  The factorization has the form
!     A = P * L * U
!  where P is a permutation matrix, L is lower triangular with unit
!  diagonal elements (lower trapezoidal if m > n), and U is upper
!  triangular (upper trapezoidal if m < n).
!
!  This is the right-looking Level 2 BLAS version of the algorithm.
!
!  Arguments
!  =========
!
!  M       (input) INTEGER
!          The number of rows of the matrix A.  M >= 0.
!
!  N       (input) INTEGER
!          The number of columns of the matrix A.  N >= 0.
!
!  A       (input/output) DOUBLE PRECISION array, dimension (LDA,N)
!          On entry, the m by n matrix to be factored.
!          On exit, the factors L and U from the factorization
!          A = P*L*U; the unit diagonal elements of L are not stored.
!
!  LDA     (input) INTEGER
!          The leading dimension of the array A.  LDA >= max(1,M).
!
!  IPIV    (output) INTEGER array, dimension (min(M,N))
!          The pivot indices; for 1 <= i <= min(M,N), row i of the
!          matrix was interchanged with row IPIV(i).
!
!  INFO    (output) INTEGER
!          = 0: successful exit
!          < 0: if INFO = -k, the k-th argument had an illegal value
!          > 0: if INFO = k, U(k,k) is exactly zero. The factorization
!               has been completed, but the factor U is exactly
!               singular, and division by zero will occur if it is used
!               to solve a system of equations.
!
!  =====================================================================
!
!     .. Parameters ..
!     ..
!     .. Local Scalars ..
!     ..
!     .. External Functions ..
!     ..
!     .. External Subroutines ..
!     ..
!     .. Intrinsic Functions ..
!     ..
!     .. Executable Statements ..
!
!     Test the input parameters.
!
      Info = 0
      IF ( M<0 ) THEN
         Info = -1
      ELSEIF ( N<0 ) THEN
         Info = -2
      ELSEIF ( Lda<MAX(1,M) ) THEN
         Info = -4
      ENDIF
      IF ( Info/=0 ) THEN
         CALL XERBLA('DGETF2',-Info)
         RETURN
      ENDIF
!
!     Quick return if possible
!
      IF ( M==0 .OR. N==0 ) RETURN
!
      DO j = 1 , MIN(M,N)
!
!        Find pivot and test for singularity.
!
         jp = j - 1 + IDAMAX(M-j+1,A(j,j),1)
         Ipiv(j) = jp
         IF ( A(jp,j)/=ZERO ) THEN
!
!           Apply the interchange to columns 1:N.
!
            IF ( jp/=j ) CALL DSWAP(N,A(j,1),Lda,A(jp,1),Lda)
!
!           Compute elements J+1:M of J-th column.
!
            IF ( j<M ) CALL DSCAL(M-j,ONE/A(j,j),A(j+1,j),1)
!
         ELSEIF ( Info==0 ) THEN
!
            Info = j
         ENDIF
!
!
!           Update trailing submatrix.
!
         IF ( j<MIN(M,N) ) CALL DGER(M-j,N-j,-ONE,A(j+1,j),1,A(j,j+1),  &
     &                               Lda,A(j+1,j+1),Lda)
      ENDDO
!
!     End of DGETF2
!
      END SUBROUTINE DGETF2
!*==DGETRF.spg  processed by SPAG 6.55Dc at 12:01 on  5 Feb 2004
 
 
      SUBROUTINE DGETRF(M,N,A,Lda,Ipiv,Info)
      USE S_DGEMM
      USE S_DGETF2
      USE S_DLASWP
      USE S_DTRSM
      USE S_ILAENV
      USE S_XERBLA
      IMPLICIT NONE
!*--********************************************************************
!A INPUT  - M
!A INPUT  - N
!A PASSED - A
!A INPUT  - LDA
!A OUTPUT - IPIV
!A OUTPUT - INFO
! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
! calls       DGEMM    DGETF2   DLASWP   DTRSM    ILAENV   XERBLA
! called by   ** NOTHING **
! modifies    ** NOTHING **
! uses value  ** NOTHING **
! local vars  I        IINFO    J        JB       NB
! uses PARAMs ONE
!*++********************************************************************
!
!*** Start of declarations rewritten by SPAG
!
! PARAMETER definitions
!
      DOUBLE PRECISION , PARAMETER :: ONE = 1.0D+0
!
! Dummy arguments
!
      INTEGER :: Info , Lda , M , N
      DOUBLE PRECISION , DIMENSION(Lda,*) :: A
      INTEGER , DIMENSION(*) :: Ipiv
      INTENT (INOUT) Info , Ipiv
!
! Local variables
!
      INTEGER :: i , iinfo , j , jb , nb
!
!*** End of declarations rewritten by SPAG
!
!
!  -- LAPACK routine (version 2.0) --
!     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
!     Courant Institute, Argonne National Lab, and Rice University
!     March 31, 1993
!
!     .. Scalar Arguments ..
!     ..
!     .. Array Arguments ..
!     ..
!
!  Purpose
!  =======
!
!  DGETRF computes an LU factorization of a general M-by-N matrix A
!  using partial pivoting with row interchanges.
!
!  The factorization has the form
!     A = P * L * U
!  where P is a permutation matrix, L is lower triangular with unit
!  diagonal elements (lower trapezoidal if m > n), and U is upper
!  triangular (upper trapezoidal if m < n).
!
!  This is the right-looking Level 3 BLAS version of the algorithm.
!
!  Arguments
!  =========
!
!  M       (input) INTEGER
!          The number of rows of the matrix A.  M >= 0.
!
!  N       (input) INTEGER
!          The number of columns of the matrix A.  N >= 0.
!
!  A       (input/output) DOUBLE PRECISION array, dimension (LDA,N)
!          On entry, the M-by-N matrix to be factored.
!          On exit, the factors L and U from the factorization
!          A = P*L*U; the unit diagonal elements of L are not stored.
!
!  LDA     (input) INTEGER
!          The leading dimension of the array A.  LDA >= max(1,M).
!
!  IPIV    (output) INTEGER array, dimension (min(M,N))
!          The pivot indices; for 1 <= i <= min(M,N), row i of the
!          matrix was interchanged with row IPIV(i).
!
!  INFO    (output) INTEGER
!          = 0:  successful exit
!          < 0:  if INFO = -i, the i-th argument had an illegal value
!          > 0:  if INFO = i, U(i,i) is exactly zero. The factorization
!                has been completed, but the factor U is exactly
!                singular, and division by zero will occur if it is used
!                to solve a system of equations.
!
!  =====================================================================
!
!     .. Parameters ..
!     ..
!     .. Local Scalars ..
!     ..
!     .. External Subroutines ..
!     ..
!     .. External Functions ..
!     ..
!     .. Intrinsic Functions ..
!     ..
!     .. Executable Statements ..
!
!     Test the input parameters.
!
      Info = 0
      IF ( M<0 ) THEN
         Info = -1
      ELSEIF ( N<0 ) THEN
         Info = -2
      ELSEIF ( Lda<MAX(1,M) ) THEN
         Info = -4
      ENDIF
      IF ( Info/=0 ) THEN
         CALL XERBLA('DGETRF',-Info)
         RETURN
      ENDIF
!
!     Quick return if possible
!
      IF ( M==0 .OR. N==0 ) RETURN
!
!     Determine the block size for this environment.
!
      nb = ILAENV(1,'DGETRF',' ',M,N,-1,-1)
      IF ( nb<=1 .OR. nb>=MIN(M,N) ) THEN
!
!        Use unblocked code.
!
         CALL DGETF2(M,N,A,Lda,Ipiv,Info)
      ELSE
!
!        Use blocked code.
!
         DO j = 1 , MIN(M,N) , nb
            jb = MIN(MIN(M,N)-j+1,nb)
!
!           Factor diagonal and subdiagonal blocks and test for exact
!           singularity.
!
            CALL DGETF2(M-j+1,jb,A(j,j),Lda,Ipiv(j),iinfo)
!
!           Adjust INFO and the pivot indices.
!
            IF ( Info==0 .AND. iinfo>0 ) Info = iinfo + j - 1
            DO i = j , MIN(M,j+jb-1)
               Ipiv(i) = j - 1 + Ipiv(i)
            ENDDO
!
!           Apply interchanges to columns 1:J-1.
!
            CALL DLASWP(j-1,A,Lda,j,j+jb-1,Ipiv,1)
!
            IF ( j+jb<=N ) THEN
!
!              Apply interchanges to columns J+JB:N.
!
               CALL DLASWP(N-j-jb+1,A(1,j+jb),Lda,j,j+jb-1,Ipiv,1)
!
!              Compute block row of U.
!
               CALL DTRSM('Left','Lower','No transpose','Unit',jb,      &
     &                    N-j-jb+1,ONE,A(j,j),Lda,A(j,j+jb),Lda)
!
!                 Update trailing submatrix.
!
               IF ( j+jb<=M ) CALL DGEMM('No transpose','No transpose', &
     &              M-j-jb+1,N-j-jb+1,jb,-ONE,A(j+jb,j),Lda,A(j,j+jb),  &
     &              Lda,ONE,A(j+jb,j+jb),Lda)
            ENDIF
         ENDDO
      ENDIF
!
!     End of DGETRF
!
      END SUBROUTINE DGETRF
!*==DGETRI.spg  processed by SPAG 6.55Dc at 12:01 on  5 Feb 2004
 
 
      SUBROUTINE DGETRI(N,A,Lda,Ipiv,Work,Lwork,Info)
      USE S_DGEMM
      USE S_DGEMV
      USE S_DSWAP
      USE S_DTRSM
      USE S_DTRTRI
      USE S_ILAENV
      USE S_XERBLA
      IMPLICIT NONE
!*--********************************************************************
!A INPUT  - N
!A OUTPUT - A
!A INPUT  - LDA
!A INPUT  - IPIV
!A OUTPUT - WORK
!A INPUT  - LWORK
!A OUTPUT - INFO
! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
! calls       DGEMM    DGEMV    DSWAP    DTRSM    DTRTRI   ILAENV
!             XERBLA
! called by   ** NOTHING **
! modifies    ** NOTHING **
! uses value  ** NOTHING **
! local vars  I        IWS      J        JB       JJ       JP
!             LDWORK   NB       NBMIN    NN
! uses PARAMs ONE      ZERO
!*++********************************************************************
!
!*** Start of declarations rewritten by SPAG
!
! PARAMETER definitions
!
      DOUBLE PRECISION , PARAMETER :: ZERO = 0.0D+0 , ONE = 1.0D+0
!
! Dummy arguments
!
      INTEGER :: Info , Lda , Lwork , N
      DOUBLE PRECISION , DIMENSION(Lda,*) :: A
      INTEGER , DIMENSION(*) :: Ipiv
      DOUBLE PRECISION , DIMENSION(Lwork) :: Work
      INTENT (IN) Ipiv , Lwork
      INTENT (INOUT) A , Info
!
! Local variables
!
      INTEGER :: i , iws , j , jb , jj , jp , ldwork , nb , nbmin , nn
!
!*** End of declarations rewritten by SPAG
!
!
!  -- LAPACK routine (version 2.0) --
!     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
!     Courant Institute, Argonne National Lab, and Rice University
!     September 30, 1994
!
!     .. Scalar Arguments ..
!     ..
!     .. Array Arguments ..
!     ..
!
!  Purpose
!  =======
!
!  DGETRI computes the inverse of a matrix using the LU factorization
!  computed by DGETRF.
!
!  This method inverts U and then computes inv(A) by solving the system
!  inv(A)*L = inv(U) for inv(A).
!
!  Arguments
!  =========
!
!  N       (input) INTEGER
!          The order of the matrix A.  N >= 0.
!
!  A       (input/output) DOUBLE PRECISION array, dimension (LDA,N)
!          On entry, the factors L and U from the factorization
!          A = P*L*U as computed by DGETRF.
!          On exit, if INFO = 0, the inverse of the original matrix A.
!
!  LDA     (input) INTEGER
!          The leading dimension of the array A.  LDA >= max(1,N).
!
!  IPIV    (input) INTEGER array, dimension (N)
!          The pivot indices from DGETRF; for 1<=i<=N, row i of the
!          matrix was interchanged with row IPIV(i).
!
!  WORK    (workspace/output) DOUBLE PRECISION array, dimension (LWORK)
!          On exit, if INFO=0, then WORK(1) returns the optimal LWORK.
!
!  LWORK   (input) INTEGER
!          The dimension of the array WORK.  LWORK >= max(1,N).
!          For optimal performance LWORK >= N*NB, where NB is
!          the optimal blocksize returned by ILAENV.
!
!  INFO    (output) INTEGER
!          = 0:  successful exit
!          < 0:  if INFO = -i, the i-th argument had an illegal value
!          > 0:  if INFO = i, U(i,i) is exactly zero; the matrix is
!                singular and its inverse could not be computed.
!
!  =====================================================================
!
!     .. Parameters ..
!     ..
!     .. Local Scalars ..
!     ..
!     .. External Functions ..
!     ..
!     .. External Subroutines ..
!     ..
!     .. Intrinsic Functions ..
!     ..
!     .. Executable Statements ..
!
!     Test the input parameters.
!
      Info = 0
      Work(1) = MAX(N,1)
      IF ( N<0 ) THEN
         Info = -1
      ELSEIF ( Lda<MAX(1,N) ) THEN
         Info = -3
      ELSEIF ( Lwork<MAX(1,N) ) THEN
         Info = -6
      ENDIF
      IF ( Info/=0 ) THEN
         CALL XERBLA('DGETRI',-Info)
         RETURN
      ENDIF
!
!     Quick return if possible
!
      IF ( N==0 ) RETURN
!
!     Form inv(U).  If INFO > 0 from DTRTRI, then U is singular,
!     and the inverse is not computed.
!
      CALL DTRTRI('Upper','Non-unit',N,A,Lda,Info)
      IF ( Info>0 ) RETURN
!
!     Determine the block size for this environment.
!
      nb = ILAENV(1,'DGETRI',' ',N,-1,-1,-1)
      nbmin = 2
      ldwork = N
      IF ( nb>1 .AND. nb<N ) THEN
         iws = MAX(ldwork*nb,1)
         IF ( Lwork<iws ) THEN
            nb = Lwork/ldwork
            nbmin = MAX(2,ILAENV(2,'DGETRI',' ',N,-1,-1,-1))
         ENDIF
      ELSE
         iws = N
      ENDIF
!
!     Solve the equation inv(A)*L = inv(U) for inv(A).
!
      IF ( nb<nbmin .OR. nb>=N ) THEN
!
!        Use unblocked code.
!
         DO j = N , 1 , -1
!
!           Copy current column of L to WORK and replace with zeros.
!
            DO i = j + 1 , N
               Work(i) = A(i,j)
               A(i,j) = ZERO
            ENDDO
!
!           Compute current column of inv(A).
!
            IF ( j<N ) CALL DGEMV('No transpose',N,N-j,-ONE,A(1,j+1),   &
     &                            Lda,Work(j+1),1,ONE,A(1,j),1)
         ENDDO
      ELSE
!
!        Use blocked code.
!
         nn = ((N-1)/nb)*nb + 1
         DO j = nn , 1 , -nb
            jb = MIN(nb,N-j+1)
!
!           Copy current block column of L to WORK and replace with
!           zeros.
!
            DO jj = j , j + jb - 1
               DO i = jj + 1 , N
                  Work(i+(jj-j)*ldwork) = A(i,jj)
                  A(i,jj) = ZERO
               ENDDO
            ENDDO
!
!           Compute current block column of inv(A).
!
            IF ( j+jb<=N ) CALL DGEMM('No transpose','No transpose',N,  &
     &                                jb,N-j-jb+1,-ONE,A(1,j+jb),Lda,   &
     &                                Work(j+jb),ldwork,ONE,A(1,j),Lda)
            CALL DTRSM('Right','Lower','No transpose','Unit',N,jb,ONE,  &
     &                 Work(j),ldwork,A(1,j),Lda)
         ENDDO
      ENDIF
!
!     Apply column interchanges.
!
      DO j = N - 1 , 1 , -1
         jp = Ipiv(j)
         IF ( jp/=j ) CALL DSWAP(N,A(1,j),1,A(1,jp),1)
      ENDDO
!
      Work(1) = iws
!
!     End of DGETRI
!
      END SUBROUTINE DGETRI
!*==DLASWP.spg  processed by SPAG 6.55Dc at 12:01 on  5 Feb 2004
 
 
      SUBROUTINE DLASWP(N,A,Lda,K1,K2,Ipiv,Incx)
      USE S_DSWAP
      IMPLICIT NONE
!*--********************************************************************
!A PASSED - N
!A PASSED - A
!A INPUT  - LDA
!A INPUT  - K1
!A INPUT  - K2
!A INPUT  - IPIV
!A INPUT  - INCX
! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
! calls       DSWAP
! called by   DGETRF
! modifies    ** NOTHING **
! uses value  ** NOTHING **
! local vars  I        IP       IX
! uses PARAMs *** NONE ****
!*++********************************************************************
!
!*** Start of declarations rewritten by SPAG
!
! Dummy arguments
!
      INTEGER :: Incx , K1 , K2 , Lda , N
      DOUBLE PRECISION , DIMENSION(Lda,*) :: A
      INTEGER , DIMENSION(*) :: Ipiv
      INTENT (IN) Incx , Ipiv , K1 , K2
!
! Local variables
!
      INTEGER :: i , ip , ix
!
!*** End of declarations rewritten by SPAG
!
!
!  -- LAPACK auxiliary routine (version 2.0) --
!     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
!     Courant Institute, Argonne National Lab, and Rice University
!     October 31, 1992
!
!     .. Scalar Arguments ..
!     ..
!     .. Array Arguments ..
!     ..
!
!  Purpose
!  =======
!
!  DLASWP performs a series of row interchanges on the matrix A.
!  One row interchange is initiated for each of rows K1 through K2 of A.
!
!  Arguments
!  =========
!
!  N       (input) INTEGER
!          The number of columns of the matrix A.
!
!  A       (input/output) DOUBLE PRECISION array, dimension (LDA,N)
!          On entry, the matrix of column dimension N to which the row
!          interchanges will be applied.
!          On exit, the permuted matrix.
!
!  LDA     (input) INTEGER
!          The leading dimension of the array A.
!
!  K1      (input) INTEGER
!          The first element of IPIV for which a row interchange will
!          be done.
!
!  K2      (input) INTEGER
!          The last element of IPIV for which a row interchange will
!          be done.
!
!  IPIV    (input) INTEGER array, dimension (M*abs(INCX))
!          The vector of pivot indices.  Only the elements in positions
!          K1 through K2 of IPIV are accessed.
!          IPIV(K) = L implies rows K and L are to be interchanged.
!
!  INCX    (input) INTEGER
!          The increment between successive values of IPIV.  If IPIV
!          is negative, the pivots are applied in reverse order.
!
! =====================================================================
!
!     .. Local Scalars ..
!     ..
!     .. External Subroutines ..
!     ..
!     .. Executable Statements ..
!
!     Interchange row I with row IPIV(I) for each of rows K1 through K2.
!
      IF ( Incx==0 ) RETURN
      IF ( Incx>0 ) THEN
         ix = K1
      ELSE
         ix = 1 + (1-K2)*Incx
      ENDIF
      IF ( Incx==1 ) THEN
         DO i = K1 , K2
            ip = Ipiv(i)
            IF ( ip/=i ) CALL DSWAP(N,A(i,1),Lda,A(ip,1),Lda)
         ENDDO
      ELSEIF ( Incx>1 ) THEN
         DO i = K1 , K2
            ip = Ipiv(ix)
            IF ( ip/=i ) CALL DSWAP(N,A(i,1),Lda,A(ip,1),Lda)
            ix = ix + Incx
         ENDDO
      ELSEIF ( Incx<0 ) THEN
         DO i = K2 , K1 , -1
            ip = Ipiv(ix)
            IF ( ip/=i ) CALL DSWAP(N,A(i,1),Lda,A(ip,1),Lda)
            ix = ix + Incx
         ENDDO
      ENDIF
!
!
!     End of DLASWP
!
      END SUBROUTINE DLASWP
!*==DTRTI2.spg  processed by SPAG 6.55Dc at 12:01 on  5 Feb 2004
 
 
      SUBROUTINE DTRTI2(Uplo,Diag,N,A,Lda,Info)
      USE S_DSCAL
      USE S_DTRMV
      USE S_LSAME
      USE S_XERBLA
      IMPLICIT NONE
!*--********************************************************************
!A PASSED - UPLO
!A PASSED - DIAG
!A INPUT  - N
!A OUTPUT - A
!A INPUT  - LDA
!A OUTPUT - INFO
! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
! calls       DSCAL    DTRMV    LSAME    XERBLA
! called by   DTRTRI
! modifies    ** NOTHING **
! uses value  ** NOTHING **
! local vars  AJJ      J        NOUNIT   UPPER
! uses PARAMs ONE
!*++********************************************************************
!
!*** Start of declarations rewritten by SPAG
!
! PARAMETER definitions
!
      DOUBLE PRECISION , PARAMETER :: ONE = 1.0D+0
!
! Dummy arguments
!
      CHARACTER :: Diag , Uplo
      INTEGER :: Info , Lda , N
      DOUBLE PRECISION , DIMENSION(Lda,*) :: A
      INTENT (IN) N
      INTENT (INOUT) A , Info
!
! Local variables
!
      DOUBLE PRECISION :: ajj
      INTEGER :: j
      LOGICAL :: nounit , upper
!
!*** End of declarations rewritten by SPAG
!
!
!  -- LAPACK routine (version 2.0) --
!     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
!     Courant Institute, Argonne National Lab, and Rice University
!     February 29, 1992
!
!     .. Scalar Arguments ..
!     ..
!     .. Array Arguments ..
!     ..
!
!  Purpose
!  =======
!
!  DTRTI2 computes the inverse of a real upper or lower triangular
!  matrix.
!
!  This is the Level 2 BLAS version of the algorithm.
!
!  Arguments
!  =========
!
!  UPLO    (input) CHARACTER*1
!          Specifies whether the matrix A is upper or lower triangular.
!          = 'U':  Upper triangular
!          = 'L':  Lower triangular
!
!  DIAG    (input) CHARACTER*1
!          Specifies whether or not the matrix A is unit triangular.
!          = 'N':  Non-unit triangular
!          = 'U':  Unit triangular
!
!  N       (input) INTEGER
!          The order of the matrix A.  N >= 0.
!
!  A       (input/output) DOUBLE PRECISION array, dimension (LDA,N)
!          On entry, the triangular matrix A.  If UPLO = 'U', the
!          leading n by n upper triangular part of the array A contains
!          the upper triangular matrix, and the strictly lower
!          triangular part of A is not referenced.  If UPLO = 'L', the
!          leading n by n lower triangular part of the array A contains
!          the lower triangular matrix, and the strictly upper
!          triangular part of A is not referenced.  If DIAG = 'U', the
!          diagonal elements of A are also not referenced and are
!          assumed to be 1.
!
!          On exit, the (triangular) inverse of the original matrix, in
!          the same storage format.
!
!  LDA     (input) INTEGER
!          The leading dimension of the array A.  LDA >= max(1,N).
!
!  INFO    (output) INTEGER
!          = 0: successful exit
!          < 0: if INFO = -k, the k-th argument had an illegal value
!
!  =====================================================================
!
!     .. Parameters ..
!     ..
!     .. Local Scalars ..
!     ..
!     .. External Functions ..
!     ..
!     .. External Subroutines ..
!     ..
!     .. Intrinsic Functions ..
!     ..
!     .. Executable Statements ..
!
!     Test the input parameters.
!
      Info = 0
      upper = LSAME(Uplo,'U')
      nounit = LSAME(Diag,'N')
      IF ( .NOT.upper .AND. .NOT.LSAME(Uplo,'L') ) THEN
         Info = -1
      ELSEIF ( .NOT.nounit .AND. .NOT.LSAME(Diag,'U') ) THEN
         Info = -2
      ELSEIF ( N<0 ) THEN
         Info = -3
      ELSEIF ( Lda<MAX(1,N) ) THEN
         Info = -5
      ENDIF
      IF ( Info/=0 ) THEN
         CALL XERBLA('DTRTI2',-Info)
         RETURN
      ENDIF
!
      IF ( upper ) THEN
!
!        Compute inverse of upper triangular matrix.
!
         DO j = 1 , N
            IF ( nounit ) THEN
               A(j,j) = ONE/A(j,j)
               ajj = -A(j,j)
            ELSE
               ajj = -ONE
            ENDIF
!
!           Compute elements 1:j-1 of j-th column.
!
            CALL DTRMV('Upper','No transpose',Diag,j-1,A,Lda,A(1,j),1)
            CALL DSCAL(j-1,ajj,A(1,j),1)
         ENDDO
      ELSE
!
!        Compute inverse of lower triangular matrix.
!
         DO j = N , 1 , -1
            IF ( nounit ) THEN
               A(j,j) = ONE/A(j,j)
               ajj = -A(j,j)
            ELSE
               ajj = -ONE
            ENDIF
            IF ( j<N ) THEN
!
!              Compute elements j+1:n of j-th column.
!
               CALL DTRMV('Lower','No transpose',Diag,N-j,A(j+1,j+1),   &
     &                    Lda,A(j+1,j),1)
               CALL DSCAL(N-j,ajj,A(j+1,j),1)
            ENDIF
         ENDDO
      ENDIF
!
!
!     End of DTRTI2
!
      END SUBROUTINE DTRTI2
!*==DTRTRI.spg  processed by SPAG 6.55Dc at 12:01 on  5 Feb 2004
 
 
      SUBROUTINE DTRTRI(Uplo,Diag,N,A,Lda,Info)
      USE S_DTRMM
      USE S_DTRSM
      USE S_DTRTI2
      USE S_ILAENV
      USE S_LSAME
      USE S_XERBLA
      IMPLICIT NONE
!*--********************************************************************
!A INPUT  - UPLO
!A INPUT  - DIAG
!A INPUT  - N
!A INPUT  - A
!A INPUT  - LDA
!A OUTPUT - INFO
! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
! calls       DTRMM    DTRSM    DTRTI2   ILAENV   LSAME    XERBLA
! called by   DGETRI
! modifies    ** NOTHING **
! uses value  ** NOTHING **
! local vars  J        JB       NB       NN       NOUNIT   UPPER
! uses PARAMs ONE      ZERO
!*++********************************************************************
!
!*** Start of declarations rewritten by SPAG
!
! PARAMETER definitions
!
      DOUBLE PRECISION , PARAMETER :: ONE = 1.0D+0 , ZERO = 0.0D+0
!
! Dummy arguments
!
      CHARACTER :: Diag , Uplo
      INTEGER :: Info , Lda , N
      DOUBLE PRECISION , DIMENSION(Lda,*) :: A
      INTENT (INOUT) Info
!
! Local variables
!
      INTEGER :: j , jb , nb , nn
      LOGICAL :: nounit , upper
!
!*** End of declarations rewritten by SPAG
!
!
!  -- LAPACK routine (version 2.0) --
!     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
!     Courant Institute, Argonne National Lab, and Rice University
!     March 31, 1993
!
!     .. Scalar Arguments ..
!     ..
!     .. Array Arguments ..
!     ..
!
!  Purpose
!  =======
!
!  DTRTRI computes the inverse of a real upper or lower triangular
!  matrix A.
!
!  This is the Level 3 BLAS version of the algorithm.
!
!  Arguments
!  =========
!
!  UPLO    (input) CHARACTER*1
!          = 'U':  A is upper triangular;
!          = 'L':  A is lower triangular.
!
!  DIAG    (input) CHARACTER*1
!          = 'N':  A is non-unit triangular;
!          = 'U':  A is unit triangular.
!
!  N       (input) INTEGER
!          The order of the matrix A.  N >= 0.
!
!  A       (input/output) DOUBLE PRECISION array, dimension (LDA,N)
!          On entry, the triangular matrix A.  If UPLO = 'U', the
!          leading N-by-N upper triangular part of the array A contains
!          the upper triangular matrix, and the strictly lower
!          triangular part of A is not referenced.  If UPLO = 'L', the
!          leading N-by-N lower triangular part of the array A contains
!          the lower triangular matrix, and the strictly upper
!          triangular part of A is not referenced.  If DIAG = 'U', the
!          diagonal elements of A are also not referenced and are
!          assumed to be 1.
!          On exit, the (triangular) inverse of the original matrix, in
!          the same storage format.
!
!  LDA     (input) INTEGER
!          The leading dimension of the array A.  LDA >= max(1,N).
!
!  INFO    (output) INTEGER
!          = 0: successful exit
!          < 0: if INFO = -i, the i-th argument had an illegal value
!          > 0: if INFO = i, A(i,i) is exactly zero.  The triangular
!               matrix is singular and its inverse can not be computed.
!
!  =====================================================================
!
!     .. Parameters ..
!     ..
!     .. Local Scalars ..
!     ..
!     .. External Functions ..
!     ..
!     .. External Subroutines ..
!     ..
!     .. Intrinsic Functions ..
!     ..
!     .. Executable Statements ..
!
!     Test the input parameters.
!
      Info = 0
      upper = LSAME(Uplo,'U')
      nounit = LSAME(Diag,'N')
      IF ( .NOT.upper .AND. .NOT.LSAME(Uplo,'L') ) THEN
         Info = -1
      ELSEIF ( .NOT.nounit .AND. .NOT.LSAME(Diag,'U') ) THEN
         Info = -2
      ELSEIF ( N<0 ) THEN
         Info = -3
      ELSEIF ( Lda<MAX(1,N) ) THEN
         Info = -5
      ENDIF
      IF ( Info/=0 ) THEN
         CALL XERBLA('DTRTRI',-Info)
         RETURN
      ENDIF
!
!     Quick return if possible
!
      IF ( N==0 ) RETURN
!
!     Check for singularity if non-unit.
!
      IF ( nounit ) THEN
         DO Info = 1 , N
            IF ( A(Info,Info)==ZERO ) RETURN
         ENDDO
         Info = 0
      ENDIF
!
!     Determine the block size for this environment.
!
      nb = ILAENV(1,'DTRTRI',Uplo//Diag,N,-1,-1,-1)
      IF ( nb<=1 .OR. nb>=N ) THEN
!
!        Use unblocked code
!
         CALL DTRTI2(Uplo,Diag,N,A,Lda,Info)
!
!        Use blocked code
!
      ELSEIF ( upper ) THEN
!
!           Compute inverse of upper triangular matrix
!
         DO j = 1 , N , nb
            jb = MIN(nb,N-j+1)
!
!              Compute rows 1:j-1 of current block column
!
            CALL DTRMM('Left','Upper','No transpose',Diag,j-1,jb,ONE,A, &
     &                 Lda,A(1,j),Lda)
            CALL DTRSM('Right','Upper','No transpose',Diag,j-1,jb,-ONE, &
     &                 A(j,j),Lda,A(1,j),Lda)
!
!              Compute inverse of current diagonal block
!
            CALL DTRTI2('Upper',Diag,jb,A(j,j),Lda,Info)
         ENDDO
      ELSE
!
!           Compute inverse of lower triangular matrix
!
         nn = ((N-1)/nb)*nb + 1
         DO j = nn , 1 , -nb
            jb = MIN(nb,N-j+1)
            IF ( j+jb<=N ) THEN
!
!                 Compute rows j+jb:n of current block column
!
               CALL DTRMM('Left','Lower','No transpose',Diag,N-j-jb+1,  &
     &                    jb,ONE,A(j+jb,j+jb),Lda,A(j+jb,j),Lda)
               CALL DTRSM('Right','Lower','No transpose',Diag,N-j-jb+1, &
     &                    jb,-ONE,A(j,j),Lda,A(j+jb,j),Lda)
            ENDIF
!
!              Compute inverse of current diagonal block
!
            CALL DTRTI2('Lower',Diag,jb,A(j,j),Lda,Info)
         ENDDO
      ENDIF
!
!
!     End of DTRTRI
!
      END SUBROUTINE DTRTRI
!*==ILAENV.spg  processed by SPAG 6.55Dc at 12:01 on  5 Feb 2004
      FUNCTION ILAENV(Ispec,Name,Opts,N1,N2,N3,N4)
      IMPLICIT NONE
!*--********************************************************************
!A INPUT  - ISPEC
!A INPUT  - NAME
!A UNUSED - OPTS
!A INPUT  - N1
!A INPUT  - N2
!A UNUSED - N3
!A INPUT  - N4
! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
! calls       ** NOTHING **
! called by   DGETRF   DGETRI   DTRTRI
! modifies    ** NOTHING **
! uses value  ** NOTHING **
! local vars  C1       C2       C3       C4       CNAME    I        IC
!             IZ       NB       NBMIN    NX       SNAME    SUBNAM
! uses PARAMs *** NONE ****
!*++********************************************************************
!
!*** Start of declarations rewritten by SPAG
!
! Dummy arguments
!
      INTEGER :: Ispec , N1 , N2 , N3 , N4
      CHARACTER(*) :: Name , Opts
      INTEGER :: ILAENV
      INTENT (IN) Ispec , N1 , N2 , N4 , Name
!
! Local variables
!
      CHARACTER(1) :: c1
      CHARACTER(2) :: c2 , c4
      CHARACTER(3) :: c3
      LOGICAL :: cname , sname
      INTEGER :: i , ic , iz , nb , nbmin , nx
      CHARACTER(6) :: subnam
!
!*** End of declarations rewritten by SPAG
!
!
!  -- LAPACK auxiliary routine (version 2.0) --
!     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
!     Courant Institute, Argonne National Lab, and Rice University
!     September 30, 1994
!
!     .. Scalar Arguments ..
!     ..
!
!  Purpose
!  =======
!
!  ILAENV is called from the LAPACK routines to choose problem-dependent
!  parameters for the local environment.  See ISPEC for a description of
!  the parameters.
!
!  This version provides a set of parameters which should give good,
!  but not optimal, performance on many of the currently available
!  computers.  Users are encouraged to modify this subroutine to set
!  the tuning parameters for their particular machine using the option
!  and problem size information in the arguments.
!
!  This routine will not function correctly if it is converted to all
!  lower case.  Converting it to all upper case is allowed.
!
!  Arguments
!  =========
!
!  ISPEC   (input) INTEGER
!          Specifies the parameter to be returned as the value of
!          ILAENV.
!          = 1: the optimal blocksize; if this value is 1, an unblocked
!               algorithm will give the best performance.
!          = 2: the minimum block size for which the block routine
!               should be used; if the usable block size is less than
!               this value, an unblocked routine should be used.
!          = 3: the crossover point (in a block routine, for N less
!               than this value, an unblocked routine should be used)
!          = 4: the number of shifts, used in the nonsymmetric
!               eigenvalue routines
!          = 5: the minimum column dimension for blocking to be used;
!               rectangular blocks must have dimension at least k by m,
!               where k is given by ILAENV(2,...) and m by ILAENV(5,...)
!          = 6: the crossover point for the SVD (when reducing an m by n
!               matrix to bidiagonal form, if max(m,n)/min(m,n) exceeds
!               this value, a QR factorization is used first to reduce
!               the matrix to a triangular form.)
!          = 7: the number of processors
!          = 8: the crossover point for the multishift QR and QZ methods
!               for nonsymmetric eigenvalue problems.
!
!  NAME    (input) CHARACTER*(*)
!          The name of the calling subroutine, in either upper case or
!          lower case.
!
!  OPTS    (input) CHARACTER*(*)
!          The character options to the subroutine NAME, concatenated
!          into a single character string.  For example, UPLO = 'U',
!          TRANS = 'T', and DIAG = 'N' for a triangular routine would
!          be specified as OPTS = 'UTN'.
!
!  N1      (input) INTEGER
!  N2      (input) INTEGER
!  N3      (input) INTEGER
!  N4      (input) INTEGER
!          Problem dimensions for the subroutine NAME; these may not all
!          be required.
!
! (ILAENV) (output) INTEGER
!          >= 0: the value of the parameter specified by ISPEC
!          < 0:  if ILAENV = -k, the k-th argument had an illegal value.
!
!  Further Details
!  ===============
!
!  The following conventions have been used when calling ILAENV from the
!  LAPACK routines:
!  1)  OPTS is a concatenation of all of the character options to
!      subroutine NAME, in the same order that they appear in the
!      argument list for NAME, even if they are not used in determining
!      the value of the parameter specified by ISPEC.
!  2)  The problem dimensions N1, N2, N3, N4 are specified in the order
!      that they appear in the argument list for NAME.  N1 is used
!      first, N2 second, and so on, and unused problem dimensions are
!      passed a value of -1.
!  3)  The parameter value returned by ILAENV is checked for validity in
!      the calling subroutine.  For example, ILAENV is used to retrieve
!      the optimal blocksize for STRTRI as follows:
!
!      NB = ILAENV( 1, 'STRTRI', UPLO // DIAG, N, -1, -1, -1 )
!      IF( NB.LE.1 ) NB = MAX( 1, N )
!
!  =====================================================================
!
!     .. Local Scalars ..
!     ..
!     .. Intrinsic Functions ..
!     ..
!     .. Executable Statements ..
!
      SELECT CASE (Ispec)
      CASE (1,2,3)
!
!
!     Convert NAME to upper case if the first character is lower case.
!
         ILAENV = 1
         subnam = Name
         ic = ICHAR(subnam(1:1))
         iz = ICHAR('Z')
         IF ( iz==90 .OR. iz==122 ) THEN
!
!        ASCII character set
!
            IF ( ic>=97 .AND. ic<=122 ) THEN
               subnam(1:1) = CHAR(ic-32)
               DO i = 2 , 6
                  ic = ICHAR(subnam(i:i))
                  IF ( ic>=97 .AND. ic<=122 ) subnam(i:i) = CHAR(ic-32)
               ENDDO
            ENDIF
!
         ELSEIF ( iz==233 .OR. iz==169 ) THEN
!
!        EBCDIC character set
!
            IF ( (ic>=129 .AND. ic<=137) .OR. (ic>=145 .AND. ic<=153)   &
     &           .OR. (ic>=162 .AND. ic<=169) ) THEN
               subnam(1:1) = CHAR(ic+64)
               DO i = 2 , 6
                  ic = ICHAR(subnam(i:i))
                  IF ( (ic>=129 .AND. ic<=137) .OR.                     &
     &                 (ic>=145 .AND. ic<=153) .OR.                     &
     &                 (ic>=162 .AND. ic<=169) ) subnam(i:i)            &
     &                 = CHAR(ic+64)
               ENDDO
            ENDIF
!
         ELSEIF ( iz==218 .OR. iz==250 ) THEN
!
!        Prime machines:  ASCII+128
!
            IF ( ic>=225 .AND. ic<=250 ) THEN
               subnam(1:1) = CHAR(ic-32)
               DO i = 2 , 6
                  ic = ICHAR(subnam(i:i))
                  IF ( ic>=225 .AND. ic<=250 ) subnam(i:i) = CHAR(ic-32)
               ENDDO
            ENDIF
         ENDIF
!
         c1 = subnam(1:1)
         sname = c1=='S' .OR. c1=='D'
         cname = c1=='C' .OR. c1=='Z'
         IF ( .NOT.(cname .OR. sname) ) RETURN
         c2 = subnam(2:3)
         c3 = subnam(4:6)
         c4 = c3(2:3)
!
         SELECT CASE (Ispec)
         CASE (2)
!
!
!     ISPEC = 2:  minimum block size
!
            nbmin = 2
            IF ( c2=='GE' ) THEN
               IF ( c3=='QRF' .OR. c3=='RQF' .OR. c3=='LQF' .OR.        &
     &              c3=='QLF' ) THEN
                  IF ( sname ) THEN
                     nbmin = 2
                  ELSE
                     nbmin = 2
                  ENDIF
               ELSEIF ( c3=='HRD' ) THEN
                  IF ( sname ) THEN
                     nbmin = 2
                  ELSE
                     nbmin = 2
                  ENDIF
               ELSEIF ( c3=='BRD' ) THEN
                  IF ( sname ) THEN
                     nbmin = 2
                  ELSE
                     nbmin = 2
                  ENDIF
               ELSEIF ( c3=='TRI' ) THEN
                  IF ( sname ) THEN
                     nbmin = 2
                  ELSE
                     nbmin = 2
                  ENDIF
               ENDIF
            ELSEIF ( c2=='SY' ) THEN
               IF ( c3=='TRF' ) THEN
                  IF ( sname ) THEN
                     nbmin = 8
                  ELSE
                     nbmin = 8
                  ENDIF
               ELSEIF ( sname .AND. c3=='TRD' ) THEN
                  nbmin = 2
               ENDIF
            ELSEIF ( cname .AND. c2=='HE' ) THEN
               IF ( c3=='TRD' ) nbmin = 2
            ELSEIF ( sname .AND. c2=='OR' ) THEN
               IF ( c3(1:1)=='G' ) THEN
                  IF ( c4=='QR' .OR. c4=='RQ' .OR. c4=='LQ' .OR.        &
     &                 c4=='QL' .OR. c4=='HR' .OR. c4=='TR' .OR.        &
     &                 c4=='BR' ) nbmin = 2
               ELSEIF ( c3(1:1)=='M' ) THEN
                  IF ( c4=='QR' .OR. c4=='RQ' .OR. c4=='LQ' .OR.        &
     &                 c4=='QL' .OR. c4=='HR' .OR. c4=='TR' .OR.        &
     &                 c4=='BR' ) nbmin = 2
               ENDIF
            ELSEIF ( cname .AND. c2=='UN' ) THEN
               IF ( c3(1:1)=='G' ) THEN
                  IF ( c4=='QR' .OR. c4=='RQ' .OR. c4=='LQ' .OR.        &
     &                 c4=='QL' .OR. c4=='HR' .OR. c4=='TR' .OR.        &
     &                 c4=='BR' ) nbmin = 2
               ELSEIF ( c3(1:1)=='M' ) THEN
                  IF ( c4=='QR' .OR. c4=='RQ' .OR. c4=='LQ' .OR.        &
     &                 c4=='QL' .OR. c4=='HR' .OR. c4=='TR' .OR.        &
     &                 c4=='BR' ) nbmin = 2
               ENDIF
            ENDIF
            ILAENV = nbmin
            RETURN
         CASE (3)
!
!
!     ISPEC = 3:  crossover point
!
            nx = 0
            IF ( c2=='GE' ) THEN
               IF ( c3=='QRF' .OR. c3=='RQF' .OR. c3=='LQF' .OR.        &
     &              c3=='QLF' ) THEN
                  IF ( sname ) THEN
                     nx = 128
                  ELSE
                     nx = 128
                  ENDIF
               ELSEIF ( c3=='HRD' ) THEN
                  IF ( sname ) THEN
                     nx = 128
                  ELSE
                     nx = 128
                  ENDIF
               ELSEIF ( c3=='BRD' ) THEN
                  IF ( sname ) THEN
                     nx = 128
                  ELSE
                     nx = 128
                  ENDIF
               ENDIF
            ELSEIF ( c2=='SY' ) THEN
               IF ( sname .AND. c3=='TRD' ) nx = 1
            ELSEIF ( cname .AND. c2=='HE' ) THEN
               IF ( c3=='TRD' ) nx = 1
            ELSEIF ( sname .AND. c2=='OR' ) THEN
               IF ( c3(1:1)=='G' ) THEN
                  IF ( c4=='QR' .OR. c4=='RQ' .OR. c4=='LQ' .OR.        &
     &                 c4=='QL' .OR. c4=='HR' .OR. c4=='TR' .OR.        &
     &                 c4=='BR' ) nx = 128
               ENDIF
            ELSEIF ( cname .AND. c2=='UN' ) THEN
               IF ( c3(1:1)=='G' ) THEN
                  IF ( c4=='QR' .OR. c4=='RQ' .OR. c4=='LQ' .OR.        &
     &                 c4=='QL' .OR. c4=='HR' .OR. c4=='TR' .OR.        &
     &                 c4=='BR' ) nx = 128
               ENDIF
            ENDIF
            ILAENV = nx
            RETURN
         CASE DEFAULT
!
!
!     ISPEC = 1:  block size
!
!     In these examples, separate code is provided for setting NB for
!     real and complex.  We assume that NB will take the same value in
!     single or double precision.
!
            nb = 1
!
            IF ( c2=='GE' ) THEN
               IF ( c3=='TRF' ) THEN
                  IF ( sname ) THEN
                     nb = 64
                  ELSE
                     nb = 64
                  ENDIF
               ELSEIF ( c3=='QRF' .OR. c3=='RQF' .OR. c3=='LQF' .OR.    &
     &                  c3=='QLF' ) THEN
                  IF ( sname ) THEN
                     nb = 32
                  ELSE
                     nb = 32
                  ENDIF
               ELSEIF ( c3=='HRD' ) THEN
                  IF ( sname ) THEN
                     nb = 32
                  ELSE
                     nb = 32
                  ENDIF
               ELSEIF ( c3=='BRD' ) THEN
                  IF ( sname ) THEN
                     nb = 32
                  ELSE
                     nb = 32
                  ENDIF
               ELSEIF ( c3=='TRI' ) THEN
                  IF ( sname ) THEN
                     nb = 64
                  ELSE
                     nb = 64
                  ENDIF
               ENDIF
            ELSEIF ( c2=='PO' ) THEN
               IF ( c3=='TRF' ) THEN
                  IF ( sname ) THEN
                     nb = 64
                  ELSE
                     nb = 64
                  ENDIF
               ENDIF
            ELSEIF ( c2=='SY' ) THEN
               IF ( c3=='TRF' ) THEN
                  IF ( sname ) THEN
                     nb = 64
                  ELSE
                     nb = 64
                  ENDIF
               ELSEIF ( sname .AND. c3=='TRD' ) THEN
                  nb = 1
               ELSEIF ( sname .AND. c3=='GST' ) THEN
                  nb = 64
               ENDIF
            ELSEIF ( cname .AND. c2=='HE' ) THEN
               IF ( c3=='TRF' ) THEN
                  nb = 64
               ELSEIF ( c3=='TRD' ) THEN
                  nb = 1
               ELSEIF ( c3=='GST' ) THEN
                  nb = 64
               ENDIF
            ELSEIF ( sname .AND. c2=='OR' ) THEN
               IF ( c3(1:1)=='G' ) THEN
                  IF ( c4=='QR' .OR. c4=='RQ' .OR. c4=='LQ' .OR.        &
     &                 c4=='QL' .OR. c4=='HR' .OR. c4=='TR' .OR.        &
     &                 c4=='BR' ) nb = 32
               ELSEIF ( c3(1:1)=='M' ) THEN
                  IF ( c4=='QR' .OR. c4=='RQ' .OR. c4=='LQ' .OR.        &
     &                 c4=='QL' .OR. c4=='HR' .OR. c4=='TR' .OR.        &
     &                 c4=='BR' ) nb = 32
               ENDIF
            ELSEIF ( cname .AND. c2=='UN' ) THEN
               IF ( c3(1:1)=='G' ) THEN
                  IF ( c4=='QR' .OR. c4=='RQ' .OR. c4=='LQ' .OR.        &
     &                 c4=='QL' .OR. c4=='HR' .OR. c4=='TR' .OR.        &
     &                 c4=='BR' ) nb = 32
               ELSEIF ( c3(1:1)=='M' ) THEN
                  IF ( c4=='QR' .OR. c4=='RQ' .OR. c4=='LQ' .OR.        &
     &                 c4=='QL' .OR. c4=='HR' .OR. c4=='TR' .OR.        &
     &                 c4=='BR' ) nb = 32
               ENDIF
            ELSEIF ( c2=='GB' ) THEN
               IF ( c3=='TRF' ) THEN
                  IF ( sname ) THEN
                     IF ( N4<=64 ) THEN
                        nb = 1
                     ELSE
                        nb = 32
                     ENDIF
                  ELSEIF ( N4<=64 ) THEN
                     nb = 1
                  ELSE
                     nb = 32
                  ENDIF
               ENDIF
            ELSEIF ( c2=='PB' ) THEN
               IF ( c3=='TRF' ) THEN
                  IF ( sname ) THEN
                     IF ( N2<=64 ) THEN
                        nb = 1
                     ELSE
                        nb = 32
                     ENDIF
                  ELSEIF ( N2<=64 ) THEN
                     nb = 1
                  ELSE
                     nb = 32
                  ENDIF
               ENDIF
            ELSEIF ( c2=='TR' ) THEN
               IF ( c3=='TRI' ) THEN
                  IF ( sname ) THEN
                     nb = 64
                  ELSE
                     nb = 64
                  ENDIF
               ENDIF
            ELSEIF ( c2=='LA' ) THEN
               IF ( c3=='UUM' ) THEN
                  IF ( sname ) THEN
                     nb = 64
                  ELSE
                     nb = 64
                  ENDIF
               ENDIF
            ELSEIF ( sname .AND. c2=='ST' ) THEN
               IF ( c3=='EBZ' ) nb = 1
            ENDIF
!** Reduce NB ??? !!!
            ILAENV = nb
                    ! max (NB/2, 1) ???
            RETURN
         END SELECT
      CASE (4)
!
!
!     ISPEC = 4:  number of shifts (used by xHSEQR)
!
         ILAENV = 6
         RETURN
      CASE (5)
!
!
!     ISPEC = 5:  minimum column dimension (not used)
!
         ILAENV = 2
         RETURN
      CASE (6)
!
!
!     ISPEC = 6:  crossover point for SVD (used by xGELSS and xGESVD)
!
         ILAENV = INT(REAL(MIN(N1,N2))*1.6E0)
         RETURN
      CASE (7)
!
!
!     ISPEC = 7:  number of processors (not used)
!
         ILAENV = 1
         RETURN
      CASE (8)
!
!
!     ISPEC = 8:  crossover point for multishift (used by xHSEQR)
!
         ILAENV = 50
         GOTO 99999
      CASE DEFAULT
      END SELECT
!
!     Invalid value for ISPEC
!
      ILAENV = -1
      RETURN
!
!     End of ILAENV
!
99999 END FUNCTION ILAENV
!*==LSAME.spg  processed by SPAG 6.55Dc at 12:01 on  5 Feb 2004
      FUNCTION LSAME(Ca,Cb)
      IMPLICIT NONE
!*--********************************************************************
!A INPUT  - CA
!A INPUT  - CB
! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
! calls       ** NOTHING **
! called by   DGEMM    DGEMV    DTRMM    DTRMV    DTRSM    DTRTI2
!             DTRTRI
! modifies    ** NOTHING **
! uses value  ** NOTHING **
! local vars  INTA     INTB     ZCODE
! uses PARAMs *** NONE ****
!*++********************************************************************
!
!*** Start of declarations rewritten by SPAG
!
! Dummy arguments
!
      CHARACTER :: Ca , Cb
      LOGICAL :: LSAME
      INTENT (IN) Ca , Cb
!
! Local variables
!
      INTEGER :: inta , intb , zcode
!
!*** End of declarations rewritten by SPAG
!
!
!  -- LAPACK auxiliary routine (version 2.0) --
!     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
!     Courant Institute, Argonne National Lab, and Rice University
!     September 30, 1994
!
!     .. Scalar Arguments ..
!     ..
!
!  Purpose
!  =======
!
!  LSAME returns .TRUE. if CA is the same letter as CB regardless of
!  case.
!
!  Arguments
!  =========
!
!  CA      (input) CHARACTER*1
!  CB      (input) CHARACTER*1
!          CA and CB specify the single characters to be compared.
!
! =====================================================================
!
!     .. Intrinsic Functions ..
!     ..
!     .. Local Scalars ..
!     ..
!     .. Executable Statements ..
!
!     Test if the characters are equal
!
      LSAME = Ca==Cb
      IF ( LSAME ) RETURN
!
!     Now test for equivalence if both characters are alphabetic.
!
      zcode = ICHAR('Z')
!
!     Use 'Z' rather than 'A' so that ASCII can be detected on Prime
!     machines, on which ICHAR returns a value with bit 8 set.
!     ICHAR('A') on Prime machines returns 193 which is the same as
!     ICHAR('A') on an EBCDIC machine.
!
      inta = ICHAR(Ca)
      intb = ICHAR(Cb)
!
      IF ( zcode==90 .OR. zcode==122 ) THEN
!
!        ASCII is assumed - ZCODE is the ASCII code of either lower or
!        upper case 'Z'.
!
         IF ( inta>=97 .AND. inta<=122 ) inta = inta - 32
         IF ( intb>=97 .AND. intb<=122 ) intb = intb - 32
!
      ELSEIF ( zcode==233 .OR. zcode==169 ) THEN
!
!        EBCDIC is assumed - ZCODE is the EBCDIC code of either lower or
!        upper case 'Z'.
!
         IF ( inta>=129 .AND. inta<=137 .OR. inta>=145 .AND.            &
     &        inta<=153 .OR. inta>=162 .AND. inta<=169 ) inta = inta +  &
     &        64
         IF ( intb>=129 .AND. intb<=137 .OR. intb>=145 .AND.            &
     &        intb<=153 .OR. intb>=162 .AND. intb<=169 ) intb = intb +  &
     &        64
!
      ELSEIF ( zcode==218 .OR. zcode==250 ) THEN
!
!        ASCII is assumed, on Prime machines - ZCODE is the ASCII code
!        plus 128 of either lower or upper case 'Z'.
!
         IF ( inta>=225 .AND. inta<=250 ) inta = inta - 32
         IF ( intb>=225 .AND. intb<=250 ) intb = intb - 32
      ENDIF
      LSAME = inta==intb
!
!     RETURN
!
!     End of LSAME
!
      END FUNCTION LSAME
!*==DGEMM.spg  processed by SPAG 6.55Dc at 12:01 on  5 Feb 2004
!****************************************************************************
! This file contains the BLAS routines that are called by LAPACK routines
! for inversion of a matrix. The Lapack routines (NOT in this file!) are:
!         dgetf2  dgetrf  dgetri  dlaswp  dtrti2  dtrtri  ilaenv  lsame
!
! The BLAS routines (in this file) are:
!         dgemm   dger    dswap   dtrmv   idamax
!         dgemv   dscal   dtrmm   dtrsm   xerbla
!
! Instead of these routines you can better use a processor-optimized
! library (like INTEL mkl library).
!
!       J. Bergervoet
!       May, 1998
!****************************************************************************
 
      SUBROUTINE DGEMM(Transa,Transb,M,N,K,Alpha,A,Lda,B,Ldb,Beta,C,Ldc)
      USE S_LSAME
      USE S_XERBLA
      IMPLICIT NONE
!*--********************************************************************
!A PASSED - TRANSA
!A PASSED - TRANSB
!A INPUT  - M
!A INPUT  - N
!A INPUT  - K
!A INPUT  - ALPHA
!A INPUT  - A
!A INPUT  - LDA
!A INPUT  - B
!A INPUT  - LDB
!A INPUT  - BETA
!A OUTPUT - C
!A INPUT  - LDC
! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
! calls       LSAME    XERBLA
! called by   DGETRF   DGETRI
! modifies    ** NOTHING **
! uses value  ** NOTHING **
! local vars  I        INFO     J        L        NCOLA    NOTA
!             NOTB     NROWA    NROWB    TEMP
! uses PARAMs ONE      ZERO
!*++********************************************************************
!
!*** Start of declarations rewritten by SPAG
!
! PARAMETER definitions
!
      DOUBLE PRECISION , PARAMETER :: ONE = 1.0D+0 , ZERO = 0.0D+0
!
! Dummy arguments
!
      DOUBLE PRECISION :: Alpha , Beta
      INTEGER :: K , Lda , Ldb , Ldc , M , N
      CHARACTER(1) :: Transa , Transb
      DOUBLE PRECISION , DIMENSION(Lda,*) :: A
      DOUBLE PRECISION , DIMENSION(Ldb,*) :: B
      DOUBLE PRECISION , DIMENSION(Ldc,*) :: C
      INTENT (IN) A , Alpha , B , Beta , K , Lda , Ldb , Ldc , M , N
      INTENT (INOUT) C
!
! Local variables
!
      INTEGER :: i , info , j , l , ncola , nrowa , nrowb
      LOGICAL :: nota , notb
      DOUBLE PRECISION :: temp
!
!*** End of declarations rewritten by SPAG
!
!     .. Scalar Arguments ..
!     .. Array Arguments ..
!     ..
!
!  Purpose
!  =======
!
!  DGEMM  performs one of the matrix-matrix operations
!
!     C := alpha*op( A )*op( B ) + beta*C,
!
!  where  op( X ) is one of
!
!     op( X ) = X   or   op( X ) = X',
!
!  alpha and beta are scalars, and A, B and C are matrices, with op( A )
!  an m by k matrix,  op( B )  a  k by n matrix and  C an m by n matrix.
!
!  Parameters
!  ==========
!
!  TRANSA - CHARACTER*1.
!           On entry, TRANSA specifies the form of op( A ) to be used in
!           the matrix multiplication as follows:
!
!              TRANSA = 'N' or 'n',  op( A ) = A.
!
!              TRANSA = 'T' or 't',  op( A ) = A'.
!
!              TRANSA = 'C' or 'c',  op( A ) = A'.
!
!           Unchanged on exit.
!
!  TRANSB - CHARACTER*1.
!           On entry, TRANSB specifies the form of op( B ) to be used in
!           the matrix multiplication as follows:
!
!              TRANSB = 'N' or 'n',  op( B ) = B.
!
!              TRANSB = 'T' or 't',  op( B ) = B'.
!
!              TRANSB = 'C' or 'c',  op( B ) = B'.
!
!           Unchanged on exit.
!
!  M      - INTEGER.
!           On entry,  M  specifies  the number  of rows  of the  matrix
!           op( A )  and of the  matrix  C.  M  must  be at least  zero.
!           Unchanged on exit.
!
!  N      - INTEGER.
!           On entry,  N  specifies the number  of columns of the matrix
!           op( B ) and the number of columns of the matrix C. N must be
!           at least zero.
!           Unchanged on exit.
!
!  K      - INTEGER.
!           On entry,  K  specifies  the number of columns of the matrix
!           op( A ) and the number of rows of the matrix op( B ). K must
!           be at least  zero.
!           Unchanged on exit.
!
!  ALPHA  - DOUBLE PRECISION.
!           On entry, ALPHA specifies the scalar alpha.
!           Unchanged on exit.
!
!  A      - DOUBLE PRECISION array of DIMENSION ( LDA, ka ), where ka is
!           k  when  TRANSA = 'N' or 'n',  and is  m  otherwise.
!           Before entry with  TRANSA = 'N' or 'n',  the leading  m by k
!           part of the array  A  must contain the matrix  A,  otherwise
!           the leading  k by m  part of the array  A  must contain  the
!           matrix A.
!           Unchanged on exit.
!
!  LDA    - INTEGER.
!           On entry, LDA specifies the first dimension of A as declared
!           in the calling (sub) program. When  TRANSA = 'N' or 'n' then
!           LDA must be at least  max( 1, m ), otherwise  LDA must be at
!           least  max( 1, k ).
!           Unchanged on exit.
!
!  B      - DOUBLE PRECISION array of DIMENSION ( LDB, kb ), where kb is
!           n  when  TRANSB = 'N' or 'n',  and is  k  otherwise.
!           Before entry with  TRANSB = 'N' or 'n',  the leading  k by n
!           part of the array  B  must contain the matrix  B,  otherwise
!           the leading  n by k  part of the array  B  must contain  the
!           matrix B.
!           Unchanged on exit.
!
!  LDB    - INTEGER.
!           On entry, LDB specifies the first dimension of B as declared
!           in the calling (sub) program. When  TRANSB = 'N' or 'n' then
!           LDB must be at least  max( 1, k ), otherwise  LDB must be at
!           least  max( 1, n ).
!           Unchanged on exit.
!
!  BETA   - DOUBLE PRECISION.
!           On entry,  BETA  specifies the scalar  beta.  When  BETA  is
!           supplied as zero then C need not be set on input.
!           Unchanged on exit.
!
!  C      - DOUBLE PRECISION array of DIMENSION ( LDC, n ).
!           Before entry, the leading  m by n  part of the array  C must
!           contain the matrix  C,  except when  beta  is zero, in which
!           case C need not be set on entry.
!           On exit, the array  C  is overwritten by the  m by n  matrix
!           ( alpha*op( A )*op( B ) + beta*C ).
!
!  LDC    - INTEGER.
!           On entry, LDC specifies the first dimension of C as declared
!           in  the  calling  (sub)  program.   LDC  must  be  at  least
!           max( 1, m ).
!           Unchanged on exit.
!
!
!  Level 3 Blas routine.
!
!  -- Written on 8-February-1989.
!     Jack Dongarra, Argonne National Laboratory.
!     Iain Duff, AERE Harwell.
!     Jeremy Du Croz, Numerical Algorithms Group Ltd.
!     Sven Hammarling, Numerical Algorithms Group Ltd.
!
!
!     .. External Functions ..
!     .. External Subroutines ..
!     .. Intrinsic Functions ..
!     .. Local Scalars ..
!     .. Parameters ..
!     ..
!     .. Executable Statements ..
!
!     Set  NOTA  and  NOTB  as  true if  A  and  B  respectively are not
!     transposed and set  NROWA, NCOLA and  NROWB  as the number of rows
!     and  columns of  A  and the  number of  rows  of  B  respectively.
!
      nota = LSAME(Transa,'N')
      notb = LSAME(Transb,'N')
      IF ( nota ) THEN
         nrowa = M
         ncola = K
      ELSE
         nrowa = K
         ncola = M
      ENDIF
      IF ( notb ) THEN
         nrowb = K
      ELSE
         nrowb = N
      ENDIF
!
!     Test the input parameters.
!
      info = 0
      IF ( (.NOT.nota) .AND. (.NOT.LSAME(Transa,'C')) .AND.             &
     &     (.NOT.LSAME(Transa,'T')) ) THEN
         info = 1
      ELSEIF ( (.NOT.notb) .AND. (.NOT.LSAME(Transb,'C')) .AND.         &
     &         (.NOT.LSAME(Transb,'T')) ) THEN
         info = 2
      ELSEIF ( M<0 ) THEN
         info = 3
      ELSEIF ( N<0 ) THEN
         info = 4
      ELSEIF ( K<0 ) THEN
         info = 5
      ELSEIF ( Lda<MAX(1,nrowa) ) THEN
         info = 8
      ELSEIF ( Ldb<MAX(1,nrowb) ) THEN
         info = 10
      ELSEIF ( Ldc<MAX(1,M) ) THEN
         info = 13
      ENDIF
      IF ( info/=0 ) THEN
         CALL XERBLA('DGEMM ',info)
         RETURN
      ENDIF
!
!     Quick return if possible.
!
      IF ( (M==0) .OR. (N==0) .OR.                                      &
     &     (((Alpha==ZERO) .OR. (K==0)) .AND. (Beta==ONE)) ) RETURN
!
!     And if  alpha.eq.zero.
!
      IF ( Alpha==ZERO ) THEN
         IF ( Beta==ZERO ) THEN
            DO j = 1 , N
               DO i = 1 , M
                  C(i,j) = ZERO
               ENDDO
            ENDDO
         ELSE
            DO j = 1 , N
               DO i = 1 , M
                  C(i,j) = Beta*C(i,j)
               ENDDO
            ENDDO
         ENDIF
         RETURN
      ENDIF
!
!     Start the operations.
!
      IF ( notb ) THEN
         IF ( nota ) THEN
!
!           Form  C := alpha*A*B + beta*C.
!
            DO j = 1 , N
               IF ( Beta==ZERO ) THEN
                  DO i = 1 , M
                     C(i,j) = ZERO
                  ENDDO
               ELSEIF ( Beta/=ONE ) THEN
                  DO i = 1 , M
                     C(i,j) = Beta*C(i,j)
                  ENDDO
               ENDIF
               DO l = 1 , K
                  IF ( B(l,j)/=ZERO ) THEN
                     temp = Alpha*B(l,j)
                     DO i = 1 , M
                        C(i,j) = C(i,j) + temp*A(i,l)
                     ENDDO
                  ENDIF
               ENDDO
            ENDDO
         ELSE
!
!           Form  C := alpha*A'*B + beta*C
!
            DO j = 1 , N
               DO i = 1 , M
                  temp = ZERO
                  DO l = 1 , K
                     temp = temp + A(l,i)*B(l,j)
                  ENDDO
                  IF ( Beta==ZERO ) THEN
                     C(i,j) = Alpha*temp
                  ELSE
                     C(i,j) = Alpha*temp + Beta*C(i,j)
                  ENDIF
               ENDDO
            ENDDO
         ENDIF
      ELSEIF ( nota ) THEN
!
!           Form  C := alpha*A*B' + beta*C
!
         DO j = 1 , N
            IF ( Beta==ZERO ) THEN
               DO i = 1 , M
                  C(i,j) = ZERO
               ENDDO
            ELSEIF ( Beta/=ONE ) THEN
               DO i = 1 , M
                  C(i,j) = Beta*C(i,j)
               ENDDO
            ENDIF
            DO l = 1 , K
               IF ( B(j,l)/=ZERO ) THEN
                  temp = Alpha*B(j,l)
                  DO i = 1 , M
                     C(i,j) = C(i,j) + temp*A(i,l)
                  ENDDO
               ENDIF
            ENDDO
         ENDDO
      ELSE
!
!           Form  C := alpha*A'*B' + beta*C
!
         DO j = 1 , N
            DO i = 1 , M
               temp = ZERO
               DO l = 1 , K
                  temp = temp + A(l,i)*B(j,l)
               ENDDO
               IF ( Beta==ZERO ) THEN
                  C(i,j) = Alpha*temp
               ELSE
                  C(i,j) = Alpha*temp + Beta*C(i,j)
               ENDIF
            ENDDO
         ENDDO
      ENDIF
!
!
!     End of DGEMM .
!
      END SUBROUTINE DGEMM
!*==DGEMV.spg  processed by SPAG 6.55Dc at 12:01 on  5 Feb 2004
      SUBROUTINE DGEMV(Trans,M,N,Alpha,A,Lda,X,Incx,Beta,Y,Incy)
      USE S_LSAME
      USE S_XERBLA
      IMPLICIT NONE
!*--********************************************************************
!A PASSED - TRANS
!A INPUT  - M
!A INPUT  - N
!A INPUT  - ALPHA
!A INPUT  - A
!A INPUT  - LDA
!A INPUT  - X
!A INPUT  - INCX
!A INPUT  - BETA
!A OUTPUT - Y
!A INPUT  - INCY
! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
! calls       LSAME    XERBLA
! called by   DGETRI
! modifies    ** NOTHING **
! uses value  ** NOTHING **
! local vars  I        INFO     IX       IY       J        JX       JY
!             KX       KY       LENX     LENY     TEMP
! uses PARAMs ONE      ZERO
!*++********************************************************************
!
!*** Start of declarations rewritten by SPAG
!
! PARAMETER definitions
!
      DOUBLE PRECISION , PARAMETER :: ONE = 1.0D+0 , ZERO = 0.0D+0
!
! Dummy arguments
!
      DOUBLE PRECISION :: Alpha , Beta
      INTEGER :: Incx , Incy , Lda , M , N
      CHARACTER(1) :: Trans
      DOUBLE PRECISION , DIMENSION(Lda,*) :: A
      DOUBLE PRECISION , DIMENSION(*) :: X , Y
      INTENT (IN) A , Alpha , Beta , Incx , Incy , Lda , M , N , X
      INTENT (INOUT) Y
!
! Local variables
!
      INTEGER :: i , info , ix , iy , j , jx , jy , kx , ky , lenx ,    &
     &           leny
      DOUBLE PRECISION :: temp
!
!*** End of declarations rewritten by SPAG
!
!     .. Scalar Arguments ..
!     .. Array Arguments ..
!     ..
!
!  Purpose
!  =======
!
!  DGEMV  performs one of the matrix-vector operations
!
!     y := alpha*A*x + beta*y,   or   y := alpha*A'*x + beta*y,
!
!  where alpha and beta are scalars, x and y are vectors and A is an
!  m by n matrix.
!
!  Parameters
!  ==========
!
!  TRANS  - CHARACTER*1.
!           On entry, TRANS specifies the operation to be performed as
!           follows:
!
!              TRANS = 'N' or 'n'   y := alpha*A*x + beta*y.
!
!              TRANS = 'T' or 't'   y := alpha*A'*x + beta*y.
!
!              TRANS = 'C' or 'c'   y := alpha*A'*x + beta*y.
!
!           Unchanged on exit.
!
!  M      - INTEGER.
!           On entry, M specifies the number of rows of the matrix A.
!           M must be at least zero.
!           Unchanged on exit.
!
!  N      - INTEGER.
!           On entry, N specifies the number of columns of the matrix A.
!           N must be at least zero.
!           Unchanged on exit.
!
!  ALPHA  - DOUBLE PRECISION.
!           On entry, ALPHA specifies the scalar alpha.
!           Unchanged on exit.
!
!  A      - DOUBLE PRECISION array of DIMENSION ( LDA, n ).
!           Before entry, the leading m by n part of the array A must
!           contain the matrix of coefficients.
!           Unchanged on exit.
!
!  LDA    - INTEGER.
!           On entry, LDA specifies the first dimension of A as declared
!           in the calling (sub) program. LDA must be at least
!           max( 1, m ).
!           Unchanged on exit.
!
!  X      - DOUBLE PRECISION array of DIMENSION at least
!           ( 1 + ( n - 1 )*abs( INCX ) ) when TRANS = 'N' or 'n'
!           and at least
!           ( 1 + ( m - 1 )*abs( INCX ) ) otherwise.
!           Before entry, the incremented array X must contain the
!           vector x.
!           Unchanged on exit.
!
!  INCX   - INTEGER.
!           On entry, INCX specifies the increment for the elements of
!           X. INCX must not be zero.
!           Unchanged on exit.
!
!  BETA   - DOUBLE PRECISION.
!           On entry, BETA specifies the scalar beta. When BETA is
!           supplied as zero then Y need not be set on input.
!           Unchanged on exit.
!
!  Y      - DOUBLE PRECISION array of DIMENSION at least
!           ( 1 + ( m - 1 )*abs( INCY ) ) when TRANS = 'N' or 'n'
!           and at least
!           ( 1 + ( n - 1 )*abs( INCY ) ) otherwise.
!           Before entry with BETA non-zero, the incremented array Y
!           must contain the vector y. On exit, Y is overwritten by the
!           updated vector y.
!
!  INCY   - INTEGER.
!           On entry, INCY specifies the increment for the elements of
!           Y. INCY must not be zero.
!           Unchanged on exit.
!
!
!  Level 2 Blas routine.
!
!  -- Written on 22-October-1986.
!     Jack Dongarra, Argonne National Lab.
!     Jeremy Du Croz, Nag Central Office.
!     Sven Hammarling, Nag Central Office.
!     Richard Hanson, Sandia National Labs.
!
!
!     .. Parameters ..
!     .. Local Scalars ..
!     .. External Functions ..
!     .. External Subroutines ..
!     .. Intrinsic Functions ..
!     ..
!     .. Executable Statements ..
!
!     Test the input parameters.
!
      info = 0
      IF ( .NOT.LSAME(Trans,'N') .AND. .NOT.LSAME(Trans,'T') .AND.      &
     &     .NOT.LSAME(Trans,'C') ) THEN
         info = 1
      ELSEIF ( M<0 ) THEN
         info = 2
      ELSEIF ( N<0 ) THEN
         info = 3
      ELSEIF ( Lda<MAX(1,M) ) THEN
         info = 6
      ELSEIF ( Incx==0 ) THEN
         info = 8
      ELSEIF ( Incy==0 ) THEN
         info = 11
      ENDIF
      IF ( info/=0 ) THEN
         CALL XERBLA('DGEMV ',info)
         RETURN
      ENDIF
!
!     Quick return if possible.
!
      IF ( (M==0) .OR. (N==0) .OR. ((Alpha==ZERO) .AND. (Beta==ONE)) )  &
     &     RETURN
!
!     Set  LENX  and  LENY, the lengths of the vectors x and y, and set
!     up the start points in  X  and  Y.
!
      IF ( LSAME(Trans,'N') ) THEN
         lenx = N
         leny = M
      ELSE
         lenx = M
         leny = N
      ENDIF
      IF ( Incx>0 ) THEN
         kx = 1
      ELSE
         kx = 1 - (lenx-1)*Incx
      ENDIF
      IF ( Incy>0 ) THEN
         ky = 1
      ELSE
         ky = 1 - (leny-1)*Incy
      ENDIF
!
!     Start the operations. In this version the elements of A are
!     accessed sequentially with one pass through A.
!
!     First form  y := beta*y.
!
      IF ( Beta/=ONE ) THEN
         IF ( Incy/=1 ) THEN
            iy = ky
            IF ( Beta==ZERO ) THEN
               DO i = 1 , leny
                  Y(iy) = ZERO
                  iy = iy + Incy
               ENDDO
            ELSE
               DO i = 1 , leny
                  Y(iy) = Beta*Y(iy)
                  iy = iy + Incy
               ENDDO
            ENDIF
         ELSEIF ( Beta==ZERO ) THEN
            DO i = 1 , leny
               Y(i) = ZERO
            ENDDO
         ELSE
            DO i = 1 , leny
               Y(i) = Beta*Y(i)
            ENDDO
         ENDIF
      ENDIF
      IF ( Alpha==ZERO ) RETURN
      IF ( LSAME(Trans,'N') ) THEN
!
!        Form  y := alpha*A*x + y.
!
         jx = kx
         IF ( Incy==1 ) THEN
            DO j = 1 , N
               IF ( X(jx)/=ZERO ) THEN
                  temp = Alpha*X(jx)
                  DO i = 1 , M
                     Y(i) = Y(i) + temp*A(i,j)
                  ENDDO
               ENDIF
               jx = jx + Incx
            ENDDO
         ELSE
            DO j = 1 , N
               IF ( X(jx)/=ZERO ) THEN
                  temp = Alpha*X(jx)
                  iy = ky
                  DO i = 1 , M
                     Y(iy) = Y(iy) + temp*A(i,j)
                     iy = iy + Incy
                  ENDDO
               ENDIF
               jx = jx + Incx
            ENDDO
         ENDIF
      ELSE
!
!        Form  y := alpha*A'*x + y.
!
         jy = ky
         IF ( Incx==1 ) THEN
            DO j = 1 , N
               temp = ZERO
               DO i = 1 , M
                  temp = temp + A(i,j)*X(i)
               ENDDO
               Y(jy) = Y(jy) + Alpha*temp
               jy = jy + Incy
            ENDDO
         ELSE
            DO j = 1 , N
               temp = ZERO
               ix = kx
               DO i = 1 , M
                  temp = temp + A(i,j)*X(ix)
                  ix = ix + Incx
               ENDDO
               Y(jy) = Y(jy) + Alpha*temp
               jy = jy + Incy
            ENDDO
         ENDIF
      ENDIF
!
!
!     End of DGEMV .
!
      END SUBROUTINE DGEMV
!*==DGER.spg  processed by SPAG 6.55Dc at 12:01 on  5 Feb 2004
      SUBROUTINE DGER(M,N,Alpha,X,Incx,Y,Incy,A,Lda)
      USE S_XERBLA
      IMPLICIT NONE
!*--********************************************************************
!A INPUT  - M
!A INPUT  - N
!A INPUT  - ALPHA
!A INPUT  - X
!A INPUT  - INCX
!A INPUT  - Y
!A INPUT  - INCY
!A OUTPUT - A
!A INPUT  - LDA
! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
! calls       XERBLA
! called by   DGETF2
! modifies    ** NOTHING **
! uses value  ** NOTHING **
! local vars  I        INFO     IX       J        JY       KX
!             TEMP
! uses PARAMs ZERO
!*++********************************************************************
!
!*** Start of declarations rewritten by SPAG
!
! PARAMETER definitions
!
      DOUBLE PRECISION , PARAMETER :: ZERO = 0.0D+0
!
! Dummy arguments
!
      DOUBLE PRECISION :: Alpha
      INTEGER :: Incx , Incy , Lda , M , N
      DOUBLE PRECISION , DIMENSION(Lda,*) :: A
      DOUBLE PRECISION , DIMENSION(*) :: X , Y
      INTENT (IN) Alpha , Incx , Incy , Lda , M , N , X , Y
      INTENT (INOUT) A
!
! Local variables
!
      INTEGER :: i , info , ix , j , jy , kx
      DOUBLE PRECISION :: temp
!
!*** End of declarations rewritten by SPAG
!
!     .. Scalar Arguments ..
!     .. Array Arguments ..
!     ..
!
!  Purpose
!  =======
!
!  DGER   performs the rank 1 operation
!
!     A := alpha*x*y' + A,
!
!  where alpha is a scalar, x is an m element vector, y is an n element
!  vector and A is an m by n matrix.
!
!  Parameters
!  ==========
!
!  M      - INTEGER.
!           On entry, M specifies the number of rows of the matrix A.
!           M must be at least zero.
!           Unchanged on exit.
!
!  N      - INTEGER.
!           On entry, N specifies the number of columns of the matrix A.
!           N must be at least zero.
!           Unchanged on exit.
!
!  ALPHA  - DOUBLE PRECISION.
!           On entry, ALPHA specifies the scalar alpha.
!           Unchanged on exit.
!
!  X      - DOUBLE PRECISION array of dimension at least
!           ( 1 + ( m - 1 )*abs( INCX ) ).
!           Before entry, the incremented array X must contain the m
!           element vector x.
!           Unchanged on exit.
!
!  INCX   - INTEGER.
!           On entry, INCX specifies the increment for the elements of
!           X. INCX must not be zero.
!           Unchanged on exit.
!
!  Y      - DOUBLE PRECISION array of dimension at least
!           ( 1 + ( n - 1 )*abs( INCY ) ).
!           Before entry, the incremented array Y must contain the n
!           element vector y.
!           Unchanged on exit.
!
!  INCY   - INTEGER.
!           On entry, INCY specifies the increment for the elements of
!           Y. INCY must not be zero.
!           Unchanged on exit.
!
!  A      - DOUBLE PRECISION array of DIMENSION ( LDA, n ).
!           Before entry, the leading m by n part of the array A must
!           contain the matrix of coefficients. On exit, A is
!           overwritten by the updated matrix.
!
!  LDA    - INTEGER.
!           On entry, LDA specifies the first dimension of A as declared
!           in the calling (sub) program. LDA must be at least
!           max( 1, m ).
!           Unchanged on exit.
!
!
!  Level 2 Blas routine.
!
!  -- Written on 22-October-1986.
!     Jack Dongarra, Argonne National Lab.
!     Jeremy Du Croz, Nag Central Office.
!     Sven Hammarling, Nag Central Office.
!     Richard Hanson, Sandia National Labs.
!
!
!     .. Parameters ..
!     .. Local Scalars ..
!     .. External Subroutines ..
!     .. Intrinsic Functions ..
!     ..
!     .. Executable Statements ..
!
!     Test the input parameters.
!
      info = 0
      IF ( M<0 ) THEN
         info = 1
      ELSEIF ( N<0 ) THEN
         info = 2
      ELSEIF ( Incx==0 ) THEN
         info = 5
      ELSEIF ( Incy==0 ) THEN
         info = 7
      ELSEIF ( Lda<MAX(1,M) ) THEN
         info = 9
      ENDIF
      IF ( info/=0 ) THEN
         CALL XERBLA('DGER  ',info)
         RETURN
      ENDIF
!
!     Quick return if possible.
!
      IF ( (M==0) .OR. (N==0) .OR. (Alpha==ZERO) ) RETURN
!
!     Start the operations. In this version the elements of A are
!     accessed sequentially with one pass through A.
!
      IF ( Incy>0 ) THEN
         jy = 1
      ELSE
         jy = 1 - (N-1)*Incy
      ENDIF
      IF ( Incx==1 ) THEN
         DO j = 1 , N
            IF ( Y(jy)/=ZERO ) THEN
               temp = Alpha*Y(jy)
               DO i = 1 , M
                  A(i,j) = A(i,j) + X(i)*temp
               ENDDO
            ENDIF
            jy = jy + Incy
         ENDDO
      ELSE
         IF ( Incx>0 ) THEN
            kx = 1
         ELSE
            kx = 1 - (M-1)*Incx
         ENDIF
         DO j = 1 , N
            IF ( Y(jy)/=ZERO ) THEN
               temp = Alpha*Y(jy)
               ix = kx
               DO i = 1 , M
                  A(i,j) = A(i,j) + X(ix)*temp
                  ix = ix + Incx
               ENDDO
            ENDIF
            jy = jy + Incy
         ENDDO
      ENDIF
!
!
!     End of DGER  .
!
      END SUBROUTINE DGER
!*==DSCAL.spg  processed by SPAG 6.55Dc at 12:01 on  5 Feb 2004
      SUBROUTINE DSCAL(N,Da,Dx,Incx)
      IMPLICIT NONE
!*--********************************************************************
!A INPUT  - N
!A INPUT  - DA
!A OUTPUT - DX
!A INPUT  - INCX
! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
! calls       ** NOTHING **
! called by   DGETF2   DTRTI2
! modifies    ** NOTHING **
! uses value  ** NOTHING **
! local vars  I        M        MP1      NINCX
! uses PARAMs *** NONE ****
!*++********************************************************************
!
!*** Start of declarations rewritten by SPAG
!
! Dummy arguments
!
      DOUBLE PRECISION :: Da
      INTEGER :: Incx , N
      DOUBLE PRECISION , DIMENSION(*) :: Dx
      INTENT (IN) Da , Incx , N
      INTENT (INOUT) Dx
!
! Local variables
!
      INTEGER :: i , m , mp1 , nincx
!
!*** End of declarations rewritten by SPAG
!
!
!     scales a vector by a constant.
!     uses unrolled loops for increment equal to one.
!     jack dongarra, linpack, 3/11/78.
!     modified 3/93 to return if incx .le. 0.
!     modified 12/3/93, array(1) declarations changed to array(*)
!
!
      IF ( N<=0 .OR. Incx<=0 ) RETURN
      IF ( Incx==1 ) THEN
!
!        code for increment equal to 1
!
!
!        clean-up loop
!
         m = MOD(N,5)
         IF ( m/=0 ) THEN
            DO i = 1 , m
               Dx(i) = Da*Dx(i)
            ENDDO
            IF ( N<5 ) RETURN
         ENDIF
         mp1 = m + 1
         DO i = mp1 , N , 5
            Dx(i) = Da*Dx(i)
            Dx(i+1) = Da*Dx(i+1)
            Dx(i+2) = Da*Dx(i+2)
            Dx(i+3) = Da*Dx(i+3)
            Dx(i+4) = Da*Dx(i+4)
         ENDDO
      ELSE
!
!        code for increment not equal to 1
!
         nincx = N*Incx
         DO i = 1 , nincx , Incx
            Dx(i) = Da*Dx(i)
         ENDDO
         RETURN
      ENDIF
      END SUBROUTINE DSCAL
!*==DSWAP.spg  processed by SPAG 6.55Dc at 12:01 on  5 Feb 2004
      SUBROUTINE DSWAP(N,Dx,Incx,Dy,Incy)
      IMPLICIT NONE
!*--********************************************************************
!A INPUT  - N
!A OUTPUT - DX
!A INPUT  - INCX
!A OUTPUT - DY
!A INPUT  - INCY
! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
! calls       ** NOTHING **
! called by   DGETF2   DGETRI   DLASWP
! modifies    ** NOTHING **
! uses value  ** NOTHING **
! local vars  DTEMP    I        IX       IY       M        MP1
! uses PARAMs *** NONE ****
!*++********************************************************************
!
!*** Start of declarations rewritten by SPAG
!
! Dummy arguments
!
      INTEGER :: Incx , Incy , N
      DOUBLE PRECISION , DIMENSION(*) :: Dx , Dy
      INTENT (IN) Incx , Incy , N
      INTENT (INOUT) Dx , Dy
!
! Local variables
!
      DOUBLE PRECISION :: dtemp
      INTEGER :: i , ix , iy , m , mp1
!
!*** End of declarations rewritten by SPAG
!
!
!     interchanges two vectors.
!     uses unrolled loops for increments equal one.
!     jack dongarra, linpack, 3/11/78.
!     modified 12/3/93, array(1) declarations changed to array(*)
!
!
      IF ( N<=0 ) RETURN
      IF ( Incx==1 .AND. Incy==1 ) THEN
!
!       code for both increments equal to 1
!
!
!       clean-up loop
!
         m = MOD(N,3)
         IF ( m/=0 ) THEN
            DO i = 1 , m
               dtemp = Dx(i)
               Dx(i) = Dy(i)
               Dy(i) = dtemp
            ENDDO
            IF ( N<3 ) RETURN
         ENDIF
         mp1 = m + 1
         DO i = mp1 , N , 3
            dtemp = Dx(i)
            Dx(i) = Dy(i)
            Dy(i) = dtemp
            dtemp = Dx(i+1)
            Dx(i+1) = Dy(i+1)
            Dy(i+1) = dtemp
            dtemp = Dx(i+2)
            Dx(i+2) = Dy(i+2)
            Dy(i+2) = dtemp
         ENDDO
      ELSE
!
!       code for unequal increments or equal increments not equal
!         to 1
!
         ix = 1
         iy = 1
         IF ( Incx<0 ) ix = (-N+1)*Incx + 1
         IF ( Incy<0 ) iy = (-N+1)*Incy + 1
         DO i = 1 , N
            dtemp = Dx(ix)
            Dx(ix) = Dy(iy)
            Dy(iy) = dtemp
            ix = ix + Incx
            iy = iy + Incy
         ENDDO
         RETURN
      ENDIF
      END SUBROUTINE DSWAP
!*==DTRMM.spg  processed by SPAG 6.55Dc at 12:01 on  5 Feb 2004
      SUBROUTINE DTRMM(Side,Uplo,Transa,Diag,M,N,Alpha,A,Lda,B,Ldb)
      USE S_LSAME
      USE S_XERBLA
      IMPLICIT NONE
!*--********************************************************************
!A PASSED - SIDE
!A PASSED - UPLO
!A PASSED - TRANSA
!A PASSED - DIAG
!A INPUT  - M
!A INPUT  - N
!A INPUT  - ALPHA
!A INPUT  - A
!A INPUT  - LDA
!A OUTPUT - B
!A INPUT  - LDB
! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
! calls       LSAME    XERBLA
! called by   DTRTRI
! modifies    ** NOTHING **
! uses value  ** NOTHING **
! local vars  I        INFO     J        K        LSIDE    NOUNIT
!             NROWA    TEMP     UPPER
! uses PARAMs ONE      ZERO
!*++********************************************************************
!
!*** Start of declarations rewritten by SPAG
!
! PARAMETER definitions
!
      DOUBLE PRECISION , PARAMETER :: ONE = 1.0D+0 , ZERO = 0.0D+0
!
! Dummy arguments
!
      DOUBLE PRECISION :: Alpha
      CHARACTER(1) :: Diag , Side , Transa , Uplo
      INTEGER :: Lda , Ldb , M , N
      DOUBLE PRECISION , DIMENSION(Lda,*) :: A
      DOUBLE PRECISION , DIMENSION(Ldb,*) :: B
      INTENT (IN) A , Alpha , Lda , Ldb , M , N
      INTENT (INOUT) B
!
! Local variables
!
      INTEGER :: i , info , j , k , nrowa
      LOGICAL :: lside , nounit , upper
      DOUBLE PRECISION :: temp
!
!*** End of declarations rewritten by SPAG
!
!     .. Scalar Arguments ..
!     .. Array Arguments ..
!     ..
!
!  Purpose
!  =======
!
!  DTRMM  performs one of the matrix-matrix operations
!
!     B := alpha*op( A )*B,   or   B := alpha*B*op( A ),
!
!  where  alpha  is a scalar,  B  is an m by n matrix,  A  is a unit, or
!  non-unit,  upper or lower triangular matrix  and  op( A )  is one  of
!
!     op( A ) = A   or   op( A ) = A'.
!
!  Parameters
!  ==========
!
!  SIDE   - CHARACTER*1.
!           On entry,  SIDE specifies whether  op( A ) multiplies B from
!           the left or right as follows:
!
!              SIDE = 'L' or 'l'   B := alpha*op( A )*B.
!
!              SIDE = 'R' or 'r'   B := alpha*B*op( A ).
!
!           Unchanged on exit.
!
!  UPLO   - CHARACTER*1.
!           On entry, UPLO specifies whether the matrix A is an upper or
!           lower triangular matrix as follows:
!
!              UPLO = 'U' or 'u'   A is an upper triangular matrix.
!
!              UPLO = 'L' or 'l'   A is a lower triangular matrix.
!
!           Unchanged on exit.
!
!  TRANSA - CHARACTER*1.
!           On entry, TRANSA specifies the form of op( A ) to be used in
!           the matrix multiplication as follows:
!
!              TRANSA = 'N' or 'n'   op( A ) = A.
!
!              TRANSA = 'T' or 't'   op( A ) = A'.
!
!              TRANSA = 'C' or 'c'   op( A ) = A'.
!
!           Unchanged on exit.
!
!  DIAG   - CHARACTER*1.
!           On entry, DIAG specifies whether or not A is unit triangular
!           as follows:
!
!              DIAG = 'U' or 'u'   A is assumed to be unit triangular.
!
!              DIAG = 'N' or 'n'   A is not assumed to be unit
!                                  triangular.
!
!           Unchanged on exit.
!
!  M      - INTEGER.
!           On entry, M specifies the number of rows of B. M must be at
!           least zero.
!           Unchanged on exit.
!
!  N      - INTEGER.
!           On entry, N specifies the number of columns of B.  N must be
!           at least zero.
!           Unchanged on exit.
!
!  ALPHA  - DOUBLE PRECISION.
!           On entry,  ALPHA specifies the scalar  alpha. When  alpha is
!           zero then  A is not referenced and  B need not be set before
!           entry.
!           Unchanged on exit.
!
!  A      - DOUBLE PRECISION array of DIMENSION ( LDA, k ), where k is m
!           when  SIDE = 'L' or 'l'  and is  n  when  SIDE = 'R' or 'r'.
!           Before entry  with  UPLO = 'U' or 'u',  the  leading  k by k
!           upper triangular part of the array  A must contain the upper
!           triangular matrix  and the strictly lower triangular part of
!           A is not referenced.
!           Before entry  with  UPLO = 'L' or 'l',  the  leading  k by k
!           lower triangular part of the array  A must contain the lower
!           triangular matrix  and the strictly upper triangular part of
!           A is not referenced.
!           Note that when  DIAG = 'U' or 'u',  the diagonal elements of
!           A  are not referenced either,  but are assumed to be  unity.
!           Unchanged on exit.
!
!  LDA    - INTEGER.
!           On entry, LDA specifies the first dimension of A as declared
!           in the calling (sub) program.  When  SIDE = 'L' or 'l'  then
!           LDA  must be at least  max( 1, m ),  when  SIDE = 'R' or 'r'
!           then LDA must be at least max( 1, n ).
!           Unchanged on exit.
!
!  B      - DOUBLE PRECISION array of DIMENSION ( LDB, n ).
!           Before entry,  the leading  m by n part of the array  B must
!           contain the matrix  B,  and  on exit  is overwritten  by the
!           transformed matrix.
!
!  LDB    - INTEGER.
!           On entry, LDB specifies the first dimension of B as declared
!           in  the  calling  (sub)  program.   LDB  must  be  at  least
!           max( 1, m ).
!           Unchanged on exit.
!
!
!  Level 3 Blas routine.
!
!  -- Written on 8-February-1989.
!     Jack Dongarra, Argonne National Laboratory.
!     Iain Duff, AERE Harwell.
!     Jeremy Du Croz, Numerical Algorithms Group Ltd.
!     Sven Hammarling, Numerical Algorithms Group Ltd.
!
!
!     .. External Functions ..
!     .. External Subroutines ..
!     .. Intrinsic Functions ..
!     .. Local Scalars ..
!     .. Parameters ..
!     ..
!     .. Executable Statements ..
!
!     Test the input parameters.
!
      lside = LSAME(Side,'L')
      IF ( lside ) THEN
         nrowa = M
      ELSE
         nrowa = N
      ENDIF
      nounit = LSAME(Diag,'N')
      upper = LSAME(Uplo,'U')
!
      info = 0
      IF ( (.NOT.lside) .AND. (.NOT.LSAME(Side,'R')) ) THEN
         info = 1
      ELSEIF ( (.NOT.upper) .AND. (.NOT.LSAME(Uplo,'L')) ) THEN
         info = 2
      ELSEIF ( (.NOT.LSAME(Transa,'N')) .AND. (.NOT.LSAME(Transa,'T'))  &
     &         .AND. (.NOT.LSAME(Transa,'C')) ) THEN
         info = 3
      ELSEIF ( (.NOT.LSAME(Diag,'U')) .AND. (.NOT.LSAME(Diag,'N')) )    &
     &         THEN
         info = 4
      ELSEIF ( M<0 ) THEN
         info = 5
      ELSEIF ( N<0 ) THEN
         info = 6
      ELSEIF ( Lda<MAX(1,nrowa) ) THEN
         info = 9
      ELSEIF ( Ldb<MAX(1,M) ) THEN
         info = 11
      ENDIF
      IF ( info/=0 ) THEN
         CALL XERBLA('DTRMM ',info)
         RETURN
      ENDIF
!
!     Quick return if possible.
!
      IF ( N==0 ) RETURN
!
!     And when  alpha.eq.zero.
!
      IF ( Alpha==ZERO ) THEN
         DO j = 1 , N
            DO i = 1 , M
               B(i,j) = ZERO
            ENDDO
         ENDDO
         RETURN
      ENDIF
!
!     Start the operations.
!
      IF ( lside ) THEN
         IF ( LSAME(Transa,'N') ) THEN
!
!           Form  B := alpha*A*B.
!
            IF ( upper ) THEN
               DO j = 1 , N
                  DO k = 1 , M
                     IF ( B(k,j)/=ZERO ) THEN
                        temp = Alpha*B(k,j)
                        DO i = 1 , k - 1
                           B(i,j) = B(i,j) + temp*A(i,k)
                        ENDDO
                        IF ( nounit ) temp = temp*A(k,k)
                        B(k,j) = temp
                     ENDIF
                  ENDDO
               ENDDO
            ELSE
               DO j = 1 , N
                  DO k = M , 1 , -1
                     IF ( B(k,j)/=ZERO ) THEN
                        temp = Alpha*B(k,j)
                        B(k,j) = temp
                        IF ( nounit ) B(k,j) = B(k,j)*A(k,k)
                        DO i = k + 1 , M
                           B(i,j) = B(i,j) + temp*A(i,k)
                        ENDDO
                     ENDIF
                  ENDDO
               ENDDO
            ENDIF
!
!           Form  B := alpha*B*A'.
!
         ELSEIF ( upper ) THEN
            DO j = 1 , N
               DO i = M , 1 , -1
                  temp = B(i,j)
                  IF ( nounit ) temp = temp*A(i,i)
                  DO k = 1 , i - 1
                     temp = temp + A(k,i)*B(k,j)
                  ENDDO
                  B(i,j) = Alpha*temp
               ENDDO
            ENDDO
         ELSE
            DO j = 1 , N
               DO i = 1 , M
                  temp = B(i,j)
                  IF ( nounit ) temp = temp*A(i,i)
                  DO k = i + 1 , M
                     temp = temp + A(k,i)*B(k,j)
                  ENDDO
                  B(i,j) = Alpha*temp
               ENDDO
            ENDDO
         ENDIF
      ELSEIF ( LSAME(Transa,'N') ) THEN
!
!           Form  B := alpha*B*A.
!
         IF ( upper ) THEN
            DO j = N , 1 , -1
               temp = Alpha
               IF ( nounit ) temp = temp*A(j,j)
               DO i = 1 , M
                  B(i,j) = temp*B(i,j)
               ENDDO
               DO k = 1 , j - 1
                  IF ( A(k,j)/=ZERO ) THEN
                     temp = Alpha*A(k,j)
                     DO i = 1 , M
                        B(i,j) = B(i,j) + temp*B(i,k)
                     ENDDO
                  ENDIF
               ENDDO
            ENDDO
         ELSE
            DO j = 1 , N
               temp = Alpha
               IF ( nounit ) temp = temp*A(j,j)
               DO i = 1 , M
                  B(i,j) = temp*B(i,j)
               ENDDO
               DO k = j + 1 , N
                  IF ( A(k,j)/=ZERO ) THEN
                     temp = Alpha*A(k,j)
                     DO i = 1 , M
                        B(i,j) = B(i,j) + temp*B(i,k)
                     ENDDO
                  ENDIF
               ENDDO
            ENDDO
         ENDIF
!
!           Form  B := alpha*B*A'.
!
      ELSEIF ( upper ) THEN
         DO k = 1 , N
            DO j = 1 , k - 1
               IF ( A(j,k)/=ZERO ) THEN
                  temp = Alpha*A(j,k)
                  DO i = 1 , M
                     B(i,j) = B(i,j) + temp*B(i,k)
                  ENDDO
               ENDIF
            ENDDO
            temp = Alpha
            IF ( nounit ) temp = temp*A(k,k)
            IF ( temp/=ONE ) THEN
               DO i = 1 , M
                  B(i,k) = temp*B(i,k)
               ENDDO
            ENDIF
         ENDDO
      ELSE
         DO k = N , 1 , -1
            DO j = k + 1 , N
               IF ( A(j,k)/=ZERO ) THEN
                  temp = Alpha*A(j,k)
                  DO i = 1 , M
                     B(i,j) = B(i,j) + temp*B(i,k)
                  ENDDO
               ENDIF
            ENDDO
            temp = Alpha
            IF ( nounit ) temp = temp*A(k,k)
            IF ( temp/=ONE ) THEN
               DO i = 1 , M
                  B(i,k) = temp*B(i,k)
               ENDDO
            ENDIF
         ENDDO
      ENDIF
!
!
!     End of DTRMM .
!
      END SUBROUTINE DTRMM
!*==DTRMV.spg  processed by SPAG 6.55Dc at 12:01 on  5 Feb 2004
      SUBROUTINE DTRMV(Uplo,Trans,Diag,N,A,Lda,X,Incx)
      USE S_LSAME
      USE S_XERBLA
      IMPLICIT NONE
!*--********************************************************************
!A PASSED - UPLO
!A PASSED - TRANS
!A PASSED - DIAG
!A INPUT  - N
!A INPUT  - A
!A INPUT  - LDA
!A OUTPUT - X
!A INPUT  - INCX
! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
! calls       LSAME    XERBLA
! called by   DTRTI2
! modifies    ** NOTHING **
! uses value  ** NOTHING **
! local vars  I        INFO     IX       J        JX       KX
!             NOUNIT   TEMP
! uses PARAMs ZERO
!*++********************************************************************
!
!*** Start of declarations rewritten by SPAG
!
! PARAMETER definitions
!
      DOUBLE PRECISION , PARAMETER :: ZERO = 0.0D+0
!
! Dummy arguments
!
      CHARACTER(1) :: Diag , Trans , Uplo
      INTEGER :: Incx , Lda , N
      DOUBLE PRECISION , DIMENSION(Lda,*) :: A
      DOUBLE PRECISION , DIMENSION(*) :: X
      INTENT (IN) A , Incx , Lda , N
      INTENT (INOUT) X
!
! Local variables
!
      INTEGER :: i , info , ix , j , jx , kx
      LOGICAL :: nounit
      DOUBLE PRECISION :: temp
!
!*** End of declarations rewritten by SPAG
!
!     .. Scalar Arguments ..
!     .. Array Arguments ..
!     ..
!
!  Purpose
!  =======
!
!  DTRMV  performs one of the matrix-vector operations
!
!     x := A*x,   or   x := A'*x,
!
!  where x is an n element vector and  A is an n by n unit, or non-unit,
!  upper or lower triangular matrix.
!
!  Parameters
!  ==========
!
!  UPLO   - CHARACTER*1.
!           On entry, UPLO specifies whether the matrix is an upper or
!           lower triangular matrix as follows:
!
!              UPLO = 'U' or 'u'   A is an upper triangular matrix.
!
!              UPLO = 'L' or 'l'   A is a lower triangular matrix.
!
!           Unchanged on exit.
!
!  TRANS  - CHARACTER*1.
!           On entry, TRANS specifies the operation to be performed as
!           follows:
!
!              TRANS = 'N' or 'n'   x := A*x.
!
!              TRANS = 'T' or 't'   x := A'*x.
!
!              TRANS = 'C' or 'c'   x := A'*x.
!
!           Unchanged on exit.
!
!  DIAG   - CHARACTER*1.
!           On entry, DIAG specifies whether or not A is unit
!           triangular as follows:
!
!              DIAG = 'U' or 'u'   A is assumed to be unit triangular.
!
!              DIAG = 'N' or 'n'   A is not assumed to be unit
!                                  triangular.
!
!           Unchanged on exit.
!
!  N      - INTEGER.
!           On entry, N specifies the order of the matrix A.
!           N must be at least zero.
!           Unchanged on exit.
!
!  A      - DOUBLE PRECISION array of DIMENSION ( LDA, n ).
!           Before entry with  UPLO = 'U' or 'u', the leading n by n
!           upper triangular part of the array A must contain the upper
!           triangular matrix and the strictly lower triangular part of
!           A is not referenced.
!           Before entry with UPLO = 'L' or 'l', the leading n by n
!           lower triangular part of the array A must contain the lower
!           triangular matrix and the strictly upper triangular part of
!           A is not referenced.
!           Note that when  DIAG = 'U' or 'u', the diagonal elements of
!           A are not referenced either, but are assumed to be unity.
!           Unchanged on exit.
!
!  LDA    - INTEGER.
!           On entry, LDA specifies the first dimension of A as declared
!           in the calling (sub) program. LDA must be at least
!           max( 1, n ).
!           Unchanged on exit.
!
!  X      - DOUBLE PRECISION array of dimension at least
!           ( 1 + ( n - 1 )*abs( INCX ) ).
!           Before entry, the incremented array X must contain the n
!           element vector x. On exit, X is overwritten with the
!           tranformed vector x.
!
!  INCX   - INTEGER.
!           On entry, INCX specifies the increment for the elements of
!           X. INCX must not be zero.
!           Unchanged on exit.
!
!
!  Level 2 Blas routine.
!
!  -- Written on 22-October-1986.
!     Jack Dongarra, Argonne National Lab.
!     Jeremy Du Croz, Nag Central Office.
!     Sven Hammarling, Nag Central Office.
!     Richard Hanson, Sandia National Labs.
!
!
!     .. Parameters ..
!     .. Local Scalars ..
!     .. External Functions ..
!     .. External Subroutines ..
!     .. Intrinsic Functions ..
!     ..
!     .. Executable Statements ..
!
!     Test the input parameters.
!
      info = 0
      IF ( .NOT.LSAME(Uplo,'U') .AND. .NOT.LSAME(Uplo,'L') ) THEN
         info = 1
      ELSEIF ( .NOT.LSAME(Trans,'N') .AND. .NOT.LSAME(Trans,'T') .AND.  &
     &         .NOT.LSAME(Trans,'C') ) THEN
         info = 2
      ELSEIF ( .NOT.LSAME(Diag,'U') .AND. .NOT.LSAME(Diag,'N') ) THEN
         info = 3
      ELSEIF ( N<0 ) THEN
         info = 4
      ELSEIF ( Lda<MAX(1,N) ) THEN
         info = 6
      ELSEIF ( Incx==0 ) THEN
         info = 8
      ENDIF
      IF ( info/=0 ) THEN
         CALL XERBLA('DTRMV ',info)
         RETURN
      ENDIF
!
!     Quick return if possible.
!
      IF ( N==0 ) RETURN
!
      nounit = LSAME(Diag,'N')
!
!     Set up the start point in X if the increment is not unity. This
!     will be  ( N - 1 )*INCX  too small for descending loops.
!
      IF ( Incx<=0 ) THEN
         kx = 1 - (N-1)*Incx
      ELSEIF ( Incx/=1 ) THEN
         kx = 1
      ENDIF
!
!     Start the operations. In this version the elements of A are
!     accessed sequentially with one pass through A.
!
      IF ( LSAME(Trans,'N') ) THEN
!
!        Form  x := A*x.
!
         IF ( LSAME(Uplo,'U') ) THEN
            IF ( Incx==1 ) THEN
               DO j = 1 , N
                  IF ( X(j)/=ZERO ) THEN
                     temp = X(j)
                     DO i = 1 , j - 1
                        X(i) = X(i) + temp*A(i,j)
                     ENDDO
                     IF ( nounit ) X(j) = X(j)*A(j,j)
                  ENDIF
               ENDDO
            ELSE
               jx = kx
               DO j = 1 , N
                  IF ( X(jx)/=ZERO ) THEN
                     temp = X(jx)
                     ix = kx
                     DO i = 1 , j - 1
                        X(ix) = X(ix) + temp*A(i,j)
                        ix = ix + Incx
                     ENDDO
                     IF ( nounit ) X(jx) = X(jx)*A(j,j)
                  ENDIF
                  jx = jx + Incx
               ENDDO
            ENDIF
         ELSEIF ( Incx==1 ) THEN
            DO j = N , 1 , -1
               IF ( X(j)/=ZERO ) THEN
                  temp = X(j)
                  DO i = N , j + 1 , -1
                     X(i) = X(i) + temp*A(i,j)
                  ENDDO
                  IF ( nounit ) X(j) = X(j)*A(j,j)
               ENDIF
            ENDDO
         ELSE
            kx = kx + (N-1)*Incx
            jx = kx
            DO j = N , 1 , -1
               IF ( X(jx)/=ZERO ) THEN
                  temp = X(jx)
                  ix = kx
                  DO i = N , j + 1 , -1
                     X(ix) = X(ix) + temp*A(i,j)
                     ix = ix - Incx
                  ENDDO
                  IF ( nounit ) X(jx) = X(jx)*A(j,j)
               ENDIF
               jx = jx - Incx
            ENDDO
         ENDIF
!
!        Form  x := A'*x.
!
      ELSEIF ( LSAME(Uplo,'U') ) THEN
         IF ( Incx==1 ) THEN
            DO j = N , 1 , -1
               temp = X(j)
               IF ( nounit ) temp = temp*A(j,j)
               DO i = j - 1 , 1 , -1
                  temp = temp + A(i,j)*X(i)
               ENDDO
               X(j) = temp
            ENDDO
         ELSE
            jx = kx + (N-1)*Incx
            DO j = N , 1 , -1
               temp = X(jx)
               ix = jx
               IF ( nounit ) temp = temp*A(j,j)
               DO i = j - 1 , 1 , -1
                  ix = ix - Incx
                  temp = temp + A(i,j)*X(ix)
               ENDDO
               X(jx) = temp
               jx = jx - Incx
            ENDDO
         ENDIF
      ELSEIF ( Incx==1 ) THEN
         DO j = 1 , N
            temp = X(j)
            IF ( nounit ) temp = temp*A(j,j)
            DO i = j + 1 , N
               temp = temp + A(i,j)*X(i)
            ENDDO
            X(j) = temp
         ENDDO
      ELSE
         jx = kx
         DO j = 1 , N
            temp = X(jx)
            ix = jx
            IF ( nounit ) temp = temp*A(j,j)
            DO i = j + 1 , N
               ix = ix + Incx
               temp = temp + A(i,j)*X(ix)
            ENDDO
            X(jx) = temp
            jx = jx + Incx
         ENDDO
      ENDIF
!
!
!     End of DTRMV .
!
      END SUBROUTINE DTRMV
!*==DTRSM.spg  processed by SPAG 6.55Dc at 12:01 on  5 Feb 2004
      SUBROUTINE DTRSM(Side,Uplo,Transa,Diag,M,N,Alpha,A,Lda,B,Ldb)
      USE S_LSAME
      USE S_XERBLA
      IMPLICIT NONE
!*--********************************************************************
!A PASSED - SIDE
!A PASSED - UPLO
!A PASSED - TRANSA
!A PASSED - DIAG
!A INPUT  - M
!A INPUT  - N
!A INPUT  - ALPHA
!A INPUT  - A
!A INPUT  - LDA
!A OUTPUT - B
!A INPUT  - LDB
! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
! calls       LSAME    XERBLA
! called by   DGETRF   DGETRI   DTRTRI
! modifies    ** NOTHING **
! uses value  ** NOTHING **
! local vars  I        INFO     J        K        LSIDE    NOUNIT
!             NROWA    TEMP     UPPER
! uses PARAMs ONE      ZERO
!*++********************************************************************
!
!*** Start of declarations rewritten by SPAG
!
! PARAMETER definitions
!
      DOUBLE PRECISION , PARAMETER :: ONE = 1.0D+0 , ZERO = 0.0D+0
!
! Dummy arguments
!
      DOUBLE PRECISION :: Alpha
      CHARACTER(1) :: Diag , Side , Transa , Uplo
      INTEGER :: Lda , Ldb , M , N
      DOUBLE PRECISION , DIMENSION(Lda,*) :: A
      DOUBLE PRECISION , DIMENSION(Ldb,*) :: B
      INTENT (IN) A , Alpha , Lda , Ldb , M , N
      INTENT (INOUT) B
!
! Local variables
!
      INTEGER :: i , info , j , k , nrowa
      LOGICAL :: lside , nounit , upper
      DOUBLE PRECISION :: temp
!
!*** End of declarations rewritten by SPAG
!
!     .. Scalar Arguments ..
!     .. Array Arguments ..
!     ..
!
!  Purpose
!  =======
!
!  DTRSM  solves one of the matrix equations
!
!     op( A )*X = alpha*B,   or   X*op( A ) = alpha*B,
!
!  where alpha is a scalar, X and B are m by n matrices, A is a unit, or
!  non-unit,  upper or lower triangular matrix  and  op( A )  is one  of
!
!     op( A ) = A   or   op( A ) = A'.
!
!  The matrix X is overwritten on B.
!
!  Parameters
!  ==========
!
!  SIDE   - CHARACTER*1.
!           On entry, SIDE specifies whether op( A ) appears on the left
!           or right of X as follows:
!
!              SIDE = 'L' or 'l'   op( A )*X = alpha*B.
!
!              SIDE = 'R' or 'r'   X*op( A ) = alpha*B.
!
!           Unchanged on exit.
!
!  UPLO   - CHARACTER*1.
!           On entry, UPLO specifies whether the matrix A is an upper or
!           lower triangular matrix as follows:
!
!              UPLO = 'U' or 'u'   A is an upper triangular matrix.
!
!              UPLO = 'L' or 'l'   A is a lower triangular matrix.
!
!           Unchanged on exit.
!
!  TRANSA - CHARACTER*1.
!           On entry, TRANSA specifies the form of op( A ) to be used in
!           the matrix multiplication as follows:
!
!              TRANSA = 'N' or 'n'   op( A ) = A.
!
!              TRANSA = 'T' or 't'   op( A ) = A'.
!
!              TRANSA = 'C' or 'c'   op( A ) = A'.
!
!           Unchanged on exit.
!
!  DIAG   - CHARACTER*1.
!           On entry, DIAG specifies whether or not A is unit triangular
!           as follows:
!
!              DIAG = 'U' or 'u'   A is assumed to be unit triangular.
!
!              DIAG = 'N' or 'n'   A is not assumed to be unit
!                                  triangular.
!
!           Unchanged on exit.
!
!  M      - INTEGER.
!           On entry, M specifies the number of rows of B. M must be at
!           least zero.
!           Unchanged on exit.
!
!  N      - INTEGER.
!           On entry, N specifies the number of columns of B.  N must be
!           at least zero.
!           Unchanged on exit.
!
!  ALPHA  - DOUBLE PRECISION.
!           On entry,  ALPHA specifies the scalar  alpha. When  alpha is
!           zero then  A is not referenced and  B need not be set before
!           entry.
!           Unchanged on exit.
!
!  A      - DOUBLE PRECISION array of DIMENSION ( LDA, k ), where k is m
!           when  SIDE = 'L' or 'l'  and is  n  when  SIDE = 'R' or 'r'.
!           Before entry  with  UPLO = 'U' or 'u',  the  leading  k by k
!           upper triangular part of the array  A must contain the upper
!           triangular matrix  and the strictly lower triangular part of
!           A is not referenced.
!           Before entry  with  UPLO = 'L' or 'l',  the  leading  k by k
!           lower triangular part of the array  A must contain the lower
!           triangular matrix  and the strictly upper triangular part of
!           A is not referenced.
!           Note that when  DIAG = 'U' or 'u',  the diagonal elements of
!           A  are not referenced either,  but are assumed to be  unity.
!           Unchanged on exit.
!
!  LDA    - INTEGER.
!           On entry, LDA specifies the first dimension of A as declared
!           in the calling (sub) program.  When  SIDE = 'L' or 'l'  then
!           LDA  must be at least  max( 1, m ),  when  SIDE = 'R' or 'r'
!           then LDA must be at least max( 1, n ).
!           Unchanged on exit.
!
!  B      - DOUBLE PRECISION array of DIMENSION ( LDB, n ).
!           Before entry,  the leading  m by n part of the array  B must
!           contain  the  right-hand  side  matrix  B,  and  on exit  is
!           overwritten by the solution matrix  X.
!
!  LDB    - INTEGER.
!           On entry, LDB specifies the first dimension of B as declared
!           in  the  calling  (sub)  program.   LDB  must  be  at  least
!           max( 1, m ).
!           Unchanged on exit.
!
!
!  Level 3 Blas routine.
!
!
!  -- Written on 8-February-1989.
!     Jack Dongarra, Argonne National Laboratory.
!     Iain Duff, AERE Harwell.
!     Jeremy Du Croz, Numerical Algorithms Group Ltd.
!     Sven Hammarling, Numerical Algorithms Group Ltd.
!
!
!     .. External Functions ..
!     .. External Subroutines ..
!     .. Intrinsic Functions ..
!     .. Local Scalars ..
!     .. Parameters ..
!     ..
!     .. Executable Statements ..
!
!     Test the input parameters.
!
      lside = LSAME(Side,'L')
      IF ( lside ) THEN
         nrowa = M
      ELSE
         nrowa = N
      ENDIF
      nounit = LSAME(Diag,'N')
      upper = LSAME(Uplo,'U')
!
      info = 0
      IF ( (.NOT.lside) .AND. (.NOT.LSAME(Side,'R')) ) THEN
         info = 1
      ELSEIF ( (.NOT.upper) .AND. (.NOT.LSAME(Uplo,'L')) ) THEN
         info = 2
      ELSEIF ( (.NOT.LSAME(Transa,'N')) .AND. (.NOT.LSAME(Transa,'T'))  &
     &         .AND. (.NOT.LSAME(Transa,'C')) ) THEN
         info = 3
      ELSEIF ( (.NOT.LSAME(Diag,'U')) .AND. (.NOT.LSAME(Diag,'N')) )    &
     &         THEN
         info = 4
      ELSEIF ( M<0 ) THEN
         info = 5
      ELSEIF ( N<0 ) THEN
         info = 6
      ELSEIF ( Lda<MAX(1,nrowa) ) THEN
         info = 9
      ELSEIF ( Ldb<MAX(1,M) ) THEN
         info = 11
      ENDIF
      IF ( info/=0 ) THEN
         CALL XERBLA('DTRSM ',info)
         RETURN
      ENDIF
!
!     Quick return if possible.
!
      IF ( N==0 ) RETURN
!
!     And when  alpha.eq.zero.
!
      IF ( Alpha==ZERO ) THEN
         DO j = 1 , N
            DO i = 1 , M
               B(i,j) = ZERO
            ENDDO
         ENDDO
         RETURN
      ENDIF
!
!     Start the operations.
!
      IF ( lside ) THEN
         IF ( LSAME(Transa,'N') ) THEN
!
!           Form  B := alpha*inv( A )*B.
!
            IF ( upper ) THEN
               DO j = 1 , N
                  IF ( Alpha/=ONE ) THEN
                     DO i = 1 , M
                        B(i,j) = Alpha*B(i,j)
                     ENDDO
                  ENDIF
                  DO k = M , 1 , -1
                     IF ( B(k,j)/=ZERO ) THEN
                        IF ( nounit ) B(k,j) = B(k,j)/A(k,k)
                        DO i = 1 , k - 1
                           B(i,j) = B(i,j) - B(k,j)*A(i,k)
                        ENDDO
                     ENDIF
                  ENDDO
               ENDDO
            ELSE
               DO j = 1 , N
                  IF ( Alpha/=ONE ) THEN
                     DO i = 1 , M
                        B(i,j) = Alpha*B(i,j)
                     ENDDO
                  ENDIF
                  DO k = 1 , M
                     IF ( B(k,j)/=ZERO ) THEN
                        IF ( nounit ) B(k,j) = B(k,j)/A(k,k)
                        DO i = k + 1 , M
                           B(i,j) = B(i,j) - B(k,j)*A(i,k)
                        ENDDO
                     ENDIF
                  ENDDO
               ENDDO
            ENDIF
!
!           Form  B := alpha*inv( A' )*B.
!
         ELSEIF ( upper ) THEN
            DO j = 1 , N
               DO i = 1 , M
                  temp = Alpha*B(i,j)
                  DO k = 1 , i - 1
                     temp = temp - A(k,i)*B(k,j)
                  ENDDO
                  IF ( nounit ) temp = temp/A(i,i)
                  B(i,j) = temp
               ENDDO
            ENDDO
         ELSE
            DO j = 1 , N
               DO i = M , 1 , -1
                  temp = Alpha*B(i,j)
                  DO k = i + 1 , M
                     temp = temp - A(k,i)*B(k,j)
                  ENDDO
                  IF ( nounit ) temp = temp/A(i,i)
                  B(i,j) = temp
               ENDDO
            ENDDO
         ENDIF
      ELSEIF ( LSAME(Transa,'N') ) THEN
!
!           Form  B := alpha*B*inv( A ).
!
         IF ( upper ) THEN
            DO j = 1 , N
               IF ( Alpha/=ONE ) THEN
                  DO i = 1 , M
                     B(i,j) = Alpha*B(i,j)
                  ENDDO
               ENDIF
               DO k = 1 , j - 1
                  IF ( A(k,j)/=ZERO ) THEN
                     DO i = 1 , M
                        B(i,j) = B(i,j) - A(k,j)*B(i,k)
                     ENDDO
                  ENDIF
               ENDDO
               IF ( nounit ) THEN
                  temp = ONE/A(j,j)
                  DO i = 1 , M
                     B(i,j) = temp*B(i,j)
                  ENDDO
               ENDIF
            ENDDO
         ELSE
            DO j = N , 1 , -1
               IF ( Alpha/=ONE ) THEN
                  DO i = 1 , M
                     B(i,j) = Alpha*B(i,j)
                  ENDDO
               ENDIF
               DO k = j + 1 , N
                  IF ( A(k,j)/=ZERO ) THEN
                     DO i = 1 , M
                        B(i,j) = B(i,j) - A(k,j)*B(i,k)
                     ENDDO
                  ENDIF
               ENDDO
               IF ( nounit ) THEN
                  temp = ONE/A(j,j)
                  DO i = 1 , M
                     B(i,j) = temp*B(i,j)
                  ENDDO
               ENDIF
            ENDDO
         ENDIF
!
!           Form  B := alpha*B*inv( A' ).
!
      ELSEIF ( upper ) THEN
         DO k = N , 1 , -1
            IF ( nounit ) THEN
               temp = ONE/A(k,k)
               DO i = 1 , M
                  B(i,k) = temp*B(i,k)
               ENDDO
            ENDIF
            DO j = 1 , k - 1
               IF ( A(j,k)/=ZERO ) THEN
                  temp = A(j,k)
                  DO i = 1 , M
                     B(i,j) = B(i,j) - temp*B(i,k)
                  ENDDO
               ENDIF
            ENDDO
            IF ( Alpha/=ONE ) THEN
               DO i = 1 , M
                  B(i,k) = Alpha*B(i,k)
               ENDDO
            ENDIF
         ENDDO
      ELSE
         DO k = 1 , N
            IF ( nounit ) THEN
               temp = ONE/A(k,k)
               DO i = 1 , M
                  B(i,k) = temp*B(i,k)
               ENDDO
            ENDIF
            DO j = k + 1 , N
               IF ( A(j,k)/=ZERO ) THEN
                  temp = A(j,k)
                  DO i = 1 , M
                     B(i,j) = B(i,j) - temp*B(i,k)
                  ENDDO
               ENDIF
            ENDDO
            IF ( Alpha/=ONE ) THEN
               DO i = 1 , M
                  B(i,k) = Alpha*B(i,k)
               ENDDO
            ENDIF
         ENDDO
      ENDIF
!
!
!     End of DTRSM .
!
      END SUBROUTINE DTRSM
!*==IDAMAX.spg  processed by SPAG 6.55Dc at 12:01 on  5 Feb 2004
      FUNCTION IDAMAX(N,Dx,Incx)
      IMPLICIT NONE
!*--********************************************************************
!A INPUT  - N
!A INPUT  - DX
!A INPUT  - INCX
! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
! calls       ** NOTHING **
! called by   DGETF2
! modifies    ** NOTHING **
! uses value  ** NOTHING **
! local vars  DMAX     I        IX
! uses PARAMs *** NONE ****
!*++********************************************************************
!
!*** Start of declarations rewritten by SPAG
!
! Dummy arguments
!
      INTEGER :: Incx , N
      DOUBLE PRECISION , DIMENSION(*) :: Dx
      INTEGER :: IDAMAX
      INTENT (IN) Dx , Incx , N
!
! Local variables
!
      DOUBLE PRECISION , INTRINSIC :: DABS
      DOUBLE PRECISION :: dmax
      INTEGER :: i , ix
!
!*** End of declarations rewritten by SPAG
!
!
!     finds the index of element having max. absolute value.
!     jack dongarra, linpack, 3/11/78.
!     modified 3/93 to return if incx .le. 0.
!     modified 12/3/93, array(1) declarations changed to array(*)
!
!
      IDAMAX = 0
      IF ( N<1 .OR. Incx<=0 ) RETURN
      IDAMAX = 1
      IF ( N==1 ) RETURN
      IF ( Incx==1 ) THEN
!
!        code for increment equal to 1
!
         dmax = DABS(Dx(1))
         DO i = 2 , N
            IF ( DABS(Dx(i))>dmax ) THEN
               IDAMAX = i
               dmax = DABS(Dx(i))
            ENDIF
         ENDDO
         GOTO 99999
      ENDIF
!
!        code for increment not equal to 1
!
      ix = 1
      dmax = DABS(Dx(1))
      ix = ix + Incx
      DO i = 2 , N
         IF ( DABS(Dx(ix))>dmax ) THEN
            IDAMAX = i
            dmax = DABS(Dx(ix))
         ENDIF
         ix = ix + Incx
      ENDDO
      RETURN
99999 END FUNCTION IDAMAX
!*==XERBLA.spg  processed by SPAG 6.55Dc at 12:01 on  5 Feb 2004
      SUBROUTINE XERBLA(Srname,Info)
      IMPLICIT NONE
!*--********************************************************************
!A INPUT  - SRNAME
!A INPUT  - INFO
! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
! calls       ** NOTHING **
! called by   DGEMM    DGEMV    DGER     DGETF2   DGETRF   DGETRI
!             DTRMM    DTRMV    DTRSM    DTRTI2   DTRTRI
! modifies    ** NOTHING **
! uses value  ** NOTHING **
! local vars  *** NONE ****
! uses PARAMs *** NONE ****
!*++********************************************************************
!
!*** Start of declarations rewritten by SPAG
!
! Dummy arguments
!
      INTEGER :: Info
      CHARACTER(6) :: Srname
      INTENT (IN) Info , Srname
!
!*** End of declarations rewritten by SPAG
!
!
!  -- LAPACK auxiliary routine (preliminary version) --
!     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
!     Courant Institute, Argonne National Lab, and Rice University
!     February 29, 1992
!
!     .. Scalar Arguments ..
!     ..
!
!  Purpose
!  =======
!
!  XERBLA  is an error handler for the LAPACK routines.
!  It is called by an LAPACK routine if an input parameter has an
!  invalid value.  A message is printed and execution stops.
!
!  Installers may consider modifying the STOP statement in order to
!  call system-specific exception-handling facilities.
!
!  Arguments
!  =========
!
!  SRNAME  (input) CHARACTER*6
!          The name of the routine which called XERBLA.
!
!  INFO    (input) INTEGER
!          The position of the invalid parameter in the parameter list
!          of the calling routine.
!
!
      WRITE (*,FMT=99001) Srname , Info
!
      STOP
!
99001 FORMAT (' ** On entry to ',A6,' parameter number ',I2,' had ',    &
     &        'an illegal value')
!
!     End of XERBLA
!
      END SUBROUTINE XERBLA

c FORTRAN Example.f
c 
c Included in the Alpha distribution as an example of the Fort mode
c 
c source of original document:
c 
c http://www.fortran.com/
c 

       PROGRAM COLORIT

c    *****************************************
c    By Dale Bickel, Senior Electronics Engineer, dbickel@fcc.gov
c    Audio Services Div., FCC (USA)
c    http://www.fcc.gov/mmb/asd/
c    
c    This Fortran CGI application may be copied and/or 
c    modified freely.  No restrictions are placed on its use. 
c    ******************************************
c    This program was created to develop a Fortran CGI.  It 
c    receives input from HTML and generates HTML output.
c    It could easily be modified to allow input from the 
c    keyboard or a Fortran routine.

c    CGI access is required if the program is used as written. 
c    The programming has not been optimized.  
c    ****************************************** 
 
c    This Fortran 77 program prints the HTML color corresponding 
c    to a six-place hexadecimal number.  It also prints, in table form,
c    the colors which result by increasing or decreasing a single
c    digit from the entered number.
c    *******************************************

c    First, we read the six digit value sent over from the HTML.
c    Because this program uses the GET method, this program
c    reads the environment variable QUERY_STRING.   We 
c    read each character from the string, and ignore unnecessary
c    characters (here, ... ?input=  ).
c    ********************************************

c    QS represents the character string  QUERY_STRING
c    Digit is the numerical value of the corresponding character
c    12 places are required to cover the whole QUERY_STRING
c    input=AAAAAA
c    ********************************************

c    Fortran reminders:
c    Column 1 -- enter C for Comments
c    Column 2-5 -- statement labels
c    Column 6 -- continuation character
c    Column 7 -- start commands in this column
c    Column 72 -- Last column of statement -- use continuation
c        characters or another Format statement if command is longer

c    First Statement of Program :  **********************             

       Character*12 QS
       Character*1 newcolor
       Dimension digit(12) 

c    ********************************************

c    Retrieve environment variable QUERY_STRING, using
c    "getenv" get environment variable subroutine on system.
c    This command may differ on other computer systems.
c    QUERY_STRING will be stored in the character string QS.

       call getenv('QUERY_STRING', QS)
    
c    ******************************************
c    Now we set up the Fortran code to generate HTML output.
c    The Content-type: text/html // statement accomplishes
c    this action.  The slashes // are VERY IMPORTANT!! 
c    Watch the placement of the quotes!

       Write(6,55)
 55    Format("Content-Type: text/html"//)

c    ******************************************
c    From now on, the usual HTML tags will appear inside
c    FORMAT statements.  Watch the quotation marks!
c    Note that HTML tags may be placed on the same line, or 
c    one tag may be broken up onto different lines.

       Write(6,64)
       Write(6,65)
       Write(6,66)

 64    Format('<HTML><HEAD><Title>')
 65    Format('COLORIT Color Generator --- A Fortran CGI</Title>')
 66    Format('</Head><Body bgcolor=' '#FFFFFF' '>')

c    Note the placement of the quote marks for the HTML 
c    code bgcolor="#FFFFFF"> in the previous statement
c    ******************************************

c    Here we generate the HTML for the output document's
c    heading:

       Write(6,1400)
       Write(6,1401)
       Write(6,1402)
       Write(6,1403)
       Write(6,1404)
       Write(6,1405)
       Write(6,1406)     
       Write(6,1407)
       Write(6,1408)
       Write(6,1410)
       Write(6,1411)
       Write(6,1412)
       Write(6,1413)
       Write(6,1414)
       Write(6,1415)
       Write(6,1416)
       Write(6,1417)
       Write(6,1418)

 1400  FORMAT('<Center>')      
 1401  FORMAT('<A HREF=' 'http://www.fcc.gov/' '><IMG SRC=' )
 1402  FORMAT('http://www.fcc.gov/fcc-gifs/hpban1.gif ' 'ALT=' )
 1403  FORMAT(' [ Federal Communications Commission ] ' '></A>')
 1404  FORMAT('<BR><a href=' )
 1405  FORMAT('http://www.fcc.gov/fcc-bin/htimage/pub/www/pub/opa.map')
 1406  FORMAT('><img src=' 'http://www.fcc.gov/fcc-gifs/iconbar.gif' )
 1407  FORMAT('height=20' 'width=525' 'alt=' '[icon bar]' 'vspace=5' )
 1408  FORMAT('border=1' 'ismap></a></CENTER><P>' )
 1410  FORMAT('<Center><TABLE Border=0 ><TR ALIGN=LEFT>')
 1411  FORMAT('<TD align=' 'left' '><IMG SRC=' )
 1412  FORMAT('http://www.fcc.gov/fcc-gifs/sealtiny.gif')
 1413  FORMAT(' alt=' '[ FCC Seal ]' '></TD><TD><B><H2>')
 1414  FORMAT('<Font Color="#D81654">COLORIT Color ')
 1415  FORMAT(' Generator</Font> ------ <Font Size=2><A HREF=')
 1416  FORMAT('http://www.fcc.gov/mmb/asd/bickel/fortran.html')
 1417  FORMAT('>A  Fortran CGI</A></Font></H2> Page 2')
 1418  FORMAT(' -- Output</TD></TR></TABLE></Center><P>')
 
c    ************************************************* 
c    Write the pertinent part of the Input QUERY_STRING to output 

       Write(6,79)
 79    Format('<Center><H3><Font Color=' '#FF0000' '>Input Color: ')
       Write(6,81) QS(7:7),QS(8:8),QS(9:9),QS(10:10),QS(11:11),QS(12:12)
 81    Format('</Font><B> '      AAAAAA '</B></H3>')
       Write(6,83)
 83    Format('</Center><P>' )

c    ********************************************
c    Here we replicate the initial HTML Form data entry fields

       Write(6,87)
       Write(6,88)
       Write(6,89)
       Write(6,90)
 
       Write(6,96)
       Write(6,92)
       Write(6,93)
       Write(6,94)
       Write(6,95)
       Write(6,96)


 87    Format('<Center><Form method=' 'GET' ' action=')
 88    Format('http://www.fcc.gov/fcc-bin/colorit' '>')
 89    Format('Change Color Here:   ')
 90    Format("<Input type='text' name='input' maxlength='6'>")
 92    Format("<Input Type='submit'  value='Get New Color' >")
 93    Format('<Font Color=' '#FFFFFE' '> . . .</Font>')
 94    Format("<Input Type='reset'  value='Clear Form' >")
 95    Format('</Form></Center>')
 96    Format('<BR><BR>')

c    ***********************************************
c    Be aware that "numbers" in the query_string really
c    aren't numbers -- they're ASCII characters.  They must 
c    be converted to integer or real numbers before use, 
c    e.g., if(QS(*:*).eq."1") x=1
c    
c    Character entries in the query string can be retrieved
c    by QS(first char. of substring : last char of substring)
c    Both first and last characters will be retrieved.  
c    
c    In the following code, a numerical character is looked for and
c    converted into its decimal counterpart.

       Do i=7,12,1

       If(QS(i:i).eq."0")  then
       digit(i)=0.0
       Else if(QS(i:i).eq."1")  then
       digit(i)=1
       Else if(QS(i:i).eq."2")  then
       digit(i)=2
       Else if(QS(i:i).eq."3")  then
       digit(i)=3
       Else if(QS(i:i).eq."4")  then
       digit(i)=4
       Else if(QS(i:i).eq."5")  then
       digit(i)=5
       Else if(QS(i:i).eq."6")  then
       digit(i)=6
       Else if(QS(i:i).eq."7")  then
       digit(i)=7
       Else if(QS(i:i).eq."8")  then
       digit(i)=8
       Else if(QS(i:i).eq."9")  then
       digit(i)=9
       Else if((QS(i:i).eq."A").or.(QS(i:i).eq."a")) then
       digit(i)=10
       Else if((QS(i:i).eq."B").or.(QS(i:i).eq."b"))  then
       digit(i)=11
       Else if((QS(i:i).eq."C").or.(QS(i:i).eq."c"))  then
       digit(i)=12
       Else if((QS(i:i).eq."D").or.(QS(i:i).eq."d"))  then
       digit(i)=13
       Else if((QS(i:i).eq."E").or.(QS(i:i).eq."e"))   then
       digit(i)=14
       Else if((QS(i:i).eq."F").or.(QS(i:i).eq."f"))   then
       digit(i)=15
       Else if(QS(i:i).eq."") then
       Go to 162
       Else 
       Write(6,159) QS(i:i)
 159   Format(A ' is not a valid character -- ')
       Write(6,160)
 160   Format('Please reenter six characters,<P>')
       Write(6,161) 
 161   Format('of type 0,1,2,3,4,5,6,7,8,9,A,B,C,D,E,F<P>') 
          Go to 335
 162   End if
 
       End do
 
       Write(6,167)
       Write(6,168)
       Write(6,169)
 167   Format('<P>')
 168   Format('<Center>')
 169   Format('<Table width=' '95%' 'border=1>')

c    Loop through 9 rows, 4 above & 4 below the entered color code


       Do j=-4,4,1
       Write(6,177)
 177   Format('<TR align=' 'center' '>')

       If(j.eq.0) then
       Write(6,181)QS(7:7),QS(8:8),QS(9:9),QS(10:10),QS(11:11),QS(12:12)
 181   Format('<TD colspan=6 bgcolor=' '#'AAAAAA)
       Write(6,183)
 183   Format('align=' 'center' '>.<BR>')

c    Create a small label table, inside the data element

       Write(6,189)
       Write(6,190) QS(7:7),QS(8:8),QS(9:9),QS(10:10),QS(11:11),QS(12:12)
 
 189   Format('<Table border=0><TR><TD bgcolor=' '#FFFFFF' '>')
 190   Format('Submitted color= 'AAAAAA' </TD></TR></Table>')

       Write(6,193)
 193   Format('<BR>*</TD></TR>')
       Go to 320
         else if(j.ne.0) then       

c    Create HTML across the row -- 6 data elements

       Write(6,200)
 200   Format('<TR align=' 'center' '>')

       Do i=7,12,1

       Number=digit(i)+j

        If(number.eq.0) then
       newcolor="0"
        Else if(number.eq.1) then
       newcolor="1"
        Else if(number.eq.2) then
       newcolor="2"
        Else if(number.eq.3) then
       newcolor="3"
        Else if(number.eq.4) then
       newcolor="4"
        Else if(number.eq.5) then
       newcolor="5"
        Else if(number.eq.6) then
       newcolor="6"
        Else if(number.eq.7) then
       newcolor="7"
        Else if(number.eq.8) then
       newcolor="8"
        Else if(number.eq.9) then
       newcolor="9"
        Else if(number.eq.10) then
       newcolor="A"
        Else if(number.eq.11) then
       newcolor="B"
        Else if(number.eq.12) then
       newcolor="C"
        Else if(number.eq.13) then
       newcolor="D"
        Else if(number.eq.14) then
       newcolor="E"
        Else if(number.eq.15) then
       newcolor="F"
        End if

       If((number.lt.0).or.(number.gt.15)) then
       Write(6,243)
 243      Format('<TD bgcolor=')
          Write(6,244)
 244      Format('#FFFFFF' '>No color</TD>')
       Go to 320
       End if
 
       Write(6,243)
 
       If(i.eq.7) then
       write(6,270)newcolor,QS(8:8),QS(9:9),QS(10:10),QS(11:11),QS(12:12)
 
       Else if(i.eq.8) then
       Write(6,270)QS(7:7),newcolor,QS(9:9),QS(10:10),QS(11:11),QS(12:12)
 
       Else if(i.eq.9) then
       Write(6,270)QS(7:7),QS(8:8),newcolor,QS(10:10),QS(11:11),QS(12:12)
 
       Else if(i.eq.10) then
       Write(6,270)QS(7:7),QS(8:8),QS(9:9),newcolor,QS(11:11),QS(12:12)
 
       Else if(i.eq.11) then
       Write(6,270)QS(7:7),QS(8:8),QS(9:9),QS(10:10),newcolor,QS(12:12)
 
       Else if(i.eq.12) then
       Write(6,270)QS(7:7),QS(8:8),QS(9:9),QS(10:10),QS(12:12),newcolor
 
       End if
 270   Format(AAAAAA' align=' 'center' '><BR>')


c    Create a label table inside the data element

       Write(6,276)
 276   Format('<Table border=0><TR align=' 'center' '>')
 
       If(i.eq.7) then
       Write(6,311)
       Write(6,312)newcolor,QS(8:8),QS(9:9),QS(10:10),QS(11:11),QS(12:12)
       Write(6,313)newcolor,QS(8:8),QS(9:9),QS(10:10),QS(11:11),QS(12:12)
 
       Else if(i.eq.8) then
       Write(6,311)
       Write(6,312)QS(7:7),newcolor,QS(9:9),QS(10:10),QS(11:11),QS(12:12)
       Write(6,313)QS(7:7),newcolor,QS(9:9),QS(10:10),QS(11:11),QS(12:12)
 
       Else if(i.eq.9) then
       Write(6,311)
       Write(6,312)QS(7:7),QS(8:8),newcolor,QS(10:10),QS(11:11),QS(12:12)
       Write(6,313)QS(7:7),QS(8:8),newcolor,QS(10:10),QS(11:11),QS(12:12)
 
       Else if(i.eq.10) then
       Write(6,311)
       Write(6,312)QS(7:7),QS(8:8),QS(9:9),newcolor,QS(11:11),QS(12:12)
       Write(6,313)QS(7:7),QS(8:8),QS(9:9),newcolor,QS(11:11),QS(12:12)
 
       Else if(i.eq.11) then
       Write(6,311)
       Write(6,312)QS(7:7),QS(8:8),QS(9:9),QS(10:10),newcolor,QS(12:12)
       Write(6,313)QS(7:7),QS(8:8),QS(9:9),QS(10:10),newcolor,QS(12:12)
 
       Else if(i.eq.12) then
       Write(6,311)
       Write(6,312)QS(7:7),QS(8:8),QS(9:9),QS(10:10),QS(11:11),newcolor
       Write(6,313)QS(7:7),QS(8:8),QS(9:9),QS(10:10),QS(11:11),newcolor
 
       End if
 
       Write(6,314)
 
 311   Format('<TD bgcolor=' '#FFFFFF' '><A HREF=')
 312   Format('http://www.fcc.gov/fcc-bin/colorit?input='AAAAAA'>')
 313   Format(AAAAAA'</A></TD>')
 314   Format('</TR></Table>')

       Write(6,318)
 318   Format('<BR>.</TD>')

 320   Continue
       End do

       Write(6,324)
 324   Format('</TR>')

 99    Continue
       End do
 
       End if
       Write(6,330)
 330   Format('</table></center>')

       Write(6,331)
       Write(6,332)
       Write(6,333)
 331   Format('<P><Center><Font Size=2>NOTE: Because the colors')
 332   Format(' above are shown as BACKGROUNDS, <BR>they will')
 333   Format('  not show up when this page is printed.</Font><P>') 

 335   Continue

       Write(6,337)
       Write(6,338)
       Write(6,339)
       Write(6,338)
       Write(6,340)  
 337   Format('This document may be accessed at <A HREF=')
 338   Format('http://www.fcc.gov/mmb/asd/bickel/colorit.html')
 339   Format('>') 
 340   Format('</A><P></Center>')


c    Now that all of the colors have been shown, set up end-of-page
c    links & gifs

       Write(6,400)
       Write(6,401)
       Write(6,402)
       Write(6,403)
       Write(6,404)

       Write(6,400)
       Write(6,405)
       Write(6,406)
       Write(6,407)
       Write(6,408)
 
       Write(6,406)
       Write(6,409)
       Write(6,410)
       Write(6,406)
       Write(6,411)
       Write(6,412)
       Write(6,406)
       Write(6,413)
       Write(6,414)
       Write(6,406)
       Write(6,415)
       Write(6,416)      
       Write(6,406)
       Write(6,417)
       Write(6,418)
       Write(6,406)
       Write(6,419)
       Write(6,420)
       Write(6,406)
       Write(6,421)
 
       Write(6,422)
       Write(6,406)
       Write(6,423)
       Write(6,424)
       Write(6,406)
       Write(6,425)
       Write(6,426)
       Write(6,406)
       Write(6,427)
       Write(6,428)
       Write(6,400)
 
 400   Format('<CENTER>')
 401   Format('<IMG SRC=' 'http://www.fcc.gov/mmb/gif/yl_bar.gif')
 402   Format(' alt=' ' Line Across Page ' '>')
 403   Format('</Center>')
 404   Format('<P>')
 405   Format('<B>Jump to:</B><BR>')
 406   Format('<A HREF=')
 407   Format('http://www.fcc.gov/mmb/asd/' '>')
 408   Format('ASD Subject Index</A>,')
 409   Format('http://www.fcc.gov/mmb/asd/welcomeALT.html' '>')
 410   Format('ASD Alphabetical Index</A>,')
 411   Format('http://www.fcc.gov/search/' '>')
 412   Format('FCC Search Engine</A></CENTER><BR><UL><LI>')

 413   Format('http://www.fcc.gov/mmb/asd/main/filing.html' '>')
 414   Format('Filing an Application</A><LI>')
 415   Format('http://www.fcc.gov/mmb/asd/main/information.html')
 416   Format('>Application Information</A><LI>')
 417   Format('http://www.fcc.gov/mmb/asd/main/am.html' '>')
 418   Format('AM</A><LI>')
 419   Format('http://www.fcc.gov/mmb/asd/main/fm.html' '>')
 420   Format('FM and FM Translators & Boosters</A><LI>')
 421   Format('http://www.fcc.gov/mmb/asd/main/fact.html' '>')
 422   Format('Fact Sheets</A><LI>')
 423   Format('http://www.fcc.gov/mmb/asd/decdoc/intro.html')
 424   Format('>Decisions</A><LI>')
 425   Format('http://www.fcc.gov/mmb/asd/main/other.html#WITHIN')
 426   Format('>Links Within FCC</A><LI>')
 427   Format('http://www.fcc.gov/mmb/asd/main/other.html#OUTSIDE')
 428   Format('>Links to Outside the FCC</A></UL><P>')

       Write(6,406)
       Write(6,429)
       Write(6,430)
       Write(6,431)
       Write(6,432)
       Write(6,433)
       Write(6,434)
     
 429   Format('http://www.fcc.gov/mmb/' '>Mass Media Bureau</A>')
 430   Format(' -- <A HREF=' 'http://www.fcc.gov/' '>Federal ')
 431   Format('  Communications Commission</A></CENTER><P>')
 432   Format('<BR><BR><CENTER><IMG SRC=')
 433   Format('http://www.fcc.gov/fcc-gifs/small_seal.gif')
 434   Format(' alt=' '[ FCC Seal ]' '></CENTER>')


c    ********************************************
c    Without a closing HTML statement, you may not see ANY output!
     
       Write(6,999)
 999   Format('</Body></HTML>')
       Call Exit

c    END OF PROGRAM   
       END

/* -*-SAS-*- 
 * ==========================================================================
 * SAS-Example.sas
 * 
 * Distributed as an example of Alpha's SAS mode.
 * 
 * ==========================================================================
 */

/* 
 * ==========================================================================
 * SPPA Analysis - Exploring 15 year trends in Participation in the Arts
 * 
 * FILE: "sppa1982.sas"
 *                                          created: 11/14/1998 {02:34:21 pm}
 *                                      last update: 05/29/2000 {06:38:55 pm}
 * Description: 
 *
 * Reading data from the CD-ROM "SPPA" -- National Endowment of the Arts. 
 * A revision of Steven Tepper's tap82.sas
 *
 * Author: Craig Barton Upright
 * E-mail: <cupright@alumni.princeton.edu>
 *    www: <http://www.purl.org/net/cbu>
 * 
 * Copyright (c) 1998-2000 Craig Barton Upright
 * All rights reserved.
 * 
 * ==========================================================================
 */

*** Preliminaries ;

options ls = 80 ;
LIBNAME mysas v609 "." ; 
FILENAME IN1 "../SPPA_82_97/82_85_92/SPPA1982" ;


*** Value labels ;

PROC FORMAT ;

VALUE   urbrural

    1       =  " 1 Urban                                " 
    2       =  " 2 Rural - Farm, 10 acres or larger     "
    3       =  " 3 Rural - Farm, less than 10 acres     "
    4       =  " 4 Rural - Non-Farm,10 acres or larger  "
    5       =  " 5 Rural - Non-Farm, less than 10 acres " ;

VALUE   metrange

    00      =  "00  under 200                           "
    01      =  "01       200 -     499                  "
    02      =  "02       500 -     999                  "
    03      =  "03     1,000 -   1,499                  "
    04      =  "04     1,500 -   1,999                  "
    05      =  "05     2,000 -   2,499                  "
    06      =  "06     2,500 -   4,999                  "
    07      =  "07     5,000 -   9,999                  "
    08      =  "08    10,000 -  19,999                  "
    09      =  "09    20,000 -  24,999                  "
    10      =  "10    25,000 -  49,999                  "
    11      =  "11    50,000 -  99,999                  "
    12      =  "12   100,000 - 240,999                  "
    13      =  "13   250,000 - 499,999                  "
    14      =  "14   500,000 - 999,999                  "
    15      =  "15 1,000,000 or more                    "
    99      =  "99 missing value                        " ;

 
VALUE   msa

    1       =  " 1 Central city of an SMSA only         "
    2       =  " 2 Central city of an urbnized area only"
    3       =  " 3 Central city of both SMSA, urbanized "
    4       =  " 4 Other incorporated place             "
    5       =  " 5 Unincorporated place                 "
    7       =  " 7 Not a place                          " ;
    
VALUE   quartype

    01      =  "01 House, apartment, flat               "
    02      =  "02 Housing unit in nontrnsient hotel etc"
    03      =  "03 Housing unit, permanent in transient "
    04      =  "04 Housing unit in rooming house        "
    05      =  "05 Mobile home or trailer               " 
    06      =  "06 Housing unit not specified above     "
    07      =  "07 Quarters in rooming/boarding house   "
    08      =  "08 Unit not perm in transient hotel     "
    09      =  "09 Unoccupied site for mobile home, etc "
    10      =  "10 Other unit not specified above       " ;
    
VALUE   number
        
     98     = " 98 residue                              "
     99     =  "99 missing value                        "
    998     = "998 residue                              "
    999     = "999 missing value                        " ;

VALUE   phyesno

    1       =  " 1 Phone in unit - phone intrvw accp    "
    2       =  " 2 Phone in unit - phone intrvw unaccp  "
    3       =  " 3 Phone elsewhere - phone intrvw accp  "
    4       =  " 4 Phone elsewhere - phone intrvw unaccp"
    5       =  " 5 No phone                             "
    8       =  " 5 residue                              "
    9       =  " 9 missing value                        " ;
    
VALUE   incrange

    03      =  "03 Less than  $3,000                    "
    05      =  "05 $ 3,000 to  4,999                    "
    06      =  "06 $ 5,000 to  5,999                    "
    07      =  "07 $ 6,000 to  7,499                    "
    08      =  "08 $ 7,500 to  9,999                    "
    09      =  "06 $10,000 to 11,999                    "
    10      =  "10 $12,000 to 14,999                    "
    11      =  "11 $15,000 to 19,999                    "
    12      =  "12 $20,000 to 24,999                    "
    13      =  "13 $25,000 to 49,999                    " 
    14      =  "11 $50,000 and over                     "
    98      =  "98 residue                              "
    99      =  "99 missing value                        " ;
    
    
VALUE   monthnm

    01      =  "01 January                              "
    02      =  "02 February                             "
    03      =  "03 March                                "
    04      =  "04 April                                "
    05      =  "05 May                                  "
    06      =  "06 June                                 "
    07      =  "07 July                                 "
    08      =  "08 August                               "
    09      =  "09 September                            "
    10      =  "10 Ocober                               "
    11      =  "11 November                             "
    12      =  "12 December                             " ;

VALUE   relation

    1       =  " 1 Reference person                     "
    2       =  " 2 Spouse                               "
    3       =  " 3 Own child                            "
    4       =  " 4 Other relative                       " 
    5       =  " 5 Non-relative                         "
    9       =  " 9 missing value                        " ;
    
VALUE   status

    1       =  " 1 Married                              "
    2       =  " 2 Widowed                              "
    3       =  " 3 Divorced                             "
    4       =  " 4 Separated                            "
    5       =  " 5 Never married                        "
    8       =  " 8 residue                              "
    9       =  " 9 missing value                        " ;
    
VALUE   rrace

    1       =  " 1 White                                "
    2       =  " 2 Black                                "
    3       =  " 3 Other                                " 
    9       =  " 9 missing value                        " ;
    
VALUE   mf

    1       =  " 1 Male                                 "
    2       =  " 2 Female                               "
    9       =  " 9 missing value                        " ;
    
VALUE   noyes

    0       =  " 0 No                                   "
    1       =  " 1 Yes                                  "
    8       =  " 8 residue                              "
    9       =  " 9 missing value                        " ;

VALUE   catnoyes

    0       =  " 0 No entry for this category           "
    1       =  " 1 Entry for this category              "
    8       =  " 8 NA, all categories are blank         "
    9       =  " 9 missing value                        " ;
    
RUN ;


*** Input data ;

DATA mysas.sppa1982 ;
INFILE IN1 LRECL=660 MISSOVER ;

INPUT

    /*       Characters 1 - 120 are the household section  */

    @1       sample          2.
    @3       psunumbr        3.
    @6       segnumbr        4.
    @10      checkdig        1.
    @11      sernumbr        2.
    @13      blank1          1.
    @14      hhnumbr         1.
    @15      Landuse         1.
    @16      Metsize         2.
    @18      Msatype         1.
    @19      blank2          3.
    @22      blank3          1.
    @23      hhrsnumb        2.
    @25      noninttp        1.
    @26      nonintrc        1.
    @27      nonintrs        2.
    @29      blank4          9.
    @38      hhstatus        1.
    @39      spcplace        2.
    @41      tenure          1.
    @42      blank5          1.
    @43      Lvquart         2.
    @45      blank6          1.
    @46      hhbusnss        1.
    @47      hsgunits        2.
    @49      crimrprt        2.
    
    /*       Characters 124 - 171 are the person section */
    
    @124     Refrltn         1.
    @125     Age             2.
    @127     MARSTAT         1.
    @128     RACE            1.
    @129     SEX             1.
    @130     afmemb          1.
    @131     GRADE           2.
    @133     Gradecom        1.
    @134     blank12         2.
    @136     WORKWK          2.
    @138     inttype2        1.
    @139     blank13         5.
    @144     layoff          1.
    @145     blank14         1.
    @146     nojobrsn        1.
    @147     forwhom         1.
    @148     iccode          3.
    @151     emptype         1.
    @152     occcode         3.
    @155     blank15        11.
    @166     Workwkhr        3.
    @169     Ethncity        2.
    @171     workwk2         1.
    @172     blank16         9.
    
    /*       Characters 181 - 660 are the SPPA section */
    
    @181     blank17        18.
    @199     lashhwt        12.
    @211     laspnwt        12.
    @223     hfsampcd       16.
    @239     blank18         3.
    @242     version         1.
    @243     blank19        17.
    @260     Intvtype        1.
    @261     Chszlt06        1.
    @262     Chsz0611        1.
    @263     blank20         3.
    @266     LPJAZZMO        1.
    @267     LPCLASMO        1.
    @268     LPOPERMO        1.
    @269     LPMUSIMO        1.
    @270     LPPLAYMO        1.
    @271     LPBALLMO        1.
    @272     LPGALLMO        1.
    @273     PPMUSWEL        1.
    @274     PPCLAPLA        1.
    @275     PPJAZPLA        1.
    @276     ppanypub        1.
    @277     PPPLAPUB        1.
    @278     PPMUSPUB        1.
    @279     PPOPRSNG        1.
    @280     PPBALLET        1.
    @281     LPREAD          1.
    @282     blank21         3.
    @285     unclear1        1.
    
    /*   I consider questions in characters 286 thu 292 to be   */
    /*   unreliable.  response rates of 100 or less.   -cbu     */
    
    @286     lpjazzXX        1.
    @287     lpclasXX        1.
    @288     lpoperXX        1.
    @289     lpmusiXX        1.
    @290     lpplayXX        1.
    @291     lpballXX        1.
    @292     lpgallXX        1.
    @293     blank22         1.
    @294     unclear2        1.
    @295     lpprplld        1.
    @296     lpprpln         2.
    @298     lpprpl01        1.
    @299     lpprpl02        1.
    @300     lpprpl03        1.
    @301     lpprpl04        1.
    @302     lpprpl05        1.
    @303     lpprpl06        1.
    @304     lpprpl07        1.
    @305     lpprpl08        1.
    @306     lpprpl09        1.
    @307     lpprpl10        1.
    @308     lpprpl11        1.
    @309     lpprpl12        1.
    @310     lpprefld        1.
    @311     lpprefn         1.
    @312     lppref01        1.
    @313     lppref02        1.
    @314     lppref03        1.
    @315     lppref04        1.
    @316     lppref05        1.
    @317     lppref06        1.
    @318     lppref07        1.
    @319     blank23         1. ;
    
LABEL

    /*      household section  */
        
    Landuse  =  "   -land use: rural vs urban            "
    Metsize  =  "   -place size                          " 
    Msatype  =  "   -place description                   "
    Lvquart  =  "   -type of living quarters             "
    Hhszge12 =  "   -# in household aged 12 or older     "
    Hhszlt12 =  "   -# in household aged less than 12    "
    Phonokay =  "   -is phone interview okay             "
    INCOME   =  "H26-HH INCOME-SPECIFIC CATEGORY         "
    Hhszge18 =  "   -# in household aged 18 or older     "
    
    /*      person section  */
    
    Refrltn  =  "   -relationship to reference person    "
    Age      =  "   -age at time of interview            "
    MARSTAT  =  "H7-MARITAL STATUS                       "
    RACE     =  "H2-RACE/ETHNICITY                       "
    SEX      =  "S7-RESPONDENT SEX                       "
    GRADE    =  "H9-HIGHEST GRADE/YEAR OF SCHOOL         "
    Gradecom =  "   -did you complete that grade         "
    WORKWK   =  "H15-WORKED LAST WEEK FOR PAY OR PROFIT  "
    Workwkhr =  "   -# hours worked last week            "
    Ethncity =  "   -ethnicity                           "
    workwk2  =  "   -worked last week recode             "
    
    /*      SPPA section  */
    
    Intvtype =  "   -interview type                      "
    Chszlt06 =  "   -# of respondant's children under 6  "
    Chsz0611 =  "   -# of respondant's children 6 to 11  "
    LPJAZZMO =  "A2A-# TIMES WENT LIVE JAZZ LAST MO      "
    LPCLASMO =  "A4A-# TIMES WENT LIVE CLASSCL LAST MO   "
    LPOPERMO =  "A6A-# TIMES WENT LIVE OPERA LAST MO     "
    LPMUSIMO =  "A8A-# TIMES WENT LIVE MUSICAL LAST MO   "
    LPPLAYMO =  "A10A-# TIMES WENT LIVE PLAY LAST MO     "
    LPBALLMO =  "A12A-# TIMES WENT LIVE BALLET LAST MO   "
    LPGALLMO =  "A16A-# TIMES WENT ART MUSEUM LAST MO    "
    PPMUSWEL =  "E14-CAN PERFORM FOR/WITH OTHER MUSICIANS"
    PPCLAPLA =  "E19-PLAYED CLASSICAL MUSIC LAST 12 MO   "
    PPJAZPLA =  "E17-PERFORMED JAZZ MUSIC LAST 12 MO     "
    PPPLAPUB =  "E26-ACT IN PUBLIC PERF OF PLAY LST 12 MO"
    PPMUSPUB =  "E24-SANG PUBLIC PERFORMANCE OF MUSICAL  "
    PPOPRSNG =  "E21-SANG MUSIC FROM OPERA LAST 12 MO    "
    PPBALLET =  "E27-DANCED BALLET LAST 12 MO            " ;

FORMAT

    Landuse         urbrural.
    Metsize         metrange.
    Msatype         msa.
    Lvquart         quartype.
    Hhszge12        number.
    Hhszlt12        number.
    Phonokay        phyesno.
    INCOME          incrange.
    Hhszge18        number.
    Intvmm          monthnm.
    Intvyy          number.
    Refrltn         relation.
    Age             number.
    MARSTAT         status.
    RACE            rrace.
    SEX             mf.
    GRADE           gradeyr.
    Gradecom        yesno.
    WORKWK          worksta.
    Workwkhr        number.
    Ethncity        ethncode.
    workwk2         workstb.
    Intvtype        itype.
    Chszlt06        numbera.
    Chsz0611        numbera.
    LPJAZZMO        lpfreq.
    LPCLASMO        lpfreq.
    LPOPERMO        lpfreq.
    LPMUSIMO        lpfreq.
    LPPLAYMO        lpfreq.
    LPBALLMO        lpfreq.
    LPGALLMO        lpfreq.
    PPMUSWEL        noyes.
    PPCLAPLA        noyes.
    PPJAZPLA        noyes.
    ppanypub        noyes.
    PPPLAPUB        noyes.
    PPMUSPUB        noyes.
    PPOPRSNG        noyes.
    PPBALLET        noyes.
    LPREAD          noyes. ;

RUN ;
PROC CONTENTS ;   RUN ;

Fortran90 Electric Completions Tutorial

                                            version: 2.0
                                            created: 02/12/2005 {10:10:22 AM}
                                        last update: 02/22/2005 {12:15:33 PM}


	  	! Table Of Contents

"# Description"
"# Keyword Completions"
"# If ... Then ... Else ..."
"# Electric Contractions"
"# DO Completions"
"#  DO ... CONTINUE"
"#  DO ... END DO"
"#  DO WHILE ... (or WHILE ... DO)"
"#  DO ... UNTIL ..."
"# Electric Return"
"# Word Completions"
 
"# Copyright"


	================================================================


	  	! Description

This file contains examples of "electric completions".  Completions are ways in
which Alpha attempts to complete what you're typing in a mode specific way (in
this case Fortran, or "Fort" mode specific).

The "Config > Special Keys" menu item will display your current completion
key-binding, and will give you the option to change it if you desire.

In this tutorial, you can use the back-quote key ( ` ) to jump to the next
completion example.  Once at the correct position, imagine that you had just
typed the preceding text.

Then hit the completion invoking key.  Alpha attempts to complete what you typed
-- eliminating a lot of keystrokes, avoiding the need for copy/pasting, and
reducing the possibility of typos.

Technical note: the presence of un-used stops can interfere with the
completion/expansion of the next shortcut, so each jump via the back-quote key
first clears all stops.


	  	! Keyword Completions

Most Fortran keywords (including statements, functions, intrinsic operators,
etc.)  are available as "electric completions" If you type a portion of the name
and press your "Complete" key, the rest of it will be finished for you.  Press
the back-quote (`) key now to position the cursor behind the string "write" and
then press your special "Complete" key to test:

   write×

After the electric template has been created, you can press your special "Next
Stop" key to advance to the next template marker.

Now try it with these examples

   format×
   if×
   abs×

Fortran is a case-insensitive language, so you can include all of

   write (*,*) 
   Write (*,*) 
   WRITE (*,*) 

in your source files.  The "Complete Commands Using" preference allows you to
select your personal style -- you can view (and change) the current setting for
this preference by selecting the "Config > Fort Mode Prefs > Preferences" menu
item.

Note that all of the following are available as electric completions, but all
will be converted to your chosen style:

   write×
   Write×
   WRITE×
   
The "Spaces After Command/Function" preferences also determine if the
(parentheses) are inserted touching the keyword or not.

Most Fortran keywords can be completed after typing just a portion of the
command.  If the 'hint' is ambiguous, you will be prompted to select from all
available options.  Complete the following:

   wr×
   for×
   proc×
   int×
   pr×

If you have typed a keyword and a "(", typing a consecutive "(" will trigger a
quick () template, with an additional stop at the end for easy navigation:

   sqrt(×
   tan(×
   if (×

The logic here is that typing two "((" is slightly easier than typing ().

   log×
   min×

In "normal" windows, selecting "Edit > Undo" a few times will eventually restore
the original double text if that is what you really wanted.  (In this window,
[undo] is disabled.)

You can turn off the "Electric Dbl Left Paren" preference to disable this
feature.
   
   
	  	! If ... Then ... Else ...

The basic "IF" statement takes place on a single line, as in

   IF (<logical-expression>) <statement>
   
   if×

Often times you need to execute several different statements after an IF, using
the IF ...  THEN construction, as in

   IF (<logical-expression>) THEN
      <statement>
      <statement>
      ...
   ENDIF

You can type and complete "ifthen" to create a template for this:

   ifthen×

And of course IFTHEN works too:

   IFTHEN×

The "Enddo Endif Are Single Words" preference determines if the template
includes "ENDIF" vs "END IF".

If you need to include an "ELSE IF" case, just complete "elseif" :

   IF (x .GE. y) THEN
      WRITE(*,*) 'x is positive and x >= y'
      elseif×
   ENDIF

The "Elseif Is Single Word" preference determines if "elseif" will complete to
"ELSEIF" vs "ELSE IF".


If you know in advance that you want to create an "IF ...  ELSE" set of
conditions, you can complete "ifelse" :

   ifelse×


	  	! Electric Contractions

Some statements required two keywords, as in
 
    ASSIGN <label> TO <integer name>
    
    DOUBLE PRECISION <list of variables>
    
    BLOCK DATA <arguments>
 
You can complete these as "contractions", i.e.
 
    a't×
    
    d'p×
    
    b'd×
    
UPPER and Mixed case "hints" work as well:
 
    A'T×
    
    D'p×
    
    b'D×
 
There are special cases built in for "IF/ELSE" statements :
 
    i't×
    
    i'e×
    
    IF () THEN
       e'i×
    ENDIF
 
Tip: in Fort mode the "Expand" key will also complete all of these electric
contractions.


	  	! DO Completions

Fortran has several different flavors of DO statements, including
 
   DO <label> <var>=<expr>
      <statement>
   CONTINUE
   
   DO
      <statement>
   ENDDO
   
   DO WHILE (<logical expression>) 
      <statement>
   ENDDO
   
   WHILE (<logical expression>) DO
      <statement>
   ENDDO
   
   DO
      <statement>                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          
   UNTIL (<logical expression)
 
If you attempt to complete "DO" you will be offered all of these options in a
list-pick dialog:
 
   do×
 
Your last selection will be "remembered" the next time you attempt to complete
DO as the default option in the dialog:
 
    do×

There are other methods for a template for your desired flavor from the outset.

	  	 	! DO ... CONTINUE

To create a "DO ...  CONTINUE" template, you can complete the string
"doContinue" (or "docontinue" or DOCONTINUE) :
 
   doContinue×
 
The electric contraction "d'c" is even handier:
 
   d'c×
   
   D'C×
 
	  	 	! DO ... END DO

This is the most basic template.  

   doEndDo×
   
   doenddo×
   
The "Enddo Endif Are Single Words" preference determines if "enddo" will be
inserted as "ENDDO" vs "END DO" in the template.

The "d'e" contraction is also useful:
  
   d'e×
   
   D'e×
  


	  	 	! DO WHILE ... (or WHILE ... DO)

To create a DO ...  WHILE template, you can complete "doWhile" or "doEndDo" :
  
   doWhile×
   
   dowhile×
   
The "Enddo Endif Are Single Words" preference determines if "enddo" will be
inserted as "ENDDO" vs "END DO" in the template.

   DOWHILE×
   
The "d'w" contraction is also useful:
  
   d'w×
   
   D'W×
   
To create a WHILE ...  DO template, simply complete "while":
  
   while×
  
or use "w'd":
  
   w'd×
     
	  	 	! DO ... UNTIL ...


To create a DO ... UNTIL template, complete "doUntil" :
  
   doUntil×
  
or use the contraction "d'u" :
  
   d'u×

(Do you sense a pattern here?)
  
  
	  	! Electric Return

Fort mode has a sophisticated indentation routine.  For example, advance to the
next × marker in this window and select the "Fortran > Reformat Block" command:

   Do i=7,12,1×
   If(QS(i:i).eq."0")  then
   digit(i)=0.0
   Else if(QS(i:i).eq."1")  then
   digit(i)=1
   Else if(QS(i:i).eq."2")  then
   digit(i)=2
   Else if(QS(i:i).eq."3")  then
   digit(i)=3
   Else if(QS(i:i).eq."") then
   Go to 162
   Else 
   Write(6,159) QS(i:i)
   Format(A ' is not a valid character -- ')
   Write(6,160)
   Format('Please reenter six characters,<P>')
   Write(6,161) 
   Format('of type 0,1,2,3,4,5,6,7,8,9,A,B,C,D,E,F<P>') 
   Go to 335
   End if
   End do

Note that the cursor is positioned at the start of the next block of code after
reformatting, in case you want to reformat several blocks in your file.

If the "Indent On Return" preference is turned on, pressing the Return key will
automatically indent the next line.
   
   IF(QS(i:i).eq."0")  THEN×
   ENDIF

It will also indent the current line before creating the new one when this is
appropriate:

   IF(QS(i:i).eq."0")  THEN
      digit(i)=0.0
      ENDIF×

If you just want to create a new line without invoking any fancy indentation
routines, press Control-Return.
 
If you are nearing the end of a line and want to continue it to the next, select
the "Fortran > Continue Line" command.

   CHARACTER(255) :: allnames , cmdln , command , comment , ×

   
	  	! Word Completions

Here's a paragraph in which I use the word paragraph many times.  If I become
bored of typing the word paragraph, I can just type

   parag×

This also works with Fortran variable names, so if I have "MYVARIABLE" which I
don't wish to retype, I can just do

   MYV×
   
instead.  If there are several similar completions available, such as
"MYVARIANCE" and "MYVALUE" then pressing the Completion key multiple times will
cycle through all of the options.

   MYV×

Your "Electric Expansion" key (see "Config > Special Keys") can be used to
expand acronyms.  For example, if you name your variables with a mix of upper
and lower case letters ("myVariable"), you can then expand the string

   mv×

to insert the correct text into the window.  Again, if you have several words
that match the acronym, such as "myVariance" and "myValue" you can cycle through
the options.

   mv×

	================================================================


	  	! Copyright

This document has been placed in the public domain.

Fortran Electric Completions Tutorial

                                       version: 2.0
                                       created: 02/12/2005 {10:10:22 AM}
                                   last update: 02/15/2005 {06:13:00 PM}


	  	! Table Of Contents

      "# Description"
      "# Keyword Completions"
      "# If ... Then ... Else ..."
      "# Electric Contractions"
      "# DO Completions"
      "#  DO ... CONTINUE"
      "#  DO ... END DO"
      "#  DO WHILE ... (or WHILE ... DO)"
      "#  DO ... UNTIL ..."
      "# Electric Return"
      "# Word Completions"
       
      "# Copyright"


	================================================================


	  	! Description

 001  This file contains examples of "electric completions".
      Completions are ways in which Alpha attempts to complete what
      you're typing in a mode specific way (in this case Fortran, or
      "Fort" mode specific).

 002  The "Config > Special Keys" menu item will display your current
      completion key-binding, and will give you the option to change it
      if you desire.

 003  In this tutorial, you can use the back-quote key ( ` ) to jump to
      the next completion example.  Once at the correct position,
      imagine that you had just typed the preceding text.
      
 004  Then hit the completion invoking key.  Alpha attempts to complete
      what you typed -- eliminating a lot of keystrokes, avoiding the
      need for copy/pasting, and reducing the possibility of typos.
      
 005  Technical note: the presence of un-used stops can interfere with
      the completion/expansion of the next shortcut, so each jump via
      the back-quote key first clears all stops.


	  	! Keyword Completions

 101  Most Fortran keywords (including statements, functions, intrinsic
      operators, etc.)  are available as "electric completions" If you
      type a portion of the name and press your "Complete" key, the rest
      of it will be finished for you.  Press the back-quote (`) key now
      to position the cursor behind the string "write" and then press
      your special "Complete" key to test:
      
         write×
      
      After the electric template has been created, you can press your
      special "Next Stop" key to advance to the next template marker.
      
 102  Now try it with these examples
      
         format×
         if×
         abs×
      
 103  Fortran is a case-insensitive language, so you can include all of
      
         write (*,*) 
         Write (*,*) 
         WRITE (*,*) 
      
      in your source files.  The "Complete Commands Using" preference
      allows you to select your personal style -- you can view (and
      change) the current setting for this preference by selecting the
      "Config > Fort Mode Prefs > Preferences" menu item.
      
      Note that all of the following are available as electric
      completions, but all will be converted to your chosen style:
      
         write×
         Write×
         WRITE×
         
      The "Spaces After Command/Function" preferences also determine if
      the (parentheses) are inserted touching the keyword or not.
      
 104  Most Fortran keywords can be completed after typing just a portion
      of the command.  If the 'hint' is ambiguous, you will be prompted
      to select from all available options.  Complete the following:
      
         wr×
         for×
         proc×
         int×
         pr×
      
 105  If you have typed a keyword and a "(", typing a consecutive "("
      will trigger a quick () template, with an additional stop at the
      end for easy navigation:
      
         sqrt(×
         tan(×
         if (×
      
      The logic here is that typing two "((" is slightly easier than
      typing ().
      
         log×
         min×
      
      In "normal" windows, selecting "Edit > Undo" a few times will
      eventually restore the original double text if that is what you
      really wanted.  (In this window, [undo] is disabled.)
      
      You can turn off the "Electric Dbl Left Paren" preference to
      disable this feature.
         
         
	  	! If ... Then ... Else ...
      
 201  The basic "IF" statement takes place on a single line, as in
      
         IF (<logical-expression>) <statement>
         
         if×
      
      Often times you need to execute several different statements,
      using the IF ...  THEN construction, as in
      
         IF (<logical-expression>) THEN
            <statement>
            <statement>
            ...
         ENDIF
      
      You can type and complete "ifthen" to create a template for this:
      
         ifthen×
      
      And of course IFTHEN works too:
      
         IFTHEN×
      
      The "Enddo Endif Are Single Words" preference determines if the
      template includes "ENDIF" vs "END IF".

 202  If you need to include an "ELSE IF" case, just complete "elseif" :
      
         IF (x .GE. y) THEN
            WRITE(*,*) 'x is positive and x >= y'
            elseif×
         ENDIF
      
      The "Elseif Is Single Word" preference determines if "elseif" will
      complete to "ELSEIF" vs "ELSE IF".
      
      
 203  If you know in advance that you want to create an "IF ...  ELSE"
      set of conditions, you can complete "ifelse" :
      
         ifelse×
      

	  	! Electric Contractions

 301  Some statements required two keywords, as in
       
          ASSIGN <label> TO <integer name>
          
          DOUBLE PRECISION <list of variables>
          
          BLOCK DATA <arguments>
       
      You can complete these as "contractions", i.e. 
       
          a't×
          
          d'p×
          
          b'd×
          
 302  UPPER and Mixed case "hints" work as well:
       
          A'T×
          
          D'p×
          
          b'D×
       
 303  There are special cases built in for "IF/ELSE" statements :
       
          i't×
          
          i'e×
          
          IF () THEN
             e'i×
          ENDIF
       
       Tip: in Fort mode the "Expand" key will also complete all of
       these electric contractions.


	  	! DO Completions
      
 401  Fortran has several different flavors of DO statements, including
       
         DO <label> <var>=<expr>
            <statement>
         CONTINUE
         
         DO
            <statement>
         ENDDO
         
         DO WHILE (<logical expression>) 
            <statement>
         ENDDO
         
         WHILE (<logical expression>) DO
            <statement>
         ENDDO
         
         DO
            <statement>                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          
         UNTIL (<logical expression)
       
      If you attempt to complete "DO" you will be offered all of these
      options in a list-pick dialog:
       
         do×
       
      Your last selection will be "remembered" the next time you attempt
      to complete DO as the default option in the dialog:
       
          do×
      
      There are other methods for a template for your desired flavor
      from the outset.

	  	 	! DO ... CONTINUE
      
 411  To create a "DO ...  CONTINUE" template, you can complete the
      string "doContinue" (or "docontinue" or DOCONTINUE) :
       
         doContinue×
       
 412  The electric contraction "d'c" is even handier:
       
         d'c×
         
         D'C×
       
 413  Once you have created a DO ...  CONTINUE template, you will want
      to assign a label to it.  After typing your label behind the DO
      you can press the Complete key to add it to the CONTINUE line:
       
         DO 4655× =
            
         CONTINUE
       
      Alternatively, or if you've created a DO construct from "scratch"
      without the use of a template, you can position the cursor behind
      the final CONTINUE and then press Complete to scan the previous
      text for the DO <label> statement:
       
         DO 4875 =
            WRITE (*,*) 'x is positive and x >= y'
         CONTINUE×
       
 414  Warning: when this routine scans for the next CONTINUE it searches
      for the next "orphaned" line, i.e. the one which does not have any
      label associated with it.  No attempt is made to deal with nesting
      constuctions, so you should only use this utility when the target
      CONTINUE is visible.
        
      Similarly, completing CONTINUE will search for the closest
      previous DO label.

                        ! DO ... END DO
      
 421  This is the most basic template.  

         doEndDo×
         
         doenddo×
         
      The "Enddo Endif Are Single Words" preference determines if
      "enddo" will be inserted as "ENDDO" vs "END DO" in the template.

      The "d'e" contraction is also useful:
        
         d'e×
         
         D'e×
        

      
	  	 	! DO WHILE ... (or WHILE ... DO)

 431  To create a DO ...  WHILE template, you can complete "doWhile" or
      "doEndDo" :
        
         doWhile×
         
         dowhile×
         
      The "Enddo Endif Are Single Words" preference determines if
      "enddo" will be inserted as "ENDDO" vs "END DO" in the template.
      
         DOWHILE×
         
      The "d'w" contraction is also useful:
        
         d'w×
         
         D'W×
         
 441  To create a WHILE ... DO template, simply complete "while":
        
         while×
        
      or use "w'd":
        
         w'd×
           
	  	 	! DO ... UNTIL ...


 451  To create a DO ... UNTIL template, complete "doUntil" :
        
         doUntil×
        
      or use the contraction "d'u" :
        
         d'u×

      (Do you sense a pattern here?)
        
        
	  	! Electric Return
      
 501  Fort mode has a sophisticated indentation routine that preserves
      the contents of columns 1-6.  For example, advance to the next ×
      marker and select the "Fortran > Reformat Block" command:
      
         Do i=7,12,1×
         If(QS(i:i).eq."0")  then
         digit(i)=0.0
         Else if(QS(i:i).eq."1")  then
         digit(i)=1
         Else if(QS(i:i).eq."2")  then
         digit(i)=2
         Else if(QS(i:i).eq."3")  then
         digit(i)=3
         Else if(QS(i:i).eq."") then
         Go to 162
         Else 
         Write(6,159) QS(i:i)
 9590    Format(A ' is not a valid character -- ')
         Write(6,160)
 9600    Format('Please reenter six characters,<P>')
         Write(6,161) 
 9610    Format('of type 0,1,2,3,4,5,6,7,8,9,A,B,C,D,E,F<P>') 
         Go to 335
 9620    End if
         End do
      
      Note that the cursor is positioned at the start of the next block
      of code after reformatting, in case you want to reformat several
      blocks in your file.
     
      
 502  If the "Indent On Return" preference is turned on, pressing the
      Return key will automatically indent the next line.
      
         
         IF(QS(i:i).eq."0")  THEN×
         ENDIF
      
      It will also indent the current line before creating the new one
      when this is appropriate:
      
         IF(QS(i:i).eq."0")  THEN
            digit(i)=0.0
            ENDIF×
      
      If you just want to create a new line without invoking any fancy
      indentation routines, press Control-Return.
       
 503  The "Fortran > Shift Left/Right" menu commands will shift the text
      as desired, preserving columns 1-6.  Advance to the next ×
      marker, select the "Fortran > Select Block" menu command, and then
      practice shifting the text left and right.

 9590    Format(A ' is not a valid character -- ')×
         Write(6,160)
 9600    Format('Please reenter six characters,<P>')
         Write(6,161) 
 9610    Format('of type 0,1,2,3,4,5,6,7,8,9,A,B,C,D,E,F<P>') 
         Go to 335
         
      Note also that Alpha has dynamic "Shift Left/Right Space" commands
      in the Fortran menu.
      
 504  If you are nearing the end of a line and want to continue it to
      the next, select the "Fortran > Continue Line" command.
      
         CHARACTER(255) :: allnames , cmdln , command , comment , ×

      In some cases, you might be happily typing away and find that the
      line has been automatically continued for you.  In this case, you
      can use the "Fortran > Toggle Continuation" command to add your
      chosen continuation character into column 6:
      
         CHARACTER(255) :: allnames , cmdln , command , comment ,
         ×
      
      Selecting "Toggle Continutation" multiple times will, er, toggle
      the continuation column character.

         CHARACTER(255) :: allnames , cmdln , command , comment ,
         exename , names , root , timeline , titleline ,×
         token , zcompiletimes , zexesizes , zruntimes×
      
      You can change your "Continuation Character" preference by
      selecting "Config > Fort Mode Prefs > Preferences".
      

	  	! Word Completions

 601  Here's a paragraph in which I use the word paragraph many times.
      If I become bored of typing the word paragraph, I can just type
      
         parag×

 602  This also works with Fortran variable names, so if I have
      "MYVARIABLE" which I don't wish to retype, I can just do
      
         MYV×
         
      instead.  If there are several similar completions available, such
      as "MYVARIANCE" and "MYVALUE" then pressing the Completion key
      multiple times will cycle through all of the options.
      
         MYV×

 603  Your "Electric Expansion" key (see "Config > Special Keys") can be
      used to expand acronyms.  For example, if you name your variables
      with a mix of upper and lower case letters ("myVariable"), you can
      then expand the string
      
         mv×
      
      to insert the correct text into the window.  Again, if you have
      several words that match the acronym, such as "myVariance" and
      "myValue" you can cycle through the options.
      
         mv×

	================================================================


	  	! Copyright

c     This document has been placed in the public domain.

Title:                  C Electrics
Author:                 Craig Barton Upright <cupright@alumni.princeton.edu>
Author:                 Vince Darley <vince@santafe.edu>

    created: 05/13/2001 {01:35:07 am}
last update: 03/06/2006 {08:01:22 PM}




	  	// Table Of Contents

"# // Abstract"
"# // Description"
"# // Command Completions"
"# // Variable names"
"# // Alternate Completions"
"# // Expansions"

"# // Copyright"


	======================================================================


	  	// Abstract

This document provides examples of C mode electric completions.


	  	// Description

This file contains examples of "electric completions".  Completions are
ways in which Alpha attempts to complete what you're typing in a mode
specific way (in this case C specific).

The "Config --> Special Keys ...  " menu item will display your current
completion key-binding, and will give you the option to change it if you
desire.

In this tutorial, you can use the back-quote key ( ` ) to jump to the next
completion example.  Once at the correct position, imagine that you had
just typed the preceding text.

Then hit the completion invoking key.  Alpha attempts to complete what you
typed -- eliminating a lot of keystrokes, avoiding the need for
copy/pasting, and reducing the possibility of typos.


	  	// Command Completions

Here are some typical uses of electric completions:

	for×
	
	while×
	
	switch×


	  	// Variable names

It's important spell long variable names correctly.  

	while(myVeryLongVariableName>0) {
		my×

	  	// Alternate Completions

By pressing the invoking key multiple times, you can switch between any
number of alternative completions both above and below the insertion point. 
If you cycle through all possibilities, the entire name is highlighted so
you can delete it easily if desired.

	int myOtherLongVariable = 0;
	while(myVeryLongVariableName>0) {
		my×
	
		int myVariableBelow;


	  	// Expansions
	
There is another way to quickly pull a variable or function name out of the
surrounding text.  Instead of typing the first few letters of a multi-word
identifier, type each letter that starts a word in that identifier. 
Completions of this sort are invoke by pressing the 'expansion' key.  The
menu item "Config --> Special Keys ...  " will display your current
expansion key-binding, and will give you the option to change it if you
desire.


	int myOtherLongVariable = 0;
	while(myVeryLongVariableName>0) {
		mvlvn×
		molv×
		mvb×
	
		int myVariableBelow;
		
		
	======================================================================

	  	// Copyright

This document has been placed in the public domain.

#!/bin/tcsh

# Report the value of an environment variable 
# as defined in the startup sequence of /bin/tcsh

source /etc/csh.cshrc
source /etc/csh.login
if ( -r ~/.tcshrc ) then
  source ~/.tcshrc
else if ( -r ~/.cshrc ) then
  source ~/.cshrc
endif
if ( -r ~/.login ) then
  source ~/.login
endif

eval echo \$$1

#!/bin/bash

# Report the value of an environment variable 
# as defined in the startup sequence of /bin/bash

source /etc/profile
if [ -r ~/.bash_profile ]
then
  source ~/.bash_profile
fi
if [ -r ~/.bash_login ]
then
  source ~/.bash_login
fi
if [ -r ~/.profile ]
then
  source ~/.profile
fi
if [ -r ~/.bashrc ]
then
  source ~/.bashrc
fi

eval echo \$$1

#!/bin/tcsh -f 
#
# Edit paths as appropriate.  If you have improvements to
# this file which would help others, please send them to
# vince.darley@kagi.com
# 
#  Usage:
#         alphatk
#  or
#         alphatk filename
#
if ( $# == 0 ) then
	/opt/bin/wish /opt/Alphatk/alphatk.tcl &
else if ( -f $1 ) then
	/opt/bin/wish /opt/Alphatk/runalpha.tcl $1 &
else
	touch $1;
	/opt/bin/wish /opt/Alphatk/runalpha.tcl $1 &
endif

#!/opt/bin/ksh
#
# Edit paths as appropriate.  If you have improvements to
# this file which would help others, please send them to
# vince.darley@kagi.com
# 
#  Usage:  
#         alphatk 
#  or
#         alphatk filename
#
if [[ "$1" == "" ]]
then
	/opt/bin/wish /opt/Alphatk/alphatk.tcl &
elif [[ -f $1 ]]
then
	/opt/bin/wish /opt/Alphatk/runalpha.tcl $1 & 
else 
	touch $1;
	/opt/bin/wish /opt/Alphatk/runalpha.tcl $1 &
fi

#!/bin/zsh

# Report the value of an environment variable 
# as defined in the startup sequence of /bin/zsh

if [ -r /etc/zshenv ]
then
  source /etc/zshenv
fi
if [ -r $ZDOTDIR/.zshenv ]
  then
  source $ZDOTDIR/.zshenv
fi
if [ -r .zprofile ]
then
  source .zprofile
fi
if [ -r $ZDOTDIR/.zprofile ]
  then
  source $ZDOTDIR/.zprofile
fi
if [ -r /etc/zshrc ]
then
  source /etc/zshrc
fi
if [ -r $ZDOTDIR/.zshrc ]
  then
  source $ZDOTDIR/.zshrc
fi
if [ -r /etc/zshlogin ]
then
  source /etc/zlogin
fi
if [ -r $ZDOTDIR/.zlogin ]
  then
  source $ZDOTDIR/.zlogin
fi

eval echo \$$1

## -*-sh-*-
 # ==========================================================================
 # sh-Example.sh
 # 
 # Distributed as an example of Alpha's sh Scripts mode.
 #
 # Source of original file:
 # 
 # <http://www.softlab.ntua.gr/~christia/man-cgi>
 # 
 # This file demonstrates a 'command' style syntax -- toggle the sh mode
 # preference 'Navigate Blocks' to explore file marking and navigation.
 # 
 # ==========================================================================
 ##

#!/bin/sh
# Man-cgi : a Common Gateway Interface which converts the output of
#           the "man" command to HTML
#
VERSION="1.15"
#
# Author  : Panagiotis J. Christias <christia@theseas.ntua.gr>
#
# Usage   : it goes in the /cgi-bin/ directory. When called without 
#           arguments (http://www-server/cgi-bin/man-cgi) it outputs a
#           "Front Page" with a section list and query form. When called
#           with arguments, the first argument is the topic (e.g. ls)
#           and the second argument (optional) is the section to look in.
#
#           Examples:
#               http://www.ntua.gr/cgi-bin/man-cgi?ls
#               http://www.ntua.gr/cgi-bin/man-cgi?sleep+3
#
# Notice  : Man-cgi uses the following two images, you may want to get them
#           and put them in your w3 server:
#               http://www.ntua.gr/images/doty.gif
#               http://www.ntua.gr/images/pages.gif
#
# History :
#   1.15    Multiple blank lines are supressed.
#   1.14    Man-cgi now recognizes cross-references that
#           contain periods (e.g. foo.foo(3)).
#   1.13    Really fixed problems occuring in pages which used
#           multi-overstrike for emboldening (hopefully).
#   1.12    Fixed problems occuring in pages which used multi-overstrike
#           for emboldening. Now Man-cgi works any number of overstrike.
#   1.11    Fixed problem with hyphenated cross-references.
#   1.10 and earlier, no history at that time...
#
# Last update: Fri May 5 1995
#

### CONFIGURATION SECTION : change the following variables to fit your needs ###

# The HTTPD server may not pass the enviroment variables to the script.
# You should add your system path here :
PATH=/usr/gnu/bin:/bin:/usr/ucb:/usr/bin:/usr/local/bin:/usr/misc/bin
export PATH

# The same for the man path here :
MANPATH=/usr/gnu/man:/usr/local/man:/usr/X11R5/man:/usr/new/man:/usr/misc/man:/usr/man:/usr/openwin/man:/usr/lang/man
export MANPATH

# The full URL of the Man-cgi :
MANCGI='http://www.ntua.gr/cgi-bin/man-cgi'

# The URL of the two images :
DOT=http://www.ntua.gr/images/doty.gif
PAGES=http://www.ntua.gr/images/pages.gif

### END OF CONFIGURATION SECTION ###############################################

SECTION=$2
COMMAND=$1

echo "Content-type: text/html"
echo ""

if [ $# -eq 2 ] ; then
  if [ $2 = "00" ] ; then
    read a

    COMMAND=`echo $a | sed 's/command=\(.*\)&.*/\1/'`
    SECTION=`echo $a | sed 's/command=.*&section=\(.*\)
/\1/'`

    if [ $SECTION = "ANY" ] ; then
	SECTION=""
      fi;
  fi;
fi

if [ $# -ne 0 ] ; then
  cat <<END
  <TITLE>UNIX man pages : $COMMAND ($SECTION)</TITLE>
  <h4>NOTE: click <A HREF="$MANCGI?$COMMAND">here</A> if you get an empty page.</h4>
  <hr>
END
  man "$SECTION" "$COMMAND" | \
  sed \
          -e '/-$/N
{
s/\([0-9A-z][-,0-9A-z]*\)-\n\(  *\)\([0-9A-z][-,0-9A-z]*([1-9][A-z]*)\)/\1\3\
\2/
}' \
          -e '/-$/N
{
s/\([0-9A-z][-,0-9A-z]*\)-\n\(  *\)\([0-9A-z][-,0-9A-z]*([1-9][A-z]*)\)/\1\3\
\2/
}' \
          -e '/-$/N
{
s/\([0-9A-z][-,0-9A-z]*\)-\n\(  *\)\([0-9A-z][-,0-9A-z]*([1-9][A-z]*)\)/\1\3\
\2/
}' \
          -e '/-$/N
{
s/\([0-9A-z][-,0-9A-z]*\)-\n\(  *\)\([0-9A-z][-,0-9A-z]*([1-9][A-z]*)\)/\1\3\
\2/
}' \
	  -e 's/</«/g' \
	  -e 's/>/»/g' \
   \
	  -e '/^[A-Z]/s/.//g' \
	  -e 's/^[A-Z][ ,A-Z]*$/<H2>&<\/H2>/' \
   \
	  -e 's/_\(.\)/<i>\1<\/i>/g' \
	  -e 's/.\(.\)/<b>\1<\/b>/g' \
   \
          -e 's#</b><b>.##g' \
          -e 's#</b>.<b>##g' \
          -e 's#.##g' \
          -e 's#_</i<b><</b>i>##g'  \
   \
	  -e 's/<\/i><i>//g' \
	  -e 's/<\/b><b>//g' \
   \
	  -e 's/^  \([A-Z][ ,0-9A-z]*\)$/  <b>\1<\/b>/' \
	  -e 's/^   \([A-Z][ ,0-9A-z]*\)$/  <b>\1<\/b>/' \
   \
	  -e "/^   /s#\(\([0-9A-z][-.,0-9A-z]*\)(\([1-9]\)[A-z]*)\)#<A HREF=\"$MANCGI\?\2+\3\">\1</A>#g" \
	  -e "/^   /s#\(<i>\([0-9A-z][-.,0-9A-z]*\)</i>(\([1-9]\)[A-z]*)\)#<A HREF=\"$MANCGI\?\2+\3\">\1</A>#g" \
   \
	  -e "s#<b>+<\/b>#<IMG SRC=$DOT>#" \
   \
          -e 's/«/\&lt;/g' \
          -e 's/»/\&gt;/g' \
   \
          -e '1s/^/<PRE>
/' \
          -e '$s/$/
<\/PRE>
/' | \
awk '/^$/     { if(!blank) { print; blank=1 } }
     /^..*$/  { print; blank=0 }'

else
  cat <<END
  <HEAD>
  <TITLE>UNIX man pages</TITLE>
  </HEAD>
  <BODY>
  <H1><IMG SRC=$PAGES> UNIX ON-LINE Man Pages</H1>
  <hr><P>
  These are the UNIX man pages. The html versions are created on the fly
  by a <i>simple</i> shell/sed/awk script.
  <P>
  <H5>NOTICE: There are still problems with
  the man pages that are not stored in the right section. In
  this case you'll get an empty page. Follow the link at the top of the
  empty page and you'll get your man page (hopefully).</H5>
  
  Here are the intro pages of each section:
  <P>
  <OL>
  <LI><A HREF="$MANCGI?intro+1">USER COMMANDS</A>
  <LI><A HREF="$MANCGI?intro+2">SYSTEM CALLS</A>
  <LI><A HREF="$MANCGI?intro+3">C LIBRARY FUNCTIONS</A>
  <LI><A HREF="$MANCGI?intro+4">DEVICES AND NETWORK INTERFACES</A>
  <LI><A HREF="$MANCGI?intro+5">FILE FORMATS</A>
  <LI><A HREF="$MANCGI?intro+6">GAMES AND DEMOS</A>
  <LI><A HREF="$MANCGI?intro+7">ENVIRONMENTS, TABLES, AND TROFF MACROS</A>
  <LI><A HREF="$MANCGI?intro+8">MAINTENANCE COMMANDS</A>
  <LI><A HREF="$MANCGI?X+1">X WINDOW SYSTEM</A>
  </OL>
  <P><hr>
  You can also request a man page by name and (optionally) by section:
  <P>
  <FORM METHOD=POST ACTION=$MANCGI?00+00>
  Set command name :  <INPUT NAME=command SIZE=24>
  <INPUT TYPE=submit VALUE="Fetch man page">
  <P>Set Section number : <SELECT NAME=section>
  <OPTION VALUE="ANY"> ANY
  <OPTION VALUE="1" > 1
  <OPTION VALUE="2" > 2
  <OPTION VALUE="3" > 3
  <OPTION VALUE="4" > 4
  <OPTION VALUE="5" > 5
  <OPTION VALUE="6" > 6
  <OPTION VALUE="7" > 7
  <OPTION VALUE="8" > 8
  <OPTION VALUE="n" > n
  <OPTION VALUE="x" > x
  </SELECT>
  </FORM>
END
fi
cat <<END
  <hr>
  <ADDRESS>
  © 1994 <A HREF="http://www.ntua.gr/~christia/man-cgi.html">Man-cgi $VERSION</A>, Panagiotis Christias &lt;christia@theseas.ntua.gr&gt;
  </ADDRESS>
END

## -*-sh-*-
 # ==========================================================================
 # sh-Example.tcsh
 # 
 # Distributed as an example of Alpha's X Scripts mode.
 #
 # This file demonstrates a 'block' style syntax -- toggle the sh mode
 # preference 'Navigate Blocks' to explore file marking and navigation.
 # 
 # ==========================================================================
 ##

#!/usr/princeton/bin/tcsh
 # ==========================================================================
 # Corporate Policies Analysis - Exploring 30 years of family benefits
 #
 # FILE: "cps-master.csh"
 #                                          created: 09/25/1999 {10:46:22 pm}
 #                                      last update: 09/11/2001 {01:33:46 pm}
 # Description: 
 #
 # The master source file for beginning analysis of data extracted from the
 # Current Population Surveys CD-ROMs.  This source file should be run from
 # the Unix folder benefits/cps/analysis, which assumes that the data files
 # to be analyzed are contained in the folder benefits/cps/data.  To use
 # this file, type
 #
 # % source cps-master.csh
 #
 # where % indicates the Unix prompt.  
 #
 # Author: Craig Barton Upright
 # E-mail: <cupright@alumni.princeton.edu>
 #    www: <http://www.purl.org/net/cbu>
 # 
 # Copyright (c) 1999-2000  Craig Barton Upright
 # All rights reserved.
 # 
 # ==========================================================================
 ##


### Preliminaries

# This analysis requires some sharp spikes in memory requirements.
# For this reason I monitor the directory size, and keep
# intermediate data files in a scratch directory.


	unalias rm


# Making Stata "nice", which lowers its priority for CPU time.
# This keeps our friends at CIT happier.

	alias stata nice stata -q


# Creating symbolic links to scratch files.  Each data file is much too
# large to keep in a personal Unix account.  (In fact, they're so large
# that I have to compress them even in the scratch folder as soon as I can
# throughout the analysis.)  This source file assumes that the extracted
# data files are already in a scratch directory named "benefits-cps"

	mkdir   /var/scratch/benefits-cps

	rm -f    ../data-temp
	ln -s    /var/scratch/benefits-cps/  ../data-temp/

	mkdir    ../data

# Creating additional directory "output"

	mkdir ../output

	
# Removing intermediate data files.
#
# "rm" is necessary because Stata will not overwrite unless specifically
# told to do so, and (except for figures), I generally don't.

	rm -f       ../data-temp/*-1.1.dta*
	rm -f       ../data-temp/*-1.2.dta*
	rm -f       ../data-temp/*-1.3.dta*
	rm -f       ../data-temp/*-1.4.dta*
	rm -f       ../data-temp/*-1.5.dta*
	

### Analysis, part I: reading in data, transforming variables
#
# (1-0.do) "Stata-compressing" the marXX.dta data files.
# (1-1.do) Selects variables to be used in the analysis.
#	   Recodes variable responses from "_state" to create "region".
#	   Adjusts weights according to instructions in appendix Q.
#	   (This involves eliminating some observations from the 1963
#	   through 1975 data sets which were assigned negative weights.  
#	   The output file will indicate how many observations were
#	   dropped.)  The march files are then removed to save disk
#	   space.  (This is done at the very end, at which point we can 
#	   assume that the procedure worked.  This same logic continues
#	   in the procedures which follow.)
# (1-2.do) Transforms variables to determine parental status.
# (1-3.do) Transforms variables to determine occupation status.
# (1-4.do) Transforms variables to determine industry.
# (1-5.do) Creating dummy variables

	echo "Analysis, part I: reading in data, transforming variables"

	stata do cps-1-0.do > cps-1-0.out
	stata do cps-1-1.do > cps-1-1.out
	stata do cps-1-2.do > cps-1-2.out
	stata do cps-1-3.do > cps-1-3.out
	stata do cps-1-4.do > cps-1-4.out
	stata do cps-1-5.do > cps-1-5.out


# cleaning up after part I:  removing intermediate data files

	rm -f  ../data-temp/cps*-1.1*
	rm -f  ../data-temp/cps*-1.2*
	rm -f  ../data-temp/cps*-1.3*
	rm -f  ../data-temp/cps*-1.4*


### Analysis, part II: creating crosstab data files
#
# (2-1.do) Extracting, merging crosstab information, national data
# (2-2.do) Extracting, merging crosstab information, regional data
# (2-3.do) Creating new variables as specified by Erin, national data
# (2-4.do) Creating new variables as specified by Erin, regional data
# (2-5.do) Creating figures with new variables, national data
# (2-6.do) Creating figures with new variables, regional data


	echo "Analysis, part II: creating crosstab data files"

	stata do cps-2-1.do > cps-2-1.out
	stata do cps-2-2.do > cps-2-2.out
	stata do cps-2-3.do > cps-2-3.out
	stata do cps-2-4.do > cps-2-4.out
	stata do cps-2-5.do > cps-2-5.out
	stata do cps-2-6.do > cps-2-6.out

	
### Analysis, part III:  merging the new variables with Erin's data set
#
# The "hrs0100.dta.gz" file is from Erin -- it is the one in which all of 
# the new variables will be merged.  It is also rather large, so it has to 
# live in data-temp, the scratch directory.
# 
# (3-1.do) Obtaining the codebook for Erin's data set
# (3-2.do) Merging the new nariables into Erin's stripped data set
# (3-3.do) Merging the new nariables back into Erin's original data set
# (3-4.do) Adding new data, recoding count variables in original data set
# (3-5.do) Creating figures with new variables

	echo "Analysis, part III: merging the new variables"

	stata do cps-3-1.do > cps-3-1.out
	stata do cps-3-2.do > cps-3-2.out
	stata do cps-3-3.do > cps-3-3.out
	stata do cps-3-4.do > cps-3-4.out
	stata do cps-3-5.do > cps-3-5.out


# making all cps files world-readable on password protected web site
#
# Edit the .password/.ht* files to change access users and passwords.
# The Unix command "ypmatch username passwd" will give 
# encrypted passwords on this system.

	echo "making files world-readable on password protected web site"
	chmod -R 755 ../*


### Cleaning up

	mv *.out  ../output

	rm -f       ../figures/NMomAll*
	rm -f       ../figures/NWomAll*
	rm -f       ../figures/NMomWom*
	rm -f       ../figures/NParAll*

	gzip ../data/hrs0100.dta
	
	echo "current inst-logics directory size:" `du -ksd ../`


# Locating errors:  Useful if run in background

	echo "locating errors ..."
	grep 'r(' ../output/* | cat
	echo "finished looking for errors"

	
# never comment out this last line!!


	alias rm rm -i

# .
